;+
; Project     : SOHO - CDS     
;                   
; Name        : WHAT_CDHS_STUDY
;               
; Purpose     : Lists last few CDHS study IDs
;               
; Explanation : Searched CDHS data base and collects latest few
;               series IDs loaded and translates to ground study
;               names.
;               
; Use         : IDL> what_cdhs_study
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : HARDCOPY - sends list to printer
;
; Calls       : Database routines
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : OPS, commanding
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 
;               
; Modified    : 
;
; Version     : Version 1, 15-May-98
;-            
pro what_cdhs_study,hardcopy=hardcopy

dbopen,'rseries_id'
nen = db_info('entries')
dbclose,'rseries_id'

nen = nen(0)
nst = nen - 10
nend = nen + 10

text = strarr(1000)
text(0) = ' '
text(1) = '  CDHS study ID    Name             Description'
text(2) = '    Dec.  Hex
text(3) = ' '
for i=nst,nend do begin
   s = get_cdhs_series(i)
   if s.id gt 0 then begin
      get_study,s.id,s.var,ss
      dec2hex,i,out,/quiet
      text(i-nst+4) = '    '+trim(i) +'  0x0'+out+'   '+ss.obs_prog+'      '+$
                      ss.sv_desc
      print,text(i-nst)
   endif
endfor

n = where(text ne '')
text = text(n)

if keyword_set(hardcopy) then print_str,text,/hard,/quiet


end
