;+
; Project     :	SOHO - CDS
;
; Name        :	DEF_CDS_DETAIL
;
; Purpose     : Define CDS detailed plan structure
;
; Use         : DEF_CDS_DETAIL,PLAN
;
; Inputs      : None.
;
; Opt. Inputs : PLAN = plan structure definition
;
; Outputs     : PLAN = structure definition
;
; Opt. Outputs: None.
;
; Keywords    : None.
;
; Explanation : None.
;
; Calls       : None.
;
; Common      : None.
;
; Restrictions: None.
;
; Side effects: None.
;
; Category    : Planning
;
; Prev. Hist. : None.
;
; Written     :	Version 1, Zarro (ARC/GSFC) 29 January 1995
;-


pro def_cds_detail,plan,n_pointings=n_pointings

if n_elements(n_pointings) eq 0 then npoint=1 else npoint=fix(n_pointings)

plan =        { STRUCT_TYPE:'CDS-DETAIL',$
                PROG_ID: 0              ,$
		STUDY_ID: -1            ,$
                STUDYVAR: -1            ,$
                SCI_OBJ:''              ,$
                SCI_SPEC:''             ,$
                CMP_NO: -1              ,$
                OBJECT: ''              ,$
                OBJ_ID: ''              ,$
                DATE_OBS: 0.d           ,$
                DATE_END: 0.d           ,$
                ORIG_DUR:0.d            ,$
                N_RASTERS1: 1           ,$
                TIME_TAGGED: 1b         ,$
                TRACKING: 0b            ,$
                N_POINTINGS:npoint      ,$
                N_REPEAT_S: 1           ,$
                FLAG_MASTER:0           ,$
                GSET_ID: -1             ,$
                GET_RAW: 0b            }


pointings =   {PLAN_PNT_STRUC             ,$
               INS_X:0.                   ,$
               INS_Y:0.                   ,$
               ZONE_ID:0                   }

if npoint gt 0 then plan=add_tag(plan,replicate(pointings,npoint),'POINTINGS')

return & end

