;+
; Project     :	SOHO - CDS
;
; Name        :	DEF_STUDY
;
; Purpose     : define a base study structure
;
; Use         : DEF_STUDY,STUDY
;
; Inputs      : None.
;
; Opt. Inputs : None.
;
; Outputs     : STUDY = study definition
;
; Opt. Outputs: None.
;
; Keywords    : RASTERS = add a raster structure tag (CDS only)
;               AREAS   = add an area structure tag (SUMER only)
;
; Explanation : 
;
; Calls       : 
;
; Common      : None.
;
; Restrictions: None.
;
; Side effects: None.
;
; Category    : Planning
;
; Prev. Hist. : None.
;
; Written     :	Version 1, Zarro (ARC/GSFC) 31 October 1994
;-

pro def_study,study,rasters=rasters,areas=areas,inst=inst

delvarx,study
if (datatype(inst) eq 'STR') then begin
 inst=strupcase(strmid(strtrim(inst,2),0,1))
 get_instrument,inst,desc
 name=strtrim(desc.name,2)
endif else begin
 inst=which_inst()
 if inst eq 'S' then name='SUMER' else name='CDS'
endelse

if inst eq 'C' then begin
   CALL_PROCEDURE, 'def_cds_study', study, rasters=rasters
 study.sv_desc=''
endif
IF inst EQ 'S' THEN CALL_PROCEDURE, 'def_sumer_study', study, areas=areas

return & end
