;+
; Project     : SOHO - CDS     
;                   
; Name        : CHECK_SET_EVENT
;               
; Purpose     : Processes events from the CHECK_SET_MENU.
;               
; Explanation : Any events originating within the widgets realized by 
;               CHECK_SET_MENU are handled by this routine.
;               
; Use         : Only by XMANAGER
;    
; Inputs      : ev  -  the event structure
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use with CHECK_SET_MENU in EGSE sci_ana routines.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 10-Feb-94
;               
; Modified    : 
;
; Version     : Version 1, 10-Feb-94
;-            

PRO check_set_event, ev

;
;  COMMON blocks for widget id's
;
@MainWidgets.com
@CalSeq.com
@CalFits.com
@Check_Setup.com

;
;  interpret type of event
;
type = TAG_NAMES(ev, /STRUCTURE)

;
;  could have been a BUTTON
;                    ======
;
IF (type EQ 'WIDGET_BUTTON') THEN BEGIN
   WIDGET_CONTROL, ev.id, GET_VALUE=value, get_uvalue=uvalue
 
;
;  Done (ie exit) request received
; 
   IF (value EQ 'Done') THEN BEGIN
      WIDGET_CONTROL, cal_set_base, /destroy
      widget_control,check_widg,sensitive=1
   ENDIF
;
;  Recheck request received
; 
   IF (value EQ 'Recheck') THEN BEGIN
      disp_check_set
   ENDIF

ENDIF


END
