;+
; Project     : SOHO - CDS     
;                   
; Name        : CHECK_SET_MENU
;               
; Purpose     : Defines the setup check window.
;               
; Explanation : Creates the widgets which form the window within which
;               the calibration setup can be checked.
;               
; Use         : check_set_menu
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use in EGSE sci_ana programs only.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 10-Feb-94
;               
; Modified    : 
;
; Version     : Version 1, 10-Feb-94
;-            

PRO check_set_menu

;
;  COMMON blocks for widget id communication
; 
@MainWidgets.com
@CalFits.com
@GAS_Details.com
@Check_Setup.com

;
;  trap double clicks
;
if xregistered('check_set') then return

;
;  widget id's
;
setup_widg = lonarr(2)

;
;  create main base
;
cal_set_base = WIDGET_BASE(title='Calibration Sequence ID/filename Check',$
                           /FRAME, /COLUMN, xoffset=700,yoffset=250, $
                           group_leader = main_base)

;
;  and subsidiary ones
;
menu_base  = WIDGET_BASE(cal_set_base, /COLUMN)
bid = widget_base(menu_base, /row)

;
;  Done button
;
doneid = widget_button(bid,value='Done')

;
;  recheck button
;
checkid = widget_button(bid,value='Recheck')
;
;  information widgets
;
w1 = widget_base(menu_base,/row)
w11 = widget_label(w1,val='Sequence ID: ')
setup_widg(0) = widget_text(w1,xsize=55,ysize=1)

w2 = widget_base(menu_base,/row)
w22 = widget_label(w2,val='Gas ID:      ')
setup_widg(1) = widget_text(w2,xsize=55,ysize=1)



;
;  make it all appear
;
WIDGET_CONTROL, cal_set_base, /realize

;
;  do an initial check
;
disp_check_set


end

