;+
; Project     : SOHO - CDS     
;                   
; Name        : DISP_REVIEW
;               
; Purpose     : Display the statistics of the incoming packets.
;               
; Explanation : When the review packet statistics mode is switched on, this
;               procedure will gather the details of the packet id's and 
;               display them.
;               
; Use         : disp_review
;    
; Inputs      : None - all variables come in COMMON
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: Restricted to use within the EGSE science analysis programs.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : EGSE version by C D Pike, RAL, 19-Oct-93
;               
; Modified    : 
;
; Version     : Version 1, 19-Oct-93
;-            

PRO disp_review

;
;  COMMON block for communication of widget id's, flags and the variable
;  review_stats which holds all the review statistics
;
@ReviewWidgets.com

;
;  load new count into correct widget
;
widget_control,review_expa(new_rev_stat),$
               set_val=string(review_stats(new_rev_stat),format='(i5)')

end

