;+
; Project     : SOHO - CDS     
;                   
; Name        : PAUSE_REPLAY
;               
; Purpose     : Pauses the telemetry replay from a data file.
;               
; Explanation : Performs a temporary pause (as opposed to a stop) of the
;               telemetry replay from a data file.
;               
; Use         : NOT USED AT PRESENT
;    
; Inputs      : widget_base - the top level widget with which to unregister
;                             the background task
;               msg_widg    - widget id for messages
;               last_exp    - flag to indicate if last exposure of a raster
;                             has been received prior to this call
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: Only for internal use in EGSE science analysis programs.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : EM version by Arnulf, Oct-92
;
; Written     : FM version by C D Pike, RAL, 7-Oct-93
;               
; Modified    : 
;
; Version     : Version 1, 7-Oct-93
;-            

PRO pause_replay, widget_base, msg_widg, last_exp


;
;  Disable background task "workproc" 
;
XBackRegister, /UNREGISTER, "workproc", widget_base

;
;  and alert operator  
;
IF (last_exp EQ 1) THEN $
   msg = "Last exposure completed and replaying paused." + STRING(10B) + $
	     "Choose File->Save to save raster on file." + STRING(10B) + $
	     "Choose Control->Start to continue" $
ELSE $
   msg="Exposure completed and replaying paused."+$
      " Choose Control->Start to resume"

WIDGET_CONTROL, msg_widg, /append, SET_VALUE= msg

;
; Enable analysis again
;
ctrl_analysis, 1      

END
