;+
; Project     : SOHO - CDS     
;                   
; Name        : POSN_MENU
;               
; Purpose     : Defines the setup position details window.
;               
; Explanation : Creates the widgets which form the window within which
;               he calibrated source position details are entered/displayed.
;               
; Use         : posn_menu
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use in EGSE calibration programs only.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 1-Mar-94
;               
; Modified    : 
;
; Version     : Version 1, 1-Mar-94
;-            

PRO posn_menu

;
;  COMMON blocks for widget id communication
; 
@Posn_Details.com
@MainWidgets.com

;
;  trap double clicks
;
if xregistered('posn') then return



posn_exp_awidg = lonarr(2)

;
;  create main base
;
posn_base = WIDGET_BASE(title='Source position details',  /FRAME, /COLUMN,$
                       group_leader = main_base, xoffset=500)

;
;  and subsidiary ones
;
menu_base  = WIDGET_BASE(posn_base, /ROW)
info_base  = WIDGET_BASE(posn_base, /ROW)
info_abase = WIDGET_BASE(info_base, /COLUMN, /FRAME)
m1_widg       = WIDGET_BASE(menu_base, /ROW)


;
;  'Done' button to exit
;
doneid = widget_button(m1_widg, value='Done', uvalue='Done')

;
;  widgets for display of positions
;

a1  = WIDGET_BASE(info_abase, /ROW)
a11 = WIDGET_LABEL(a1, VALUE='Horizontal position:')
posn_exp_awidg(0) = WIDGET_TEXT(a1,XSIZE=12,YSIZE=1,uvalue='Hor_posn',$
                                value=string(cal_hor_posn,form='(2x,f7.2)'),$
                                /editable)


a2  = WIDGET_BASE(info_abase, /ROW)
a21 = WIDGET_LABEL(a2, VALUE='Vertical position:  ')
posn_exp_awidg(1) = WIDGET_TEXT(a2,XSIZE=12,YSIZE=1,/editable,$
                               value=string(cal_vert_posn,form='(2x,f7.2)'),$
                               uvalue='Vert_posn')


;
;  make it all appear
;
WIDGET_CONTROL, posn_base, /realize

end
