;+
; Project     : SOHO - CDS     
;                   
; Name        : PROF_EVENT
;               
; Purpose     : To service events from profile plotting widgets.   
;               
; Explanation : To service events from profile plotting widgets.   
;               
; Use         : Only by XMANAGER
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 5-Jan-94
;               
; Modified    : 
;
; Version     : Version 1, 5-Jan-94
;-            

pro prof_event,ev

;
;  Commons for widget ids
;
@VDSWidgets.com
@Profiles.com

;
;  get user value of event generated
;
widget_control,ev.id,get_uvalue=uval

;
;  act on user value
;
case strmid(uval,0,5) of

   'DONE':  begin
;
;  tidy up the display first
;
;
;  which draw widget window was last used?
;
               if last_window eq 'A' or last_window eq 'B' then begin
                  if last_window eq 'A' then begin
                     widget_control, vds_awidg, get_value=window
                     maxval = maxvala
                  endif else begin
                     widget_control, vds_bwidg, get_value=window
                     maxval = maxvalb
                  endelse
                  wset,window
;
;  put back previous area data (if used already)
;
                  if n_elements(prof_area) gt 1 then begin
                     temp = bytscl(prof_area,min=0,max=maxval)
                     tv, temp, prof_x1, prof_y1
                  endif
               endif
               widget_control,ev.top,/destroy
               plotting_prof = 0
               widget_control,vds_ana_widg,sens=1
               widget_control,vds_base,/realize
            end
   'PLEN':  begin
               widget_control, ev.id, get_val=val
               plen = val(0)/plen_fac  > 2
               widget_control, plen_widg, set_value=string(plen,form='(i4)') 
            end
   'PWID':  begin
               widget_control, ev.id, get_val=val
               pwid = val(0)
               widget_control, pwid_widg, set_value=string(pwid,form='(i4)') 
            end
   'PVERT': begin
               pvert = 1 
               plen_fac = 4
               plen = plen/plen_fac > 2
               widget_control, plen_widg, set_value=string(plen,form='(i4)') 
            end
  'PHOR': begin
               pvert = 0 
               plen_fac = 1
               plen = plen * 4
               widget_control, plen_widg, set_value=string(plen,form='(i4)') 
            end
   'GAUSS': begin
               k = strmid(uval,5,1)
               yfit = cds_gauss(pxarr,pline,coeff,k)
               widget_control,pdraw, get_val=wind
               wset,wind
               oplot,pxarr,yfit,thick=2
               x_unit = ' Central pixel: '
               text1 = string('Fitted profile  -->  Height: ',$
                               float(coeff(0)),form='(a,f7.1)')
               text2 = string(x_unit,float(coeff(1)),' Sigma: ',$
                              float(coeff(2)),form='(a,f6.1,a,f6.2)')
               if k gt 0 then begin
                  text3 = string(' Background terms: ',float(coeff(3:k+2)),$
                               format='(a,3(f7.2,2x))')
               endif else begin
                  text3 = ' '
               endelse
               widget_control,vds_msg_widg,set_val=text1+text2+text3
            end
            

      else: help,ev,/str

endcase

end
