;+
; Project     : SOHO - CDS     
;                   
; Name        : SP_DEF_MENU
;               
; Purpose     : Defines the deferred command table dump.
;               
; Explanation : A special packet with the format id = '02'x is a dump of the
;               deferred command store.  Those packets can be displayed in
;               the widget realized by this procedure.
;               
; Use         : sp_def_menu
;    
; Inputs      : None - all variables communicated by COMMON
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: Only for use in EGSE sci_ana program
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 22-Oct-93
;               
; Modified    : 
;
; Version     : Version 1, 22-Oct-93
;-            

PRO sp_def_menu

;
;  COMMON blocks for varaibles
; 
@SpecialWidgets.com
@MainWidgets.com

;
;  trap double clicks
;
if xregistered('sp_def') then return


;
;  array to hold id's of text widgets where packet info is displayed.
;
sp_def_exp = lonarr(9)

;
;  get main widget
;
sp_def_base = WIDGET_BASE(title='Deferred special packet', group=main_base, $
                          /FRAME, /COLUMN, XOFFSET=500, XSIZE=750, SPACE=1)

;
; ... and subsidiary ones
;
menu_base  = WIDGET_BASE(sp_def_base, /ROW)
info_base  = WIDGET_BASE(sp_def_base, /ROW)
info_abase = WIDGET_BASE(info_base,   /COLUMN, /FRAME)
m1_widg    = WIDGET_BASE(menu_base,   /COLUMN)

;
;  the "Done" button
;
doneid = widget_button(m1_widg, value='Done')

;
;  the change of format menu
;
XPDmenu, ['"Format" {','"Decimal"','"Hex"', '}'],m1_widg

;
;  display current chosen format
;
f1 =  widget_base(m1_widg,/row)
f11 = widget_label(f1,val='Current format: ')
if special_format eq 2 then curr_fmt = 'Hex' else curr_fmt = 'Decimal'
sp_format_def = widget_text(f1,xsize=10,ysize=1,value=curr_fmt)

;
;  general label
;
a0 = WIDGET_LABEL(info_abase, VALUE='Deferred special packet')

;
; create all the individual widgets that will hold the specific parameters
; derived from the packets
;
a1  = WIDGET_BASE(info_abase, /ROW)
a11 = WIDGET_LABEL(a1, VALUE='Store enabled/disabled flag:     ')
sp_def_exp(0) = WIDGET_TEXT(a1,XSIZE=10,YSIZE=1)


a2  = WIDGET_BASE(info_abase, /ROW)
a21 = WIDGET_LABEL(a2, VALUE='Spacecraft time (UT)             ')
sp_def_exp(1) = WIDGET_TEXT(a2,XSIZE=10,YSIZE=1)


a3  = WIDGET_BASE(info_abase, /ROW)
a31 = WIDGET_LABEL(a3, VALUE='Start of store:                  ')
sp_def_exp(2) = WIDGET_TEXT(a3,XSIZE=10,YSIZE=1)


a4  = WIDGET_BASE(info_abase, /ROW)
a41 = WIDGET_LABEL(a4, VALUE='End of store:                    ')
sp_def_exp(3) = WIDGET_TEXT(a4,XSIZE=10,YSIZE=1)

a5  = WIDGET_BASE(info_abase, /ROW)
a51 = WIDGET_LABEL(a5, VALUE='Space left in store (words):     ')
sp_def_exp(4) = WIDGET_TEXT(a5,XSIZE=10,YSIZE=1)

a6  = WIDGET_BASE(info_abase, /ROW)
a61 = WIDGET_LABEL(a6, VALUE='Number of commands in store:     ')
sp_def_exp(5) = WIDGET_TEXT(a6,XSIZE=10,YSIZE=1)

a7  = WIDGET_BASE(info_abase, /ROW)
a71 = WIDGET_LABEL(a7, VALUE='Earliest time in store:          ')
sp_def_exp(6) = WIDGET_TEXT(a7,XSIZE=10,YSIZE=1)

a8  = WIDGET_BASE(info_abase, /ROW)
a81 = WIDGET_LABEL(a8, VALUE='Latest time in store:            ')
sp_def_exp(7) = WIDGET_TEXT(a8,XSIZE=10,YSIZE=1)

;
;  this last widget will hold the 'body' of the dump
;
a9   = WIDGET_BASE(info_abase, /ROW)
a91 = WIDGET_LABEL(a9, VALUE='Contents dump:      ')
sp_def_exp(8) = WIDGET_TEXT(a9,XSIZE=40,YSIZE=50,/scroll)

;
;  realize the widget - ie create and display it
;
WIDGET_CONTROL, sp_def_base, /realize


end
