;+
; Project     : SOHO - CDS     
;                   
; Name        : SP_GEN_MENU
;               
; Purpose     : Defines the widgets used in a general table dump.
;               
; Explanation : When a display of one of the general table dumps is requested,
;               this routine defines and realizes the display widgets.
;               
; Use         : sp_gen_menu
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use in EGSE sci_ana only.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 25-Oct-93
;               
; Modified    : To include output of Study ID.  CDP 4-Nov-93
;
; Version     : Version 2, 4-Nov-93
;-            

PRO sp_gen_menu, gen_title

;
;  COMMON blocks for widget id's etc.
;
@SpecialWidgets.com
@MainWidgets.com

;
;  trap double clicks
;
if xregistered('sp_gen') then return



;
;  individual widget id's for output text widgets
;
sp_gen_exp = lonarr(5)

;
;  top level widget id
;
sp_gen_base = WIDGET_BASE(title=gen_title, group = main_base, $
                          /FRAME, /COLUMN, XOFFSET=700)

;
;  subordinate widgets
;
menu_base  = WIDGET_BASE(sp_gen_base, /ROW)
info_base  = WIDGET_BASE(sp_gen_base, /ROW)
info_abase = WIDGET_BASE(info_base, /COLUMN, /FRAME)
m1_widg = WIDGET_BASE(menu_base, /column)

;
;  creatre 'DONE'button
;
doneid = widget_button(m1_widg,value='Done')

;
;  pull-down menu for format choice
;
XPDmenu, ['"Format" {','"Decimal"','"Hex"', '}'],m1_widg

;
;  indicate current format choice
;
f1 =  widget_base(m1_widg,/column)
f11 = widget_label(f1,val='Current format: ')
if special_format eq 2 then curr_fmt = 'Hex' else curr_fmt = 'Decimal'
sp_format_def = widget_text(f1,xsize=10,ysize=1,value=curr_fmt)

;
;  widgets for display of header information
;
a0 = WIDGET_LABEL(info_abase, VALUE=gen_title)
a1  = WIDGET_BASE(info_abase, /ROW)
a11 = WIDGET_LABEL(a1, VALUE='Table index :     ')
sp_gen_exp(0) = WIDGET_TEXT(a1,XSIZE=10,YSIZE=1)


a2  = WIDGET_BASE(info_abase, /ROW)
a21 = WIDGET_LABEL(a2, VALUE='Table ID:         ')
sp_gen_exp(1) = WIDGET_TEXT(a2,XSIZE=10,YSIZE=1)


a3  = WIDGET_BASE(info_abase, /ROW)
a31 = WIDGET_LABEL(a3, VALUE='Study ID:         ')
sp_gen_exp(2) = WIDGET_TEXT(a3,XSIZE=10,YSIZE=1)

a4  = WIDGET_BASE(info_abase, /ROW)
a41 = WIDGET_LABEL(a4, VALUE='Table length:     ')
sp_gen_exp(3) = WIDGET_TEXT(a4,XSIZE=10,YSIZE=1)


;
;  .. and then the general body of the packet
;
a5  = WIDGET_BASE(info_abase, /ROW)
a51 = WIDGET_LABEL(a5, VALUE='Contents:         ')
sp_gen_exp(4) = WIDGET_TEXT(a5,XSIZE=30,YSIZE=22,/scroll)

;
;  realize (ie make appear) it all
;
WIDGET_CONTROL, sp_gen_base, /realize

end
