;+
; Project     : SOHO - CDS     
;                   
; Name        : SP_IMIFIM_EVENT
;               
; Purpose     : Processes events from SP_IMIFIM_MENU widgets.
;               
; Explanation : All events generated by the sp_imifim_menu program are 
;               processed with this routine.
;               
; Use         : Only for use by XMANAGER
;    
; Inputs      : ev - the event structure
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: Only for use within EGSE science analysis.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 30-Nov-93
;               
; Modified    : None
;
; Version     : Version 1, 30-Nov-93
;-            

PRO sp_imifim_event, ev

;
;  COMMON blocks for communication
;
@MainWidgets.com
@SpecialWidgets.com
@Packets.com
      
;
;  determine type of event that has occurred
;
type = TAG_NAMES(ev, /STRUCTURE)

;
;  if it was a button then handle accordingly
;
IF (type EQ 'WIDGET_BUTTON') THEN BEGIN
   WIDGET_CONTROL, ev.id, GET_VALUE=value

;
;  finish by destroying widget
;  
   IF (value EQ 'Done') THEN BEGIN
      WIDGET_CONTROL, sp_map_base, SENSITIVE=1
      WIDGET_CONTROL, sp_imifim_base, /destroy
      sp_request = -1
   ENDIF

;
;  switch to Decimal format
;
   IF (value EQ 'Decimal') then begin
      special_format = 1 
      widget_control,sp_format_imifim,set_value='Decimal'
   endif

;
;  switch to Hexadecimal format
;
   IF (value EQ 'Hex') then begin
      special_format = 2 
      widget_control,sp_format_imifim,set_value='Hex'
   endif


ENDIF

END


