;+
; Project     : SOHO - CDS     
;                   
; Name        : VDS_SYNTH()
;               
; Purpose     : To load synthetic VDS data into the calibration program.
;               
; Explanation : Loads output from vds_dummy into gis data storage arrays.
;               
; Use         : Only within EGSE calibration software.
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : GISData
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 12-Jan-94
;               
; Modified    : 
;
; Version     : Version 1, 12-Jan-94
;-            
function vds_synth

temp = fix(dist(1024,256))

fil = concat_dir('$CDS_PLAN_TECH','vds_dummy_image')
openr,lun,fil,/get_lun, error=err
if err eq 0 then begin
   readu,lun,temp
   free_lun,lun
endif


z = intarr(1024,1024)
z(*,384:639) = temp
return,z


end
