;+
; Project     : SOHO - CDS     
;                   
; Name        : FULL_IMG_EVENT
;               
; Purpose     : Handle widget event from the VDS_FULL procedure.
;               
; Explanation : This module is called by the IDL xmanager when an event
;               originates in the VDS_FULL program.  
;               
; Use         : Called only by XMANAGER.
;    
; Inputs      : ev - the event which has occurred.
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: Only for use with VDS_FULL.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : Original EM version by Arnulf, Oct 92
;
; Written     : FM version by C D Pike, 7-Oct-93
;               
; Modified    : 
;
; Version     : Version 1, 7-Oct-93
;-            


PRO full_img_event, ev

;
;  Determine type of event, it must have been a button
;
type = TAG_NAMES(ev, /STRUCTURE)

;
;  handle the button event
;
if (type EQ 'widget_button') then begin
  WIDGET_CONTROL, ev.id, GET_VALUE=value

;
;  the only possible event is from the "close" button
;  
   if (value EQ 'Close') then begin
      WIDGET_CONTROL, /DESTROY, ev.top
   endif

endif

end   

