;+
; Project     : SOHO - CDS     
;                   
; Name        : MON_MENU
;               
; Purpose     : Defines the widgets used in a monitor plot.
;               
; Explanation : When a monitor display of data is requested,
;               this routine defines and realizes the display widgets.
;               
; Use         : mon_menu
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use in EGSE sci_ana only.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 10-Jan-94
;               
; Modified    : To include reset and hardcopy buttons.  CDP, 1-Mar-94
;
; Version     : Version 2, 1-Mar-94
;-            

PRO mon_menu

;
;  COMMON blocks for widget id's etc.
;
@MainWidgets.com
@Monitor.com
@Base_Offsets.com


;
;  trap double clicks
;
if xregistered('mon') then return


;
;  get base widget position and size
;
tp_offsets

;
;  top level widget id
;
if v_monitor_mode then tit = 'Monitor of VDS data' 
if g_monitor_mode then tit = 'Monitor of GIS data'
if m_monitor_mode then tit = 'CDS mechanisms'


mon_base = WIDGET_BASE(title=tit, group = main_base, $
                       /FRAME, /COLUMN, $
                       xsize=mon_menu_off(2),ysize=mon_menu_off(3), $
                       xoffset=mon_menu_off(0),yoffset=mon_menu_off(1))




;
;  subordinate widgets
;
if m_monitor_mode then begin
   mon_draw  = WIDGET_DRAW(mon_base, xsize=600, ysize=800, xoffset=500)
   dummy     = WIDGET_BASE(mon_base, /row, space=40)
endif else begin
   mon_draw  = WIDGET_DRAW(mon_base, xsize=400, ysize=400, xoffset=500)
   dummy     = WIDGET_BASE(mon_base, /row, space=40)
endelse

;
;  create 'DONE' button
;
cfont="-adobe-helvetica-bold-r-normal--14-100-100-100-p-82-iso8859-1"
doneid = widget_button(dummy,value='Done', uvalue='Done', font=cfont)

;
;  create 'RESET' button
;
resetid = widget_button(dummy,value='Reset', uvalue='Reset', font=cfont)

;
;  create 'HARDCOPY' button
;
hardid = widget_button(dummy,value='Hardcopy', uvalue='Hardcopy', font=cfont)


;
;  realize (ie make appear) it all
;
WIDGET_CONTROL, mon_base, /realize

end
