;+
; Project     : SOHO - CDS     
;                   
; Name        : OPS_PLAN_MENU
;               
; Purpose     : Defines the widgets used in an OPS_PLAN listing.
;               
; Explanation : When a display of the OPS_PLAN contents is requested,
;               this routine defines and realizes the widgets.
;               
; Use         : ops_plan_menu
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use in EGSE STM program only.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 15-Nov-95
;               
; Modified    : Trap empty plan.  CDP, 24-Sep-96
;
; Version     : Version 2, 24-Sep-96
;-            

PRO ops_plan_menu

;
;  COMMON blocks for widget id's etc.
;
@MainWidgets.com
@Base_Offsets.com


;
;  trap double clicks
;
if xregistered('ops_plan') then return


;
; prepare the OPS_PLAN contents
;
file = ''
show_plan,/quiet,/keep,file=file,/now,/detail,/summ
if file eq 'Error' then begin
   flash_msg,msg_widg,'No plan file available',/append
   return
endif


;
;  get base widget position and size
;
tp_offsets

;
;  top level widget id
;
tit = 'Current Operations Plan' 


ops_plan_base = WIDGET_BASE(title=tit, group = main_base, $
                       /FRAME, /COLUMN, $
                       xsize=ops_plan_menu_off(2),ysize=ops_plan_menu_off(3), $
                       xoffset=ops_plan_menu_off(0),yoffset=ops_plan_menu_off(1))

;
;  create master button base
;
dummy = widget_base(ops_plan_base,/frame,/row)

;
;  create 'DONE' button
;
cfont="-adobe-helvetica-bold-r-normal--14-100-100-100-p-82-iso8859-1"
doneid = widget_button(dummy,value='Done', uvalue='Done', font=cfont)


;
;  create 'Read again' button
;
renewid = widget_button(dummy,value='Renew', uvalue='Renew', font=cfont)

;
;  create 'HARDCOPY' button
;
ops_plan_hc_id = widget_button(dummy,value='Hardcopy', uvalue='Hardcopy', font=cfont)


;
;  if all Ok then read the OPS_PLAN dump file
;  
mess = rd_ascii(file)

;
;  trap no plan
;
if n_elements(mess) le 1 then begin
   mess = [' ','No entries in the plan for this time period.....',' ']
endif else begin
   mess = mess(1:*)
endelse

;
;  list widget for display of contents
;
ops_plan_list_id = widget_list(ops_plan_base, value=mess, ysize=30, $
                               xsize=100, font=cfont)

;
;  realize (ie make appear) it all
;
WIDGET_CONTROL, ops_plan_base, /realize
;widget_control, ops_plan_list_id, set_list_top = p

;
;  and start it running
;
xmanager,"ops_plan",ops_plan_base

end
