;+
; Project     : SOHO - CDS     
;                   
; Name        : PHA_MENU
;               
; Purpose     : Defines the widgets used in a PHA plot.
;               
; Explanation : When a PHA display of data is requested,
;               this routine defines and realizes the display widgets.
;               
; Use         : pha_menu
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use in EGSE STM only.
;               
; Side effects: None
;               
; Category    : Telemetry, GIS
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 11-Oct-95
;               
; Modified    : 
;
; Version     : Version 1, 11-Oct-95
;-            

PRO pha_menu

;
;  COMPHA blocks for widget id's etc.
;
@MainWidgets.com
@Base_Offsets.com
@PHA_data.com


;
;  trap double clicks
;
if xregistered('pha') then return


;
;  get base widget position and size
;
tp_offsets

;
;  top level widget id
;
tit = 'GIS PHA data'

pha_base = WIDGET_BASE(title=tit, group = main_base, $
                       /FRAME, /COLUMN, $
                       xsize=pha_menu_off(2),ysize=pha_menu_off(3), $
                       xoffset=pha_menu_off(0),yoffset=pha_menu_off(1))




;
;  subordinate widgets
;
pha_draw  = WIDGET_DRAW(pha_base, xsize=400, ysize=400, xoffset=500)
dummy     = WIDGET_BASE(pha_base, /row, space=40)

;
;  create 'DONE' button
;
cfont="-adobe-helvetica-bold-r-normal--14-100-100-100-p-82-iso8859-1"
doneid = widget_button(dummy,value='Done', uvalue='Done', font=cfont)

;
;  create 'HARDCOPY' button
;
hardid = widget_button(dummy,value='Hardcopy', uvalue='Hardcopy', font=cfont)


;
;  realize (ie make appear) it all
;
WIDGET_CONTROL, pha_base, /realize

end
