;+
; Project     : SOHO - CDS     
;                   
; Name        : READ_DATA
;               
; Purpose     : Read a fixed quantity of data from a logical unit.
;               
; Explanation : A simple read from the specified unit of the amount of data
;               specified in the input variable.
;               
; Use         : read_data, unit, buffer
;    
; Inputs      : unit   - the logical unit from which to read.
;               buffer - int variable defining the quantity of data to read.
;
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: Logical unit must be defined and opened before call.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : EM version by Arnulf, Oct 92
;
; Written     : FM version by C D Pike, RAL, 11-Oct-93
;               
; Modified    : 
;
; Version     : Version 1, 11-Oct-93
;-            

FUNCTION read_data, unit, buffer

;
;  For an i/o error, return function value -1, else return 1
;
ON_IOERROR, ERR_data

;
;  read defined number of data
;
READU,unit,buffer


;
;  succes or failure returns
;
RETURN,1
ERR_data: RETURN,-1

END




