	FUNCTION RT_DCMP_COPY, vdswin, numvdswin, rawdata, data

	pos = 0

	FOR win = 0, numvdswin - 1 DO BEGIN

	   xpix = vdswin (win).datalnx
	   ypix = vdswin (win).datalny

	   data (win, 0:xpix-1, 0:ypix-1) = FIX	(rawdata, pos, xpix, ypix)

	   pos = pos + xpix * ypix

	ENDFOR

	RETURN, data

	END



	FUNCTION RT_DCMP_COPY, vdswin, numvdswin, rawdata, data

	FOR win = 0, numvdswin - 1 DO BEGIN

	   xpix = vdswin (win).datalnx
	   ypix = vdswin (win).datalny

	   FOR y = 0, ypix - 1 DO BEGIN

	      FOR x = 0, xpix - 1 DO BEGIN

	         CASE phase OF

	            0:  BEGIN

	                val = word0 OR ((word1 AND 'F'X) * 256) 

	                data (win, x, y) = val

	            END

	            1:  BEGIN

	                data (win, x, y) = word1 / 16 OR word2 * 16

	                pos = pos + 3

	                word0 = rawdata (pos)
	                word1 = rawdata (pos + 1)
	                word2 = rawdata (pos + 2)

	            END

                 ENDCASE

	         phase = (phase + 1) AND '1'X

	      ENDFOR

	   ENDFOR

	ENDFOR

	RETURN, data

	END




	FUNCTION RT_DCMP_TRUNC, vdswin, numvdswin, rawdata, data

        pos = 0L

	word0 = FIX (rawdata (pos))
	word1 = FIX (rawdata (pos + 1))
	word2 = FIX (rawdata (pos + 2))

	phase = 0

	FOR win = 0, numvdswin - 1 DO BEGIN

	   xpix = vdswin (win).lengthx
	   ypix = vdswin (win).lengthy

	   FOR y = 0, ypix - 1 DO BEGIN

	      FOR x = 0, xpix - 1 DO BEGIN

	         CASE phase OF

	            0:  BEGIN

	                val = word0 OR ((word1 AND 'F'X) * 256) 

	                data (win, x, y) = val

	            END

	            1:  BEGIN

	                data (win, x, y) = word1 / 16 OR word2 * 16

	                pos = pos + 3

	                word0 = rawdata (pos)
	                word1 = rawdata (pos + 1)
	                word2 = rawdata (pos + 2)

	            END

                 ENDCASE

	         phase = (phase + 1) AND '1'X

	      ENDFOR

	   ENDFOR

	ENDFOR

	RETURN, data

	END



	FUNCTION RT_REMOVE_BG, vdswin, numvdswin, lastwindow, data  

;
; Set lastwindow to the index of the last possible window.  We may move
; this value back if some the windows are backround windows and not data
; windows.
;

	lastwindow = numvdswin - 1

;
; Attempt to debias the data.  We can only do this if there are four backround
; windows included in the exposure.  First we will check to see if there are
; more then four windows in the exposure.
;

	IF numvdswin GT 4 THEN BEGIN

;
; Now reset all of our debias values to 0.
;

	   biasa = 0
	   biasb = 0
	   biasc = 0
	   biasd = 0

;
; Loop through each of the possible backround windows. 
;

	   FOR i = numvdswin - 1, numvdswin - 4, -1 DO BEGIN

;
; Make sure the window is a backround window
;

	      IF vdswin (i).lengthx EQ 10 AND			$ 
                 vdswin (i).lengthy EQ 10 THEN BEGIN

;
; Move lastwindow back to the window prior to this one.
;

                 lastwindow = i - 1

;
; Set xlen and ylen to the actual window data lengths.
;

	         xlen = vdswin (i).datalnx
	         ylen = vdswin (i).datalny

;
; Check which quadrant it goes with.  We will make this decission based on
; the x and y position of the first pixel in the window.  Once we figure out
; which quadrant a window is in, we will set the bias value for that quadrant
; to the minimum pixel value in the backround window.
;

	         IF vdswin (i).startx GT 511 THEN BEGIN

	            IF vdswin (i).starty GT 511 THEN BEGIN

	               biasb = MEDIAN (data (i, 0:xlen-1, 0:ylen-1))

	            ENDIF ELSE BEGIN

	               biasd = MEDIAN (data (i, 0:xlen-1, 0:ylen-1))

	            ENDELSE


	         ENDIF ELSE BEGIN

	            IF vdswin (i).starty GT 511 THEN BEGIN

	               biasa = MEDIAN (data (i, 0:xlen-1, 0:ylen-1))

	            ENDIF ELSE BEGIN

	               biasc = MEDIAN (data (i, 0:xlen-1, 0:ylen-1))

	            ENDELSE

	         ENDELSE

	      ENDIF

	   ENDFOR

;
; Now loop through all of the actual data windows and debias them.  We 
; determine which value to use to debias the window with based on the the
; position of the first pixel in the window. 
;

	   FOR i = 0, lastwindow DO BEGIN

	      IF vdswin (i).startx GT 511 THEN BEGIN

	         IF vdswin (i).starty GT 511 THEN BEGIN

	            data (i, *, *) = data (i, *, *) - biasb 

	         ENDIF ELSE BEGIN

	            data (i, *, *) = data (i, *, *) - biasd

	         ENDELSE


	      ENDIF ELSE BEGIN

	         IF vdswin (i).starty GT 511 THEN BEGIN

		     data (i, *, *) = data (i, *, *) - biasa

	         ENDIF ELSE BEGIN

	             data (i, *, *) = data (i, *, *) - biasc

	         ENDELSE

	      ENDELSE

;
; Get rid of any pixel that was accidently set to a negative value.  This will
; happen when we try and subtract the backround from pixel which we didn't
; receive any data for in the first place.
;

	      data (i, *, *) = data (i, *, *) > 0

	   ENDFOR

	ENDIF

	RETURN, data

	END



	FUNCTION RT_SCALE_IMAGE, image, FLOOR = floor

;
; Find the median value of the image
;

	mval = MEDIAN (image)

;
; Set hst to the histogram of the image.
;

	hst = HISTOGRAM (image)

;
; Set nopixel to the total number of pixels in the image.
;

	nopixel = N_ELEMENTS (image)


;
; Set goal to 98% of the number of pixels in the image.  The idea is to find
; the lowest intensity value such that 98% percent of the pixels in the 
; image have intensities less then or equal to this value.
;

	goal = nopixel * 0.80

;
; Set i and b to 0.  The variable i will hold the current intensity value
; that we are looking at and b will hold the number of pixels with intensity
; values less then or equal to i. 
;
	i = 0
	b = 0

;
; Loop to find the intensity value i such that 98% percent of pixels have
; in the image have this intensity value or less.    
;

	WHILE b LT goal DO BEGIN

	   b = b + hst (i)
	   i = i + 1

	ENDWHILE


	IF N_ELEMENTS (floor) NE 0 THEN BEGIN

	   floor = 0

	   IF N_ELEMENTS (hst) GT 1 THEN floor = 1

	   WHILE hst (floor) EQ 0 DO floor = floor + 1

	   i = i - floor

	ENDIF 

;
; Return the correct scale factor.
;

	RETURN, 25.0 / i 

	END



	PRO RTDIS, START = start

;
; Check if a start time was passed to the program.  If it was not, then
; set the start time to current time.
;

	IF NOT KEYWORD_SET (start) THEN GET_UTC, start

;
; Convert the start time to seconds.  This will allow us to only display 
; data after the start time has been traversed.
;

	sec_start = UTC2SEC (ANYTIM2UTC (start))

;
; Create an array of structures to hold VDS window coordinates.  Since the 
; maximum number of VDS windows is 10, this is as large as the array needs
; to be.
;

        vdswindow = {VDSWDW, 			$
                     startx:   FIX (0), 	$
                     starty:   FIX (0), 	$
                     lengthx:  FIX (0), 	$
                     lengthy:  FIX (0),		$
	             datalnx:  FIX (0),		$
	             datalny:  FIX (0)}

;	vdswin = REPLICATE (vdswindow, 10)
	vdswin = REPLICATE (vdswindow, 32)

;
; Create a structure to hold the data from each exposure in the raster.  
;

	exposure = {EXPREC, 			$
	            solarx:    FIX (0),		$
	            time:      BYTARR (6),	$
	            expno:     FIX (0),		$
	            slitpos:   FIX (0),		$
	            sspitch:   FIX (0),		$
	            ssyaw:     FIX (0),		$
	            solary:    FIX (0),		$
	            mirrpos:   BYTE (0),	$
	            evntstat:  BYTE (0),	$
	            evntlevl:  FIX (0),		$
	            studycnt:  FIX (0),		$
	            rastercnt: FIX (0)}

;
; Create a structure to hold line / data window associations.
;

	linedesc = {LINEDSC,			$
	            label:     "",	  	$
	            window:    FIX (0),  	$
	            offset:    FIX (0),  	$
	            width:     FIX (0),  	$
	            lamda:     FLOAT (0)}

;
; Check if there are any open windows.  If there are, then delete them.
;

;	WHILE !D.WINDOW NE -1 DO WDELETE

;
; Create a new display window.  For now, this window will be 1024 x 1024
;

	WINDOW, TITLE = 'Realtime CDS Image Display',		$
	        XSIZE = 1024,					$
	        YSIZE = 624 

;
; SET DISPLAY CONSTANTS
;
; Set the message window size top border size in pixels
;


	msg_window_size = 150
	top_border_size = 30

;
; Set the ammount border area to allow between the image and the box as as
; between boxes.
;

	border_box_x = 4
	border_box_y = 4

	border_dsp_x = 10
	border_dsp_y = 25

;
; Get the display size in pixels
;

	disp_xlen = !D.X_SIZE
	disp_ylen = !D.Y_SIZE - msg_window_size - top_border_size

;
; Set endtime to 0.  This variable will contain the estimated end time of the
; current telemetry file in seconds.
;

	endtime = 0

;
; Set the exp_complete flag to 0 (FALSE).  After we finish geting the data for
; an exposure, then we will set this flag to 1 (TRUE).  Also set the flag
; display_rdy to 0 (FALSE).  We will use this flag to triger the display of
; of science data. 
;

	exp_complete = 0
	display_rdy  = 0

;
; Set ras_hdr_rec and exp_hdr_rec to 0 (FALSE).  We will use these flags to 
; indicate when we have received a valid raster header and a valid exposure
; header.
;

	ras_hdr_rec = 0
	exp_hdr_rec = 0

;
; Set the basic raster information (raster counter and study counter) to 0.
; This will keep us from starting in the middle of a raster.
;

	rastercnt = 0
	studycnt = 0

;
; Set file to the tm file that corresponds to start.
;

	path = GET_TM_FILE (ANYTIM2UTC (start), ENDTIME = endtime)

;
; Check if we found a file.  If we didn't, then print out an error message
; and return.
;

	IF path EQ '' THEN BEGIN

	   PRINT, 'Could not find file for time: ', FORMAT = '(a, $)
	   PRINT, UTC2STR (ANYTIME2UTC (start), /ECS, /TRUNCATE)

	   RETURN

	ENDIF


        PRINT, '>>Reading file ', path

;
; Open the file.
;

	OPENR, dev, path, /GET_LUN, /NOSTDIO

;
; Reset the routine READ_IWS_PKT
;

        status = READ_IWS_PKT (dev, pkt, /reset)

;
; Set error_count to 0.
;

	error_count = 0

;
; Set count to 0.  We will use this variable to keep track of the number of 
; packets that we have read
;

	count = 0L

;
; Set exit to 0.  We will use the flag to control when we exit from the main
; processing loop. 
;

	exit = 0 

;
; Semi-Inifinite loop.  This loop will continue until we hit a read error, we
; run out of files, or we we must exit for some other reason.  Loop exit is
; controlled by the flag exit.
;

	WHILE NOT exit DO BEGIN

;
; Get a packet.
;

           status = READ_IWS_PKT (dev, pkt)

;
; Check if the packet is a housekeeping packet, if it is then trash it.
;

	   IF status EQ 2 THEN GOTO, loop_continue

;
; Check for an invalid checksum.  Again, trash the packet if we find it.
;

	   IF status EQ 1 THEN GOTO, loop_continue

;
; Check for EOF.  If s = 3 or s = 4 then we should go on to the next file.
;
	
	   IF status EQ 3 OR status EQ 4 THEN BEGIN

;
; Get the current time in UTC.	   
;

	      GET_UTC, utc

;
; Check if the current time is earlier then estimated end time of the file.
; if it is then we can not switch files.  Instead, we will wait a bit, and
; try againg.
;

	      IF UTC2SEC (utc) LT endtime THEN BEGIN

;
; Increment error_count.
;

	         error_count = error_count + 1 

;
; Wait for 5 seconds.
;

	         WAIT, 5.0
;
; Print a message telling the user what we are doing, but only if we have
; been waiting here ahwile.
;

	         IF error_count GT 6 THEN $
	            PRINT, 'Waiting for telemetry to resume...'

;
; Check if error_count is less then 12.  If it is then just go back to the
; beginning of the loop and try again.
;

	         IF error_count LT 12 THEN GOTO, loop_continue

;
; Otherwise, set exit to 1 (TRUE) to exit the loop.
;

	         exit = 1
	         GOTO, loop_continue

	      ENDIF

;
; Close the previous file.
;

	      CLOSE, dev

;
; Set file to the next tm file in sequence.
;

	      path = NEXT_TM_FILE (path, ENDTIME = endtime)

;
; Check if we were able to find another file.  If we were not able to find 
; a new tm file, then set exit to 1 (TRUE) to quit out of the loop.
;


	      IF path EQ '' THEN BEGIN

	         exit = 1
	         GOTO, loop_continue

	      ENDIF

;
; Print a message to the user telling them what file we are reading.


              PRINT, '>>Reading file ', path

;
; Open the file.
;

	      OPENR, dev, path, /NOSTDIO

;
; Reset the routine READ_IWS_PKT
;

              status = READ_IWS_PKT (dev, pkt, /reset)

;
; Go back to the beginning of the loop.
;

	      GOTO, loop_continue

	   ENDIF

;
; Check for Read Failure.  Just print an error message and quit in this case. 
;

	   IF status EQ 5 THEN BEGIN

	      PRINT, 'Error ', !ERROR, ' encountered while reading file.'
	      PRINT, !ERR_STRING

	      RETURN

	   ENDIF

;
; Reset error_count to 0.
;

	   error_count = 0

;
; Get the ID of packet that we just read
;

	   id = pkt (18)

;print, id

	   CASE id OF

	   '2'X:  BEGIN    ; VDS RASTER Header

	       PRINT, 'Found VDS raster header.'

	       ; Study ID
	       studyid =          pkt (20) 	
	       ; Data Compression Scheme
	       compscheme =       pkt (21)	
               ; Data Window ID
	       datawindowid =     BYTESWAP (FIX (pkt, 22))
	       ; Sequence ID
	       Seqid =            BYTESWAP (FIX (pkt, 24))
	       rasterlengthm =    pkt (26)
	       rasterlengths =    pkt (27)
	       ; OPS Left Position
	       opslpos =          BYTESWAP (FIX (pkt, 28)) AND 'FFF'X 
	       ; OPS Right Position
	       opsrpos =          BYTESWAP (FIX (pkt, 30)) AND 'FFF'X 
	       ; Slit Position
	       slitpos =          FIX (pkt, 32) 
	       ; Slit Number
	       slitnum =          pkt (34)	
	       ; Mirror Position
	       mirrpos =          pkt (35)	
	       ; Exposure Time
	       exptime =          BYTESWAP (FIX (pkt, 36))	
	       ; Study Counter
	       studycnt =         BYTESWAP (FIX (pkt, 38))
	       ; Raster Counter
	       rastercnt =        BYTESWAP (FIX (pkt, 40))
	       ; Data Compression Option
	       datacompopt =      BYTESWAP (FIX (pkt, 42))
	       ; Science Processor Status
	       sciprocstat =      BYTESWAP (FIX (pkt, 44))
	       ; Number of VDS Windows
	       numvdswin =        LONG (pkt (47))

               offset = 48

 	       FOR i = 0, numvdswin - 1 DO BEGIN

	          vdswin (i).startx =   BYTESWAP (FIX (pkt, offset)) 
	          vdswin (i).starty =   BYTESWAP (FIX (pkt, offset + 2))

	          lenx =  BYTESWAP (FIX (pkt, offset + 4))
	          leny =  BYTESWAP (FIX (pkt, offset + 6))

	
	          vdswin (i).lengthx =  lenx
	          vdswin (i).lengthy =  leny

	          vdswin (i).datalnx =  lenx
	          vdswin (i).datalny =  leny

	          IF compscheme EQ 8 THEN BEGIN

	             newylen = FIX ((leny + datacompopt - 1) / datacompopt)
	             vdswin (i).datalny = newylen

	          ENDIF 
	          

	          offset = offset + 8

	       ENDFOR

	       ; VDS X Binning Factor
	       vds_xbin = ISHFT (pkt (46), -4) + 1
	       ; VDS Y Binning Factor
	       vds_ybin = (pkt (46) AND '0F'X) + 1
	       ; Number of Exposures in Raster
	       totalexp = (rasterlengthm > 1) * (rasterlengths > 1)

print, 'Study Counter:         ', studycnt, FORMAT = '(A, I7)'
print, 'Raster Counter:        ', rastercnt, FORMAT = '(A, I4)'
print, 'Number of Exposures:   ', totalexp, FORMAT = '(A, I4)'
print, 'Number of VDS Windows: ', numvdswin, FORMAT = '(A, I4)'

;
; Create an array to hold the data from each exposure in the raster.
; 

	       explst = REPLICATE (exposure, totalexp)

;
; Create the arrays to hold the data from each window.  Since we are only 
; working with NIS data, there will be at most 10 windows.  
;

	       maxxwinlen = LONG (MAX (vdswin.datalnx))
	       maxywinlen = LONG (MAX (vdswin.datalny))

	       data = INTARR (numvdswin, maxxwinlen, maxywinlen)

;
; Set the flags dwinlst_ok and linelst_ok to 0 (FALSE).  If we are able to 
; get the data window list then we will set dwinlst_ok to 1 (TRUE).  If we
; are able to get the line list, then we will set linelst_ok to 1 (TRUE).
;

	       dwinlst_ok = 0
	       linelst_ok = 0

;
; Set the flag display_raster to 0 (FALSE).  If we are supposed to display
; raster images then this will be reset to 1 (TRUE).
;

	       display_raster = 0

;
; Attempt to get the database data extraction window id from the data 
; window table id returned by the CDHS
;

	       dwinid = GET_CDHS_DEXWIN (datawindowid)

;
; Attempt to get a data window list for this raster from the database.  We
; can then use the data window list, if it is available, to get a line list.
;

	       GET_DATAWIN, dwinid.id, dwinlst

;
; Check if we managed to get a data window list.  If we got the data window
; list, then see if we can get the line list for this raster.  If we can get
; the list, we will use it to create an array of structures associating
; each line with an offset into one of the data windows.
;

	       IF dwinlst.dw_id GT 0 THEN BEGIN

;
; Set dwinlst_ok to 1 (TRUE).  We have a data window list.
;

	          dwinlst_ok = 1

;
; We will need to be using the corrected version of the data extraction
; window list, so do that now.
;

;	          dwinlst = UPDATE_DEX (dwinlst)

;
; Now check to see if there is line list associated with the data window
; list for this raster.   
;

	          IF dwinlst.ll_id GT 0 THEN BEGIN

;
; Go ahead and try to get the line list.
;

	             GET_LINELIST, dwinlst.ll_id, linelst

;
; Check if we got the line list, if we did set linelst_ok to 1 (TRUE). 
;

	             IF linelst.ll_id GT 0 THEN linelst_ok = 1

	          ENDIF

	       ENDIF

if dwinlst_ok then print, "Data Window List ID: ", dwinlst.dw_id
if linelst_ok then print, "Line List ID:        ", linelst.ll_id

;
; Now see if we got the line list.  If we did we can go and try to associate
; lines with window offsets.
;
 
	       IF linelst_ok THEN BEGIN

	          nolines = dwinlst.n_lines

	          lndef = REPLICATE (linedesc, nolines)

	          x1 = vdswin.startx
	          x2 = vdswin.startx + vdswin.lengthx - 1
;	          x1 = dwinlst.wins.win_def (0)
;	          x2 = dwinlst.wins.win_def (0) + dwinlst.wins.win_def (2) - 1


	          FOR i = 0, nolines - 1 DO BEGIN

	              lndef (i).label = linelst.lines (i).linename
	              lndef (i).lamda = linelst.lines (i).wavelnth

	              window = -1
	              width = -1
	              offset = -1

	              band   = linelst.lines (i).waveband
	              center = linelst.lines (i).cen_pix


		      w  = WHERE (x1 LT center AND x2 GT center, cnt)

	              IF cnt GT 0 THEN BEGIN

	                 y  = vdswin (w).starty

	                 IF band EQ 1 THEN win = WHERE (y GT 511, cnt)

	                 IF band EQ 2 THEN win = WHERE (y LT 511, cnt) 

	                 IF cnt GT 0 THEN BEGIN

	                    window = w (win (0))
	                    offset = center - dwinlst.wins (window).win_def (0)

		            print, 'label:       ', lndef (i).label
	                    print, 'band:   ', band
		            print, 'center: ', center
		            print, 'startx: ', vdswin (window).startx
		            print, 'starty: ', vdswin (window).starty
	                    print, 'offset: ', offset

	                 ENDIF

	              ENDIF

	              lndef (i).window = window
	              lndef (i).offset = offset



	          ENDFOR

	       ENDIF

;
; Check if we to display rastered images of if we are display single
; exposures.  If we are to display rastered images, then set some values
; which we will need when go to display the rastered image.
;

	       IF linelst_ok    AND				$ 
	          totalexp GT 1 AND				$
	          slitnum NE 6  THEN BEGIN  

;
; Set the values ylen and xlen the size of each indvidual exposure to add
; to the rastered image.
;

	          ylen = MAX (vdswin.datalny)

	          xlen = 1

 	          IF slitnum EQ 4 THEN xlen = 1
	          IF slitnum EQ 5 THEN xlen = 2

	          IF compscheme EQ 8 THEN xlen = 1

;
; Calculate the size of each raster image in pixels.
;

	          disp_img_xlen = xlen * totalexp
	          disp_img_ylen = ylen 

;
; Calculate the size of the box to place around each raster image in pixels.
;

	          disp_box_xlen =  disp_img_xlen + border_box_x * 2
	          disp_box_ylen =  disp_img_ylen + border_box_y * 2

;
; Calculate the minimum amount of total display space to allocate to each
; of the raster images in pixels.
;

	          disp_spc_xlen =  disp_box_xlen + border_dsp_x * 2
	          disp_spc_ylen =  disp_box_ylen + border_dsp_y * 2

;
; Set number of images that can fit in one row and one column
;

	          no_row_img = FIX (disp_xlen / disp_spc_xlen)
	          no_col_img = FIX (disp_ylen / disp_spc_ylen)

;
; Set the maximum number of lines that can be displayed.
; 

	          max_line_disp = nolines < (no_row_img * no_col_img)
	         
;
; Set the x axis offset of the first raster in each line.
;
	         
	          img_x_offset = disp_xlen - (no_row_img * disp_spc_xlen)
	          img_x_offset = FIX (img_x_offset / 2)

;
; Create the view array to hold each individual raster image.
;

	          view = INTARR (max_line_disp, xlen * totalexp, ylen)

;
; Set the flag display_raster to 1 (TRUE).
;

	          display_raster = 1

	       ENDIF

;
; Erase the previously displayed raster (if any).
;

	       IF compscheme EQ 2 OR					$
	          compscheme EQ 8 THEN ERASE

;
; Set the exp_hdr_rec to 0 (FALSE) and ras_hdr_rec to 1 (TRUE).
;

	       exp_hdr_rec = 0
	       ras_hdr_rec = 1


	   END

	   '12'X: BEGIN    ; VDS EXPOSURE Header
;
; Get the study counter and raster counter that the exposure goes with.
; Set pkt_studycnt to the study counter and pkt_rastercnt to the raster
; counter.
;

	       pkt_studycnt =  BYTESWAP (FIX (pkt, 48))
	       pkt_rastercnt = BYTESWAP (FIX (pkt, 50))
               

;
; Check that the raster counter and study counter match their expected 
; values.  If either has changed, then flag the raster information as
; invalid.
;

	       IF pkt_studycnt NE studycnt THEN ras_hdr_rec = 0
	       IF pkt_rastercnt NE rastercnt THEN ras_hdr_rec = 0

;
; Check if a raster header has been found.  If it hasn't then lets not 
; do anything.
;

	       IF NOT ras_hdr_rec THEN GOTO, loop_continue

	       PRINT, 'Found VDS exposure header.' 

;
; Read the exposure number from the exposure header
;

               expno = BYTESWAP (FIX (pkt, 30))

	       ; Solar X Position
	       explst (expno).solarx =    BYTESWAP (FIX (pkt, 22))
	       ; Exposure Time
	       explst (expno).time =      pkt (24:29)
	       ; Exposure Number (Redundant)
	       explst (expno).expno =     expno
	       ; Slit Position
	       explst (expno).slitpos =   BYTESWAP (FIX (pkt, 36))
	       ; Sun Sensor Pitch Value
	       explst (expno).sspitch =   BYTESWAP (FIX (pkt, 38))
	       ; Sun Sensor Yaw Value
	       explst (expno).ssyaw =     BYTESWAP (FIX (pkt, 40))
	       ; Solar Y Position
	       explst (expno).solary =    BYTESWAP (FIX (pkt, 42))
	       ; Mirror Position
	       explst (expno).mirrpos =   pkt (44)
	       ; Event Status
	       explst (expno).evntstat =  pkt (45)
	       ; Event Level
	       explst (expno).evntlevl =  FIX (pkt, 46)
	       ; Study Counter
	       explst (expno).studycnt =  pkt_studycnt
	       ; Raster Counter
	       explst (expno).rastercnt = pkt_rastercnt

;
; Create the rawdata array to hold the raw, probably compressed, data from
; the exposure.  The size of this array will set so that it contain all the
; data from the exposure even if it is uncompressed.
;  


	       datasiz = ((maxxwinlen * maxywinlen) - 1L) * numvdswin
	       rawdata = BYTARR (datasiz * 2)

;
; Set the science counter to the current science packet, including the end
; of exposure flag.  Since this is the exposure header, this should be 0.   
;

	       scicnt = BYTESWAP (FIX (pkt, 20))

;
; Set exp_complete to 1 if the exposure is complete.  If the exposure is not
; complete then we will set it to 0. 
;

	       exp_complete = (scicnt AND '8000'X) GT 0

;
; Remove the end of exposure flag from the science packet counter scicnt,
; this should now only contian the number of the current science packet.
;

	       scicnt = scicnt AND '7FFF'X

;
; Copy in our first block of raw data.  Since this is the exposure header,
; the raw data should be inserted starting at element 0 in the raw data 
; array.
;

	       rawdata (0:251) = pkt (52:303)

;
; Set raw_data_sz to the ammount of raw science data in the rawdata array.
;

	       raw_data_sz = 252L

;
; Set the flag exp_hdr_rec to 1 (TRUE).
;

	       exp_hdr_rec = 1

print, 'Exposure Number:  ', expno, FORMAT = '(A, I4)'
print, 'Solar X Position: ', explst (expno).solarx, FORMAT = '(A, I6)'
print, 'Solar Y Position: ', explst (expno).solary, FORMAT = '(A, I6)'
print, 'Mirror Position:  ', explst (expno).mirrpos, FORMAT = '(A, I4)'

	   END

	   '22'X: BEGIN    ; Science Packet

;
; Get the current raster and current exposure from the packet.  We will use
; this information for sanity checks.
;

	       ; Stream Counter of Current Packet
	       strcnt = pkt (19)
	       ; Exposure Number Of Packet Data  
	       pkt_expno = BYTESWAP (FIX (pkt, 22))
	       ; Study Counter of Current Packet
	       pkt_studycnt =  BYTESWAP (FIX (pkt, 24))
	       ; Raster Counter of Current Packet
	       pkt_rastercnt = BYTESWAP (FIX (pkt, 26))

;
; Check that the raster counter and study counter match their expected 
; values.  
;

	       IF pkt_studycnt NE studycnt THEN ras_hdr_rec = 0
	       IF pkt_rastercnt NE rastercnt THEN ras_hdr_rec = 0

;
; If the raster has changed, then force the flag exp_hdr_rec to be 0 (FALSE)
; as well.
;

	       IF NOT ras_hdr_rec THEN exp_hdr_rec = 0

;
; Check if everything is OK.  If it is then the exp_hdr_rec will be set to
; 1 (TRUE) at this point.  If it is not, then lets not do anything.
;

	       IF NOT exp_hdr_rec THEN GOTO, loop_continue

;
; Check expno matches the expected exposure number.  If it does not then
; reset the flag exp_hdr_rec to 0 (FALSE) and go back to the start of the
; loop.
;

	       IF pkt_expno NE expno THEN BEGIN

	          exp_hdr_rec = 0
	          GOTO, loop_continue

	       ENDIF

;
; Set the science counter to the correct value.  We will use the science 
; counter to determine where to place the data in the rawdata array.   
;

	       scicnt = BYTESWAP (FIX (pkt, 20))
;
; Set exp_complete to 1 if the exposure is complete.  If the exposure is not
; complete then we will set it to 0. 
;

	       exp_complete = (scicnt AND '8000'X) GT 0

;
; Remove the end of exposure flag from the science packet counter scicnt,
; this should now only contian the number of the current science packet.
;

	       scicnt = scicnt AND '7FFF'X

;
; Copy the science data from the packet into the array rawdata.
;

	       datastart = LONG (scicnt - 1) * 276L + 252L
	       dataend = datastart + 275L

	       rawdata (datastart:dataend) = pkt (28:303)

;
; Reset raw_data_sz to reflect the ammount of raw science data in the 
; rawdata array.
;

	       raw_data_sz = dataend + 1

	   END

	   ELSE: BEGIN     ; Everything Else

	   END

	   ENDCASE 

;
; Check if it is time to decompress and display data.  We will only do this
; if the exp_complete flag is to TRUE (1).
;

	   IF exp_complete THEN BEGIN

print, 'Exposure Complete.
print, 'Read ', scicnt, ' packets.'

;
; Set the exp_hdr_rec flag to 0 (FALSE).
;

	      exp_hdr_rec = 0

;
; Reset exp_complete to 0 (FALSE).
;

	      exp_complete = 0

;
; Swap the byte positions of all the data in the raw data array.
;

	      PRINT, FORMAT = '(A, $)', 'Reordering Raw Data Array...'
	   
              FOR i = 0L, raw_data_sz - 2L, 2L DO BEGIN

	         tmp = rawdata (i)
	         rawdata (i) = rawdata (i+1)
	         rawdata (i+1) = tmp

	      ENDFOR

	      PRINT, ' Done.'       


;
; Decompress the data.  Each decompression scheme will be handled by a 
; seperate function.  Here we will only choose which function to use, based
; on the variable compscheme.
;

	      CASE compscheme OF

	      2:     BEGIN    ; Truncation Mode

	          PRINT, FORMAT = '(A, $)',				$ 
	                 'Decompressing data for Trunc Scheme...'

	          data (*, *, *) = RT_DCMP_TRUNC (vdswin, 		$
	                                          numvdswin, 		$
	                                          rawdata, 		$
	                                          data (*, *, *))

	          PRINT, ' Done.'

;
; Set the flag display_rdy to 1 (TRUE).  We can now go ahead and display the
; data.
;

	          display_rdy = 1

	      END


	      8:     BEGIN    ; Summing Along Slit Mode

	          PRINT, FORMAT = '(A, $)',				$ 
	                 'Decompressing data for Scheme 8'

	          data (*, *, *) = RT_DCMP_COPY  (vdswin, 		$
	                                          numvdswin, 		$
	                                          rawdata, 		$
	                                          data (*, *, *))

	          PRINT, ' Done.'

;
; Set the flag display_rdy to 1 (TRUE).  We can now go ahead and display the
; data.
;

	          display_rdy = 1

	      END

	      ELSE:  BEGIN    ; Unsupported Compression Scheme

	          PRINT, 'Compression Scheme: ',			$ 
	                  compscheme, 					$
	                  ' Is Not Supported.'

	          PRINT, 'No image will be produced from this exposure.'

	      END

	      ENDCASE

	   ENDIF

;
; Check if we ready to display data yet.  If we are, then the flag 
; display_rdy will be 1 (TRUE).
;
	   IF display_rdy THEN BEGIN

;
; Set the flag display_rdy to 0 (FALSE).
;

	      display_rdy = 0

;
; Try to remove backround counts from the data.
;

	      data (*, *, *) = RT_REMOVE_BG (vdswin, 			$
	                                     numvdswin, 		$
	                                     lastwindow, 		$
	                                     data (*, *, *)) 

	      IF NOT display_raster THEN BEGIN


	         ERASE

	         FOR win = 0, lastwindow DO BEGIN 

	             xpos = vdswin (win).startx
	             ypos = vdswin (win).starty - 200
	             
	             sf = rt_scale_image (data (win, *, *)) * .5

	             TV, (data (win, *, *) * sf) < 255, xpos, ypos 


	         ENDFOR

	      ENDIF ELSE BEGIN




;
; Check if this is the first exposure.  If it is, then go and draw boxes and
; titles for all of the display images.  
;


	         IF expno EQ 0 THEN BEGIN

;
; Set up the coordinates of the box
;

	           x_box_corners = [0, disp_box_xlen, disp_box_xlen, 0, 0]
	           y_box_corners = [0, 0, disp_box_ylen, disp_box_ylen, 0]

;
; Draw a box for each raster image (line).
;

	           FOR ln = 0, max_line_disp - 1 DO BEGIN

;
; Set the x positioin of the box.
;
	              xpos = disp_spc_xlen * (ln MOD no_row_img) + 	$
	                     img_x_offset + 				$
	                     border_dsp_x

;
; Set the y position of the box.
;

	              ypos = !D.Y_SIZE -				$
	                     FIX (ln / no_row_img) * disp_spc_ylen -	$
	                     top_border_size -				$
	                     border_box_y * 2 -				$
	                     border_dsp_y -				$
	                     disp_img_ylen
;
; Draw the box.
;

	              PLOTS, x_box_corners + xpos,			$ 
	                     y_box_corners + ypos,			$
	                     /DEVICE

;
; Make a title for the box.
; 

	               boxtitle = STRTRIM (lndef (ln).label, 2)

;
; Set the x and y positions for the title, these will be based on the x
; and y positions of the box.
;

	               xpos = xpos + FIX (disp_box_xlen / 2)
	               ypos = ypos - FIX (border_dsp_y * .66)

;
; Plot the tittle.
;

	               XYOUTS, xpos,					$
	                       ypos, 					$
	                       boxtitle,				$
	                       ALIGNMENT = 0.5,				$
	                       /DEVICE

	           ENDFOR


	         END
	

	         FOR ln = 0, max_line_disp - 1 DO BEGIN

	            window = lndef (ln).window
	            offset = lndef (ln).offset - 1 

	            lstart = offset - FIX ((xlen + 1) / 2) + 1
	            lend   = offset + FIX (xlen / 2)  

	            vstart = (totalexp - expno - 1) * xlen
	            vend   = vstart + xlen - 1


	            IF window NE -1 THEN BEGIN

	               xpos = disp_spc_xlen * (ln MOD no_row_img) +	$ 
                              img_x_offset + 				$
	                      border_box_x +				$
	                      border_dsp_x

	               ypos = !D.Y_SIZE -				$
	                      FIX (ln / no_row_img) * disp_spc_ylen -	$
	                      top_border_size -				$
	                      border_box_y -				$
	                      border_dsp_y -				$
	                      disp_img_ylen

	               view (ln, vstart:vend, *) = 			$
	                    data (window, lstart:lend, *)

	               floor = 1

	               sf = rt_scale_image (view (ln, vstart:*, *), 	$
	                                    FLOOR = floor)

	               TV, (((view (ln, *, *) - floor) > 0) * sf) < 255 , $
	                   xpos, ypos

	            ENDIF

	         ENDFOR

	      ENDELSE

	   ENDIF

loop_continue:

	ENDWHILE


	RETURN

	END

