;+
; Project     : SOHO - CDS     
;                   
; Name        : SETTAB()
;               
; Purpose     : Sets up table for quasi-log decompression scheme.   
;               
; Explanation : 
;               
; Use         : 
;    
; Inputs      : 
;               
; Opt. Inputs : 
;               
; Outputs     : 
;               
; Opt. Outputs: 
;               
; Keywords    : 
;
; Calls       :
;               
; Restrictions: 
;               
; Side effects: 
;               
; Category    : 
;               
; Prev. Hist. :
;
; Written     : M K Carter, RAL, Oct-93
;               
; Modified    : 
;
; Version     : Version 1, 22-Oct-93
;-            

FUNCTION settab, mantissa_bits, exponent_bits


  table = INTARR(256)

  tabpos = 0

  FOR m = 0, 2^mantissa_bits-1 DO BEGIN
    
;   calculate value of leading bit followed by zeroes

    lead = ISHFT ( ISHFT ( 1L, m-1 ), exponent_bits )

    FOR e = 0L, 2L^exponent_bits-1L DO BEGIN

;     add on mantissa followed by zeroes

      startval = lead + ISHFT ( e, (m-1)>0 )

;     add on mantissa followed by ones

      endval   = lead + ISHFT ( e+1, (m-1)>0 ) -1

      table(tabpos) = (startval+endval)/2
      tabpos = tabpos + 1      

    ENDFOR

  ENDFOR

  RETURN, table

END
