;+
; Project     : SOHO - CDS     
;                   
; Name        : SP_HEALTH_EVENT
;               
; Purpose     : Handle events from widgets in SP_HEALTH_MENU.
;               
; Explanation : Any events generated within the widgets defined in
;               SP_HEALTH_MENU are dealt with by this routine.
;               
; Use         : Only for use with XMANAGER.
;    
; Inputs      : ev - the event structure.
;               
; Opt. Inputs : None
;               
; Outputs     : None			
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: Only for use in EGSE sci_ana program.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 25-Oct-93
;               
; Modified    : To see new 'Done' button. CDP, 28-Oct-93
;               Add hardcopy button.  CDP, 27-Jan-95
;
; Version     : Version 3, 27-Jan-95
;-            

PRO sp_health_event, ev

;
;  COMMON blocks for widget id's etc.
;
@MainWidgets.com
@SpecialWidgets.com
@Packets.com
@Base_Offsets.com

      
;
;  determine type of event
;
type = TAG_NAMES(ev, /STRUCTURE)

;
;  should only have been a button
;
IF (type EQ 'WIDGET_BUTTON') THEN BEGIN
   WIDGET_CONTROL, ev.id, GET_VALUE=value
 
;
;  ... requesting exit with 'Done' button
; 
   if (value EQ 'Done') then begin
      widget_control,sp_health_base, tlb_get_offset=boff
      widget_control,sp_health_base, tlb_get_size = bsize
      sp_health_off = [boff,bsize]
      tp_offsets, /write
      WIDGET_CONTROL, sp_health_base, /destroy
      sp_request = -1
   endif

;
;  Hardcopy
; 
   IF (value EQ 'Hardcopy') then begin
      widget_control, sp_health_base,/hourglass 
      get_utc,utc
      widget_control, health_hc_id, set_val=strmid(anytim2cal(utc,f=1),0,15)
      spawn,'xwd -name "Health special packet" '+$
         ' | xpr  -gray 3 -width 4 -height 6 -header "Health special packet"'+$
         ' | lpr'
      widget_control, health_hc_id,set_val='Hardcopy'
   ENDIF

;
;  or a change to decimal output format
;
   if (value EQ 'Decimal') then begin
      special_format = 1 
      widget_control,sp_format_health,set_value='Decimal'
   endif

;
;  .. or a change to hexadecimal
;
   if (value EQ 'Hex') then begin
      special_format = 2 
      widget_control,sp_format_health,set_value='Hex'
   endif

endif

end
