;+
; Project     : SOHO - CDS     
;                   
; Name        : STM_STAT_EVENT
;               
; Purpose     : Processes events from the STM_STAT_MENU.
;               
; Explanation : Any events originating within the widgets realized by 
;               STM_STATUS_MENU are handled by this routine.
;               
; Use         : Only by XMANAGER
;    
; Inputs      : ev  -  the event structure
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use with GAS_MENU in EGSE calibration routines.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 1-Aug-94
;               
; Modified    : 
;
; Version     : Version 1, 1-Aug-94
;-            

PRO stm_stat_event, ev

;
;  COMMON blocks for widget id's
;
@MainWidgets.com
@Status.com
      
;
;  interpret type of event
;
type = TAG_NAMES(ev, /STRUCTURE)

;
;  might have been a button
;
if (type EQ 'WIDGET_BUTTON') THEN BEGIN
   WIDGET_CONTROL, ev.id, GET_UVALUE=value
 
;
;  Done (ie exit) request received
; 
   IF (value EQ 'Done') THEN BEGIN
      WIDGET_CONTROL, status_base, /destroy
   ENDIF

endif

end
