;+
; Project     : SOHO - CDS     
;                   
; Name        : UPDATE_EXPINFO
;               
; Purpose     : Update exposure info displayed for VDS or GIS.
;               
; Explanation : 
;               
; Use         : Update_ExpInfo, ExpHdr, RasterHdr, widg 
;    
; Inputs      : ExpHdr    - Exposure header structure
;               RasterHdr - The raster header structure
;               widg      - Array with widget id's 
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use with EGSE sci_ana routines.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : EM version by Arnulf, Oct-93
;
; Written     : FM version by C D Pike, RAL, 26-Oct-93
;               
; Modified    : To update information displayed, CDP, 2-Nov-93
;               For revised display format, CDP, 8-mar-94
;
; Version     : version 3, 8-Mar-94
;-            

PRO Update_ExpInfo, ExpHdr, RasterHdr, widg 

;
;  write exposure info to the widgets.
;

WIDGET_CONTROL, widg(0), SET_VALUE=STRING(Exphdr.ExposureNumber)
;
;  format the exposure start time
;
fmt_cdhs_time, ExpHdr, date, time
WIDGET_CONTROL, widg(1), SET_VALUE=time
;
;  the integration time
;
WIDGET_CONTROL, widg(2), $
   SET_VALUE=STRING(float(RasterHdr.Scihead.ExposureTime)/10.0,form='(f6.1)')

;
;  pointing info
;
WIDGET_CONTROL, widg(3), SET_VALUE=fmt_vect([Exphdr.OPSLCoordinate,$
                                             Exphdr.OPSRCoordinate],delim='/')

END
