;+
; Project     : SOHO - CDS     
;                   
; Name        : VDS_FULL
;               
; Purpose     : Defines the science analyser full VDS window. 
;               
; Explanation : 
;               
; Use         : vds_full, base, image 
;    
; Inputs      : base  -  widget id of the group leader under which this
;                        widget is created.
;
;               image -  the 2-d VDS image array.
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: For use within EGSE sci_ana programs.
;               
; Side effects: None
;               
; Category    : EGSE
;               
; Prev. Hist. : EM version by Arnulf, Oct-92
;
; Written     : FM version by C D Pike, RAL, 27-Oct-93
;               
; Modified    : 
;
; Version     : Version 1, 27-Oct-93
;-            

PRO vds_full, base, image 

;
;  create top-level widget
;
full_base = WIDGET_BASE(title='VDS full image',  /FRAME, /COLUMN)

;
;  button for 'Done' (ie exit)
;
doneid = widget_button(full_base, value='Done')

;
;  create draw widget large enough to contain full VDS image
;
win_widg = widget_draw(full_base, XSIZE=1024, YSIZE=1024)

;
;  realize the widget - ie make it appear
;
WIDGET_CONTROL, full_base, /REALIZE

;
;  display the image within it
;
plot_vds, win_widg, image, /SIZE 

;
;  let XMANAGER control it
;
XMANAGER, "full_img",full_base, GROUP_LEADER=base

end

