	PRO HLINE, LUN
;+
; Project     :	SOHO - CDS
;
; Name        :	HLINE
;
; Purpose     :	Write the HTML format code for a horizontal line to a file. 
;
; Explanation :	This procedure creates the HTML format codes which are used
;		to display a horizontal line in the form of gif image.  In
;		order for line to display properly, the gif image must be
;		the same directory as the file with HTML code that uses it.
;
; Use         :	HLINE, LUN
;
; Inputs      :	LUN	The logical unit number of the file to write the
;			HTML format codes to.  The file must have been 
;			opened for writeing by the calling procedure.
;
; Opt. Inputs : None.
;
; Outputs     :	None.
;
; Opt. Outputs:	None.	
;
; Keywords    :	None.
;
; Calls       :	None.
;
; Common      :	None.
;
; Restrictions:	The procedure is only designed to be called by the procedure 
;		MK_CDROM_WEB.PRO
;
; Side effects:	Writes HTML format codes to the file referenced by the logical
;		unit number passed to the procedure as the parameter LUN.
;
; Category    :	Planning, Database.
;
; Prev. Hist. :	none.
;
; Written     :	Ron Yurow, GSFC, 24 October 1997
;
; Modified    :	Version 1, Ron Yurow, GSFC, 24 October 1997
;
; Version     :	Version 1, 24 October 1997
;-
;

	PRINTF, LUN, '<center> <img src = "line.jpg"> </center>'

	RETURN

	END

	