;+
; Project     : SOHO - CDS     
;                   
; Name        : CDS_TEMP_MENU
;               
; Purpose     : Define the CDS temperature plotting main window. 
;               
; Explanation : Defines all the widgets used in the CDS temperature plotting
;               routine.
;               
; Use         : Called from CDS_TEMP
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Telemetry
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 27-Oct-95
;               
; Modified    : Add reset time range button.  CDP, 19-Dec-95
;
; Version     : Version 2, 19-Dec-95
;-            
 
PRO cds_temp_menu


;
;  main COMMON variables
;
@cds_temperature.com

;
;  setup main font
;
font = "-adobe-helvetica-bold-r-normal--14-100-100-100-p-82-iso8859-1"
;
;  define main widget
;
main_base = WIDGET_BASE (TITLE='CDS Temperature Monitor', /FRAME, $
                         /COLUMN, xoff=300, yoff=100)
menu1_base = WIDGET_BASE (main_base, /ROW, space=25)

;
;  create the exit "DONE" button
;
doneid = widget_button(menu1_base, value='EXIT', uvalue='Done',font=font)


;
;  select a parameter
;
dummy = widget_button(menu1_base,value='Select temperature sensor(s)',$
                      uval='PARMS',/no_rel,font=font)


;
;  help
;
dummy = widget_button(menu1_base,value='Help',uval='HELP',$
                      /no_rel,font=font)

;
;  switch hardcopy on/off
;
hardonoff = widget_button(menu1_base,value='Hard copy OFF',uval='HARD',$
                      /no_rel,font=font)
hard = 0

;
; make message window widget
;
dummy = WIDGET_BASE(main_base, /column, /FRAME, YOFFSET=-100)
dummy_widg = WIDGET_LABEL(dummy, VALUE=' Messages   : ')
msg_widg = WIDGET_TEXT(dummy, XSIZE = 80, YSIZE=15, /scroll)

;
;  further actions
;
menu2_base = WIDGET_BASE (main_base, /ROW, space=40)

;
;  replot
;
dummy = widget_button(menu2_base,value='Replot data',$
                      uval='REPLOT',/no_rel,font=font)

;
;  Select time range graphically
;
dummy = widget_button(menu2_base,value='Select time range using cursor',$
                      uval='TIME',/no_rel,font=font)


;
;  reset time range
;
dummy = widget_button(menu2_base,value='Reset time limits',$
                      uval='RESET',/no_rel,font=font)



;
;  realise the menu widget to make it all happen
;
WIDGET_CONTROL, /REALIZE , main_base

WIDGET_CONTROL, main_base, /CLEAR_EVENT


;
;  set it all going
;
XMANAGER, 'cds_temp', main_base
   

END

