;+
; Project     : SOHO - CDS     
;                   
; Name        : EMON_SENSITIVE
;               
; Purpose     : To (de)sensitize EMON control buttons.
;               
; Explanation : Uses widget_control to (de)sensitize EMON buttons to help
;               stop user-finger trouble while data are being read.
;               
; Use         : emon_sensitive, on_off
;    
; Inputs      : on_off  -  either 0 or 1 to desensitize/sensitize the buttons
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : EMON.COM
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Telemetry
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 10-Oct-94
;               
; Modified    : 
;
; Version     : Version 1, 10-Oct-94
;-            

pro emon_sensitive, on_off

;
;  common for widget ids
;
@emon.com

;
;  switch the top row of buttons
;
widget_control, menu_base, sens=on_off

;
;  switch read and plot buttons on the lower panel
;
widget_control, plotid, sens=on_off
widget_control, readid, sens=on_off


end
