;+
; Project     : SOHO - CDS     
;                   
; Name        : KILL_ENGAB
;               
; Purpose     : Stops ingestion of engineering A/B data.
;               
; Explanation : Unregisters the procedure INPUT_ENGAB which stops the
;               input of engineering A and B packets from the telemetry
;               files.
;               
; Use         : Only within EMON package
;    
; Inputs      : widget_base  -  top level widget with which it is associated.
;               msg_widg     -  message widget
;
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Telemetry
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 30-Sep-94
;               
; Modified    : 
;
; Version     : Version 1, 30-Sep-94
;-            

pro kill_engab, widget_base, msg_widg

;
;  nothing to do but unregister INPUT_ENGAB
;
xbackregister, /unregister, 'input_engab', widget_base

;
;  inform
;
flash_msg, msg_widg, /append, 'Data taking has STOPPED.'


end
