;+
; Project     :	SOHO - CDS
;
; Name        :	UNMAP()
;
; Purpose     :	Converts from unsigned values to signed values
;
; Category    :	EGSE
;
; Explanation :	Called from decompression routines.
;
; Syntax      :	Result = UNMAP(VALUE)
;
; Examples    :	
;
; Inputs      :	VALUE	= Integer*2 value to be unmapped.
;
; Opt. Inputs :	None.
;
; Outputs     :	The result of the function is the unmapped value.
;
; Opt. Outputs:	None.
;
; Keywords    :	None.
;
; Calls       :	None.
;
; Common      :	None.
;
; Restrictions:	None.
;
; Side effects:	None.
;
; Prev. Hist. :	Original by M K Carter, RAL
;
; History     :	EGSE version by C D Pike, RAL 7-Oct-93
;
; Contact     :	CDPIKE
;-
;
FUNCTION unmap, value

  ; converts from unsigned values to signed values

  IF (value AND 1) EQ 0 THEN BEGIN

;   +ve number

    RETURN, ISHFT(value,-1)

  ENDIF ELSE BEGIN

;  -ve number

    RETURN, -1-ISHFT(value,-1)

  ENDELSE

END
