;+
; Project     : SOHO - CDS
;
; Name        : GIS_ARM
;
; Purpose     : To return arm and pixel positions to
;               help understand ghost locations 
;
; Explanation : Takes the LUT for an observation and produces
;               an array of arm locations for use in ghost_buster.
;
; Use         : 
;
;                   
; Inputs      : 
;              
; Opt. Inputs : 
;
; Outputs     :
;
; Opt. Outputs: None.
;
; Keywords    :
;
; Calls       :
;
; Common      : None.
;
; Restrictions: None.
;
; Side effects: None.
;
; Still To Do :
;
; Category    : Calibration, GIS, Intensity.
;
; Prev. Hist. : None.
;
; Written     : Carl Foley, caf@mssl.ucl.ac.uk  August 2003
;
; Modified    :
;
; Version     : 1.
;
;-
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function gis_arm,qlds,det
;
gset=qlds.header.gset_id
get_gset,gset,luto
pi=3.1415927
lut=luto.lut_par
stop=lut(det,2)/10.
start=lut(det,1)/10.
	length=(stop^2)-(start^2)
	unit=length/2048.0
	pixel=indgen(2048)
	t1=(pixel*unit)+start^2
	arm=sqrt(t1)
	out=[[pixel],[arm]]
	return,out
end
