;MYLUT.PRO
;Program which writes a LUT just like Alec's!
;
print, "Using Alec's ?? algorithm"
;
zplnref=460.0
numpixel=2048.0
pi=3.1415927
;
;	Set up variables
;
percent=	50
stop=      	4.0
start=     	2.0
k =          	2.0
Zpln=    	460
dphi=     	230
numbits=   	8
xgain= 		1.0
ygain=   	1.0
zgain=   	1.0
;swap phi to radians
rphi=(dphi*pi)/180.0
;
;	Set up array of LUT
;
chksum=long(0)
table=0
table=intarr(256,256)
;
;	Calculate the other parameters
;
hilim=percent/200.0
lolim=1.0-hilim
tend=k*((stop*2*pi)^2)
tbeg=k*((start*2*pi)^2)
pixsiz=(tend-tbeg)/numpixel
adcsteps=2^numbits
;
;	Now start calculation loop
;
For ix=0,255 do begin
	if (( (ix/50) *50) eq ix) then print, "ix= ",ix
	For iy=0,255 do begin
		iz=zpln-(ix+iy)
		if (iz ge 0) AND (iz lt 256) then begin
;
;			adjust gains:
;
			fx=float(ix)/xgain
			fy=float(iy)/ygain
			fz=float(iz)/zgain
			Sum=(fx+fy+fz)/zplnref
			fx=fx/sum
			fy=fy/sum
			fz=fz/sum
;
;			Two Dimensional plane: clockwise spiral
;
			xx=(fz-fy)/(sqrt(2.0))
			yy=((2.0*fx)-(fy+fz))/(sqrt(6.0))
;
;			Polar coords:
;
			r=sqrt((xx^2)+(yy^2))
			if (yy eq 0) then theta=(pi/2.0) else begin 
				theta=atan(xx,yy)
				if (theta lt 0) then theta=theta+(2*pi)
			endelse		;end yy=0 check
;
;			Count number of spiral arms
;
			rrevs=((r/k)-(theta+rphi))/(2.0*pi)
			nrevs=fix(rrevs)
			fracrev=float(rrevs-nrevs)
;
;			Check whether we're on the right arm!
;
			If (fracrev le hilim) OR (fracrev ge lolim) then begin
				If (fracrev ge lolim) then nrevs=nrevs+1.0
				theta=theta+(nrevs*2*pi)
				tt=((theta^2)*k)
				If (tt ge tbeg) AND (tt le tend) then begin
					tt = tt-tbeg
					pixno=fix((tt/pixsiz)+0.5)
					table(ix,iy)=pixno
					chksum=chksum+pixno
					;;;if (chksum ge 65536) then chksum=chksum - 65536
				Endif	;end of tt loop
			endif 	;end of throw away data loop
		endif	;end of iz=0 loop
	Endfor	;end of iy loop
Endfor	;end of ix loop
tvscl,table
print,'chksum = ',chksum
print,format='("in hex = ",z8)',chksum
finish:
end

