;A Dave Walton IDL program - an IDL version of ALLSINGN, the
;anode data acquisition and display program.

;----------------------- COLOURBAR ------------------------
pro colourbar
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON ZOOM, x0, y0, nx, ny, col, xbot2, ybot2, xmid2, ymid2, xtop2, ytop2, $
         boxmode2, px, py, prevboxflag2, xlo2, ylo2, xhi2, yhi2, area2,$
         histrectflag2

xbot5=xbot2+.5 & ybot5=ybot2+.5
xmid5=xbot5+65 & ymid5=ybot5+65
xtop5=xmid5+ximsize2+1 & ytop5=ymid5+yimsize2+1
       
;Clear previous colour bar
bar1=bytarr(59, 286) & tv, bar1, xtop2+10, ymid2

maxinten4=max(im4)+1L
mininten4=min(im4)
bar1=lonarr(20, 236) ;Assume 236 colour table, as used in MS-Windows
for i2=0, 235 do bar1(*, i2)=(maxinten4-mininten4)*i2/236L
tvscl, bar1, xtop2+11, ymid2+1, /device
plot, [0, 1], [mininten4-0.5, maxinten4-0.5], xstyle=1, ystyle=1, /nodata,$
      position=[xtop5+10,ymid5,  xtop5+31, ymid5+237], /device, /noerase,$
      xticklen=0.0, xminor=-1, xticks=1, xtickname=replicate(' ', 2),$
      yticklen=0.0, ytickname=replicate(' ', 10)
axis, yaxis=1, ystyle=1, ticklen=-0.2
if phd1flag2 eq 0 then xyouts, xtop2+11, ymid2+242, 'INTEN', /device $
  else xyouts, xtop2+11, ymid2+242, ' PHD ', /device

end


;---------------------------  INTENCALC ------------------------------
pro intencalc
;Calculates im4 for an intensity plot
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
 		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2

case wholefileflag2 of
  1: begin ;Whole file
         if zoomdiv2 eq 16384 then im4=long(ximsize2)*ishft(yarr2, -6) $
                                       +ishft(xarr2, -6) $
          else im4=long(ximsize2)*fix(256L*(yarr2-ycurroffset2)/zoomdiv2) $
                   +fix(256L*(xarr2-xcurroffset2)/zoomdiv2)
         im4=histogram(im4, min=0L, max=long(ximsize2)*yimsize2-1L)
         im4=reform(im4, ximsize2, yimsize2, /overwrite)
     end

  0: begin ;Some of file
         if zoomdiv2 eq 16384 then $
           im4=long(ximsize2)*ishft(yarr2(wheredisp4), -6) $
               +ishft(xarr2(wheredisp4), -6) $
          else im4=long(ximsize2)* $
                    fix(256L*(yarr2(wheredisp4)-ycurroffset2)/zoomdiv2) $
                   +fix(256L*(xarr2(wheredisp4)-xcurroffset2)/zoomdiv2)
         im4=histogram(im4, min=0L, max=long(ximsize2)*yimsize2-1L)
         im4=reform(im4, ximsize2, yimsize2, /overwrite)
     end

  -1: begin ;No counts
       im4=lonarr(ximsize2, yimsize2) ;Empty arrays
     end
endcase
end


;---------------------------  PHDCALC ------------------------------
pro phdcalc
;Calculates im4 for a PHD plot
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2

case wholefileflag2 of
  1: begin ;Whole file
         im4=lonarr(ximsize2, yimsize2) ;Clear the array
         if zoomdiv2 eq 16384 then $
           im4(ishft(xarr2, -6), ishft(yarr2, -6))=long(sum1) $
          else im4(fix(256L*(xarr2-xcurroffset2)/zoomdiv2), $
                   fix(256L*(yarr2-ycurroffset2)/zoomdiv2))=long(sum1)
     end

  0: begin ;Some of file
         im4=lonarr(ximsize2, yimsize2) ;Clear array
         if zoomdiv2 eq 16384 then $
           im4(ishft(xarr2(wheredisp4), -6), ishft(yarr2(wheredisp4), -6))= $
           long(sum1(wheredisp4)) $
          else im4(fix(256L*(xarr2(wheredisp4)-xcurroffset2)/zoomdiv2), $
                   fix(256L*(yarr2(wheredisp4)-ycurroffset2)/zoomdiv2)) $
                   =long(sum1(wheredisp4))
     end

  -1: begin ;No counts
       im4=lonarr(ximsize2, yimsize2) ;Empty arrays
     end
endcase
end


;---------------------------  CALCALL ------------------------------
;Calculates image and histograms, with previously defined pulse-ht window,
;zoom, (x,y) mask (for histogram rectangle) and intensity or pulse-ht mode.
pro calcall
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON ZOOM, x0, y0, nx, ny, col, xbot2, ybot2, xmid2, ymid2, xtop2, ytop2, $
         boxmode2, px, py, prevboxflag2, xlo2, ylo2, xhi2, yhi2, area2,$
         histrectflag2
                
xbot5=xbot2+.5 & ybot5=ybot2+.5
xmid5=xbot5+65 & ymid5=ybot5+65
xtop5=xmid5+ximsize2+1 & ytop5=ymid5+yimsize2+1
       
xhistx5=(lindgen(ximsize2)*zoomdiv2+256L*xcurroffset2)/16384.0
yhisty5=(lindgen(yimsize2)*zoomdiv2+256L*ycurroffset2)/16384.0


;First, create sumhist4
;This next block of nested 'if's speeds up the processing if it's a simple
;case
if (xmasklo2 eq 0) and (xmaskhi2 eq 32767) and $
   (ymasklo2 eq 0) and (ymaskhi2 eq 32767) then $
  wholefileflag2=1 $
 else begin
  wheredisp4=where((xarr2 ge xmasklo2) and (xarr2 le xmaskhi2) and $
                   (yarr2 ge ymasklo2) and (yarr2 le ymaskhi2))
  if wheredisp4(0) eq -1 then wholefileflag2=-1 $ ;No counts
   else begin
    sz=size(wheredisp4)
    if sz(1) eq nfile4 then wholefileflag2=1 else wholefileflag2=0
  endelse
endelse

case wholefileflag2 of
  1: begin ;Whole file
       nwind4=nfile4
       sumhist4=histogram(sum1, min=0, max=63)
     end
  0: begin ;Some of file
       nwind4=sz(1)
       sumhist4=histogram(sum1(wheredisp4), min=0, max=63)
     end
  -1: begin ;No counts
       nwind4=0L
       sumhist4=lonarr(64)
     end
endcase

;Next, form image array
if wholefileflag2 ne -1 then begin ;If some counts
  ;Check for counts outside sum window
  if sumlim1(0) eq 0 then sumlocountflag2=0 $
    else begin
      if total(sumhist4(0:(sumlim1(0)-1))) eq 0 then sumlocountflag2=0 $
        else sumlocountflag2=1
  endelse
  if sumlim1(1) eq 63 then sumhicountflag2=0 $
    else begin
      if total(sumhist4((sumlim1(1)+1):63)) eq 0 then sumhicountflag2=0 $
        else sumhicountflag2=1
  endelse
  if (sumlocountflag2 eq 0) and (sumhicountflag2 eq 0) then $
    wholesumhistflag2=1 $
      else wholesumhistflag2=0

  if (xmasklo2 eq 0) and (xmaskhi2 eq 32767) and $
     (ymasklo2 eq 0) and (ymaskhi2 eq 32767) and $
     (wholesumhistflag2 eq 1) then $
    wholefileflag2=1 $
   else begin
    sumlo1=sumlim1(0) & sumhi1=sumlim1(1)
    wheredisp4=where((xarr2 ge xmasklo2) and (xarr2 le xmaskhi2) and $
                     (yarr2 ge ymasklo2) and (yarr2 le ymaskhi2) and $
                     (sum1 ge sumlo1) and (sum1 le sumhi1))
    if wheredisp4(0) eq -1 then wholefileflag2=-1 $ ;No counts
     else begin
      sz=size(wheredisp4)
      if sz(1) eq nfile4 then wholefileflag2=1 else wholefileflag2=0
    endelse
  endelse
endif

case wholefileflag2 of
  1: begin ;Whole file
       wheredisp4=[0]  ;Dummy value to prevent undefined variable error
       ndisp4=nfile4
       if zoomdiv2 eq 16384 then begin
         yhist4=histogram(ishft(yarr2, -6), min=0, max=yimsize2-1)
         xhist4=histogram(ishft(xarr2, -6), min=0, max=ximsize2-1)
        endif else begin
         yhist4=histogram(fix(256L*(yarr2-ycurroffset2)/zoomdiv2),$
                          min=0, max=yimsize2-1)
         xhist4=histogram(fix(256L*(xarr2-xcurroffset2)/zoomdiv2),$
                          min=0, max=ximsize2-1)
       endelse
     end

  0: begin ;Some of file
       ndisp4=sz(1)
       if zoomdiv2 eq 16384 then begin
         yhist4=histogram(ishft(yarr2(wheredisp4), -6), min=0, max=yimsize2-1)
         xhist4=histogram(ishft(xarr2(wheredisp4), -6), min=0, max=ximsize2-1)
        endif else begin
         yhist4= $
           histogram(fix(256L*(yarr2(wheredisp4)-ycurroffset2)/zoomdiv2),$
                          min=0, max=yimsize2-1)
         xhist4= $
           histogram(fix(256L*(xarr2(wheredisp4)-xcurroffset2)/zoomdiv2),$
                          min=0, max=ximsize2-1)
       endelse
     end

  -1: begin ;No counts
       ndisp4=0L
       yhist4=lonarr(yimsize2) & xhist4=lonarr(ximsize2)
     end
endcase

if phd1flag2 eq 0 then intencalc else phdcalc
plotall
end


;-------------------- PLOTALL -----------------------------
;Plots im4, xhist4 vs. xhistx5, yhist4 vs. yhisty5, sumhist4
pro plotall
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON ZOOM, x0, y0, nx, ny, col, xbot2, ybot2, xmid2, ymid2, xtop2, ytop2, $
         boxmode2, px, py, prevboxflag2, xlo2, ylo2, xhi2, yhi2, area2,$
         histrectflag2
                
xbot5=xbot2+.5 & ybot5=ybot2+.5
xmid5=xbot5+65 & ymid5=ybot5+65
xtop5=xmid5+ximsize2+1 & ytop5=ymid5+yimsize2+1
    
device, set_graphics=old  ;Disable xor for plotting
erase  ;Kill previous image
prevboxflag2=0

;Plot yhist
maxyhist4=max(yhist4)
if maxyhist4 eq 0L then maxyhist4=1L
xlim5=[0.0, 1.15*maxyhist4]
yhistylim5=[yhisty5(0)-zoomdiv2/32768.0, yhisty5(yimsize2-1)+zoomdiv2/32768.0]
if zoomdiv2 eq 16384 then $
  plot, xlim5,yhistylim5, xstyle=1,ystyle=1,$
        position=[xbot5,ymid5, xmid5,ytop5],$
        /device, yticklen=-0.1, xminor=1, yminor=2, xticks=1,$
        xtickv=[0, maxyhist4], yticks=4, /noerase, psym=10,$
        ytickv=[0, 128, 256, 384, 511], /nodata,$
        xtickname=replicate(' ', 2) $
 else begin
  plot, xlim5,yhistylim5, xstyle=1,ystyle=1,$
        position=[xbot5,ymid5, xmid5,ytop5],$
        /device, yticklen=-0.1, xminor=1, xticks=1,$
        xtickv=[0, maxyhist4], /noerase,$
        /nodata,$
        xtickname=replicate(' ', 2)
  ;Plot box to resize co-ords for plots below
  plot, xlim5, [-1, yimsize2], xstyle=1, ystyle=1, /device,$
        position=[xbot5,ymid5, xmid5,ytop5],$
        ticklen=0.0, xtickname=replicate(' ', 10),$
        ytickname=replicate(' ', 10), /noerase, /nodata
endelse
for i2=0, yimsize2-1 do plots, [0, yhist4(i2)], [i2, i2] ;white
axis, xaxis=1, xminor=1, xticks=1, xtickv=[0, maxyhist4]

;Plot xhist
maxxhist4=max(xhist4)
if maxxhist4 eq 0L then maxxhist4=1L
ylim5=[0.0, 1.15*maxxhist4]
xhistxlim5=[xhistx5(0)-zoomdiv2/32768.0, xhistx5(ximsize2-1)+zoomdiv2/32768.0]
if zoomdiv2 eq 16384 then $
  plot, xhistxlim5,ylim5, xstyle=1,ystyle=1,$
        position=[xmid5,ybot5, xtop5,ymid5], /device, /nodata,$
        xticklen=-0.1, xminor=2, yminor=1, xticks=4, yticks=1,$
        /noerase, xtickv=[0, 128, 256, 384, 511],$
        ytickv=[0, maxxhist4], ytickname=replicate(' ', 2) $
 else begin
  plot, xhistxlim5,ylim5, xstyle=1,ystyle=1,$
        position=[xmid5,ybot5, xtop5,ymid5], /device, /nodata,$
        xticklen=-0.1, yminor=1, yticks=1,$
        /noerase,$
        ytickv=[0, maxxhist4], ytickname=replicate(' ', 2)
  ;Plot box to resize co-ords for plots below
  plot, [-1, ximsize2], ylim5, xstyle=1, ystyle=1, /device,$
        position=[xmid5,ybot5, xtop5,ymid5],$
        ticklen=0.0, xtickname=replicate(' ', 10),$
        ytickname=replicate(' ', 10), /noerase, /nodata
endelse
for i2=0, ximsize2-1 do plots, [i2, i2], [0, xhist4(i2)] ;white
axis, yaxis=1, yminor=1, yticks=1, ytickv=[0, maxxhist4]

;Plot sum histogram
xlim2=[-1, 64]
maxsumhist4=max(sumhist4)
if maxsumhist4 eq 0L then maxsumhist4=1L
ylim5=[0.0, 1.15*maxsumhist4]
plot, xlim2,ylim5, xstyle=9, ystyle=9,$
      position=[xbot5,ybot5, xmid5, ymid5],$ 
      /device, ticklen=-0.1, xminor=2, yminor=1, xticks=1, yticks=1,$
      xtickv=[0, 32], ytickv=[0, maxsumhist4], /nodata, /noerase
for i1=0, sumlim1(0)-1 do plots, [i1, i1], [0, sumhist4(i1)], color=col/2
for i1=sumlim1(0), sumlim1(1) do plots, [i1, i1], [0, sumhist4(i1)] ;white
for i1=sumlim1(1)+1, 63 do plots, [i1, i1], [0, sumhist4(i1)], color=col/2
plots, [0, 63], [0, 0] ;Re-white the bottom axis      

;Put box around image
plot, xhistxlim5, yhistylim5, /noerase, xstyle=1, ystyle=1, /nodata,$
      position=[xmid5, ymid5, xtop5, ytop5], /device,$
      ;xminor=2, yminor=2, xticks=4, yticks=4,$
      ;xtickv=[0, 128, 256, 384, 511],$
      ticklen=.0, xtickname=replicate(' ', 10), ytickname=replicate(' ', 10)
      ;ytickv=[0, 128, 256, 384, 511],$
if zoomdiv2 eq 16384 then begin
  axis, xaxis=1, xminor=2, xticks=4, ticklen=-0.02, xstyle=1,$
      xtickv=[0, 128, 256, 384, 511],$
      xtickname=[' ', ' ', ' ', ' ', ' ']
  axis, yaxis=1, yminor=2, yticks=4, ticklen=-0.02, ystyle=1,$
      ytickv=[0, 128, 256, 384, 511],$
      ytickname=[' ', ' ', ' ', ' ', ' '] 
 endif else begin
  axis, xaxis=1, ticklen=-0.02, xtickname=replicate(' ', 10), xstyle=1
  axis, yaxis=1, ticklen=-0.02, ytickname=replicate(' ', 10), ystyle=1
endelse

;Put image on screen
tvscl, im4, xmid5+1, ymid5+1, /device

;Print count numbers
xyouts, xtop2+11, ytop2, 'FileCts', /device, charsize=1.3
plots, [xtop2+11,xtop2+60], [ytop2-1,ytop2-1], /device ;Underline
xyouts, xtop2+11, ytop2-15, string(format='(I7)', nfile4), /device,$
         charsize=1.3

xyouts, xtop2+11, ytop2-40, 'WindCts', /device, charsize=1.3
plots, [xtop2+11, xtop2+60], [ytop2-41, ytop2-41], /device ;Underline
xyouts, xtop2+11, ytop2-55, string(format='(I7)', nwind4), /device,$
         charsize=1.3

xyouts, xtop2+11, ytop2-80, 'DispCts', /device, charsize=1.3
plots, [xtop2+11, xtop2+60], [ytop2-81, ytop2-81], /device ;Underline
xyouts, xtop2+11, ytop2-95, string(format='(I7)', ndisp4), /device,$
         charsize=1.3
       
;Plot colour bar
colourbar
xyouts, xmid2+110, ytop2+15, flnam, /device

device, get_graphics=old, set_graphics=6   ;Set xor
end


;---------------------------  ZOOMCALC -------------------------------
pro zoomcalc, ximmin2, ximmax2, yimmin2, yimmax2
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4

xarrmean4=long(ximmin2+ximmax2+1)/2L*zoomdiv2/256L+xcurroffset2
yarrmean4=long(yimmin2+yimmax2+1)/2L*zoomdiv2/256L+ycurroffset2

ximrange2=ximmax2-ximmin2+1 & yimrange2=yimmax2-yimmin2+1
if (ximrange2) ge (yimrange2) then $
    zoomdiv2=fix(long(ximrange2)*zoomdiv2/512L+.5) $
  else zoomdiv2=fix(long(yimrange2)*zoomdiv2/512L+.5)
if zoomdiv2 eq 0 then zoomdiv2=1

xmasklo2=fix(xarrmean4-zoomdiv2)
xmaskhi2=fix(xarrmean4+zoomdiv2-1L)
if xmasklo2 lt 0 then begin
  xmasklo2=0 & xmaskhi2=fix(2L*zoomdiv2-1L)
endif
if xmaskhi2 le 0 then begin ;le 0 due to integer overflow beyond 32767
  xmasklo2=fix(32768L-2L*zoomdiv2) & xmaskhi2=32767
endif

ymasklo2=fix(yarrmean4-zoomdiv2)
ymaskhi2=fix(yarrmean4+zoomdiv2-1L)
if ymasklo2 lt 0 then begin
  ymasklo2=0 & ymaskhi2=fix(2L*zoomdiv2-1L)
endif
if ymaskhi2 le 0 then begin ;le 0 due to integer overflow beyond 32767
  ymasklo2=fix(32768L-2L*zoomdiv2) & ymaskhi2=32767
endif

xcurroffset2=xmasklo2 & ycurroffset2=ymasklo2
calcall
end

;--------------------- HISTHCOPY ---------------------
pro histhcopy, filetype
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON LIM2, lim2, hist4, hist5, statstring, binoffset5

histflnam=pickfile(/write, filter=('*.' + filetype))
if histflnam ne '' then begin
  set_plot, filetype    ;Post-script, PCL or HPGL
  device, filename=histflnam

  case histident2 of
    1: titstring=flnam+'  X axis histogram'
    2: titstring=flnam+'  Y axis histogram'
    3: titstring=flnam+'  Sum histogram'
  endcase
  plot, hist5, hist4,$
      xstyle=1, xrange=[hist5(0)-.5, hist5(lim2(1)-lim2(0))+.5],$
      ticklen=-0.02, psym=10,$
      title=titstring, subtitle=statstring
  plots, [hist5(0)-.5, hist5(0)+.5], [hist4(0), hist4(0)] ;Finish the plot
  plots, [hist5(lim2(1)-lim2(0))-.5, hist5(lim2(1)-lim2(0))+.5],$
         [hist4(lim2(1)-lim2(0)), hist4(lim2(1)-lim2(0))]
  device, /close
if !version.os eq 'windows' then set_plot, 'win' $  
  else set_plot, 'x' ;In case previously set to something else
endif

end


;---------------------------  HISTZOOM_EVENT -------------------------------
pro histzoom_event, event
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON HIST_LABELS, hist_title_label, hist_val_label
COMMON LIM2, lim2, hist4, hist5, statstring, binoffset5
COMMON LABELS, title_label, val_label, base, butt_quit, butt_load, butt_acq, butt_unzoom, butt_phd,$
               butt_sel, butt_rect, butt_hard, butt_view, butt_col, draw
COMMON XVAL, writeflag2, butt_array

WIDGET_CONTROL, event.id, GET_UVALUE = eventval

; Perform actions based on the User Value of the event:
CASE eventval OF
   'RETURN': begin
    widget_control, event.top, /destroy

    WIDGET_CONTROL, butt_quit, /sensitive
    WIDGET_CONTROL, butt_load, /sensitive
    WIDGET_CONTROL, butt_col, /sensitive
    if !version.os eq 'windows' then WIDGET_CONTROL, butt_acq, /sensitive
    WIDGET_CONTROL, butt_unzoom, /sensitive
    WIDGET_CONTROL, butt_phd, /sensitive
    WIDGET_CONTROL, butt_sel, /sensitive
    WIDGET_CONTROL, butt_rect, /sensitive
    WIDGET_CONTROL, butt_hard, /sensitive
    WIDGET_CONTROL, butt_view, /sensitive
    WIDGET_CONTROL, butt_array, /sensitive
    WIDGET_CONTROL, draw, /sensitive

   end

   'DRAW_WIN_EVENT': BEGIN
     cursor, x5, y5, /nowait ;Gives x,y in data co-ords
     x2=fix(x5)
     if (x2 ge 0) and (x2 le (lim2(1)-lim2(0))) then begin
       WIDGET_CONTROL, val_label, $
       SET_VALUE=STRING([hist5(x2)-binoffset5, hist4(x2)],$
         format='("(", F6.2, ")", I)')
     endif
   end

   'PCL': histhcopy, eventval
   'ps': histhcopy, eventval
   'HP': histhcopy, eventval
ENDCASE
end


;---------------------------  HISTZOOM -------------------------------
pro histzoom, min2, max2, GROUP=GROUP
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON HIST_LABELS, hist_title_label, hist_val_label
COMMON LIM2, lim2, hist4, hist5, statstring, binoffset5
COMMON LABELS, title_label, val_label, base, butt_quit, butt_load, butt_acq, butt_unzoom, butt_phd,$
               butt_sel, butt_rect, butt_hard, butt_view, butt_col, draw
COMMON XVAL, writeflag2, butt_array

;Prevent crashes
WIDGET_CONTROL, butt_quit, sensitive=0
WIDGET_CONTROL, butt_load, sensitive=0
WIDGET_CONTROL, butt_col, sensitive=0
if !version.os eq 'windows' then WIDGET_CONTROL, butt_acq, sensitive=0
WIDGET_CONTROL, butt_unzoom, sensitive=0
WIDGET_CONTROL, butt_phd, sensitive=0
WIDGET_CONTROL, butt_sel, sensitive=0
WIDGET_CONTROL, butt_rect, sensitive=0
WIDGET_CONTROL, butt_hard, sensitive=0
WIDGET_CONTROL, butt_view, sensitive=0
WIDGET_CONTROL, butt_array, sensitive=0
WIDGET_CONTROL, draw, sensitive=0

case histident2 of
  1: begin
       titstring= 'X Histogram'
       hist4=xhist4(min2:max2)
       binoffset5=zoomdiv2/32768.0
       hist5=xhistx5(min2:max2)+binoffset5
     end
  2: begin
       titstring= 'Y Histogram'
       hist4=yhist4(min2:max2)
       binoffset5=zoomdiv2/32768.0
       hist5=yhisty5(min2:max2)+binoffset5
     end
  3: begin
       titstring= 'Sum Histogram'
       hist4=sumhist4(min2:max2)
       hist5=findgen(max2+1)
       binoffset5=.5
       hist5=hist5(min2:max2)+binoffset5
     end
endcase

;First, calculate stats
sum5=total(hist5*hist4)
sum_of_squares5=total(hist5*hist5*hist4)
counts5=total(hist4)
caseval4=long(counts5) & if caseval4 gt 2 then caseval4=3
case caseval4 of ;Avoids div by 0 depending on number of counts
  0: begin
       mean5=0.0 & stddev5=0.0 & stderr5=0.0
     end
  1: begin
       mean5=sum5 & stddev5=0.0 & stderr5=0.0
     end
  2: begin
       mean5=sum5/counts5
       sum_of_squares_diff5=sum_of_squares5-sum5*sum5/counts5
       if sum_of_squares_diff5 lt 0.0 then stddev5=0 $
         else stddev5=sqrt(sum_of_squares_diff5/(counts5-1.0))
       stderr5=0.0
     end
  3: begin
       mean5=sum5/counts5
       sum_of_squares_diff5=sum_of_squares5-sum5*sum5/counts5
       if sum_of_squares_diff5 lt 0.0 then stddev5=0 $
         else stddev5=sqrt(sum_of_squares_diff5/(counts5-1.0))
       stderr5=stddev5/sqrt(counts5-2.0)
     end
endcase

lim2=[min2, max2]
; A top-level base widget
; will be created.  The size is left unspecified until the draw widget
; is created:

hist_base = WIDGET_BASE(TITLE = titstring, /COLUMN)
  butt_disp=widget_base(hist_base, /ROW)
    butt=widget_base(butt_disp, /COLUMN)
    ; The 'RETURN' button:
    butt_return = WIDGET_BUTTON(butt, $
                UVALUE = 'RETURN', $
                VALUE = 'RETURN')

    ; The 'Hardcopy' button:
    hist_butt_hard = WIDGET_BUTTON(butt, $
                  VALUE = 'Hardcopy', /MENU)
      pcl_opt= WIDGET_BUTTON(hist_butt_hard, VALUE='PCL file', UVALUE='PCL')
      ps_opt= WIDGET_BUTTON(hist_butt_hard, VALUE='PS file', UVALUE='ps')
      hp_opt= WIDGET_BUTTON(hist_butt_hard, VALUE='HPGL file', UVALUE='HP')

    ; Create the labels that will display the current x and y
    ; coordinates, leaving the value blank for now:

  ; A widget called 'draw' is created:
  hist_draw = WIDGET_DRAW(butt_disp, $
        /FRAME, $
        /MOTION_EVENTS, $               ;generate LOTS of events
        /button_events, $
        UVALUE = 'DRAW_WIN_EVENT', $
        RETAIN = 2, $                   ;make sure window redraws when covered
        XSIZE = 500, $
        YSIZE = 500)

hist_title_label = WIDGET_LABEL(hist_base, /FRAME, $
                VALUE=' Ch                Cts')

hist_val_label = WIDGET_LABEL(hist_base, /FRAME, $
                VALUE='')

; Realize the widgets:
WIDGET_CONTROL, hist_base, /REALIZE

; Get the window number from the draw widget.  This can only be done
; after the widget has been realized:
WIDGET_CONTROL, hist_draw, GET_VALUE=win_num2
WSET, win_num2
device, set_graphics=old ;Disable xor for plotting
plot, hist4,$
      xstyle=1, ticklen=.0, yticklen=-.02, xtickname=replicate(' ', 10),$
      xrange=[-.5, max2-min2+.5], psym=10, title=''
plots, [-.5, .5], [hist4(0), hist4(0)] ;Finish the plot
plots, [max2-min2-.5, max2-min2+.5],$
        [hist4(max2-min2), hist4(max2-min2)]
axis, xaxis=0, xstyle=1, xticklen=-.02,$
      xrange=[hist5(0)-zoomdiv2/32768.0, hist5(max2-min2)+zoomdiv2/32768.0]
axis, xaxis=1, xstyle=1, xtickname=replicate(' ', 10), xticklen=-.02,$
      xrange=[hist5(0)-zoomdiv2/32768.0, hist5(max2-min2)+zoomdiv2/32768.0]
ctstring=strcompress(string(counts5, format='(I6)'))
meanstring=strcompress(string(mean5, format='(f6.2)'))
stdevstring=strcompress(string(stddev5, format='(f6.2)'))
sterrstring=strcompress(string(stderr5, format='(f6.2)'))
statstring='Cts= ' + ctstring + '   Mean= ' + meanstring $
            + '   StDev= ' + stdevstring $
            + '   StErr= ' + sterrstring
xyouts, 10, 480, statstring, /device, charsize=1.3
device, get_graphics=old, set_graphics=6   ;Set xor

; Hand off control of the widget to the XMANAGER:
XMANAGER, "histzoom", hist_base, GROUP_LEADER=GROUP

end


;---------------------------- HCOPY ---------------------------------
pro hcopy, filetype

;tvlct, r, g, b, /get  ;Read screen colour table
image=tvrd()
image=max(image)-image ;B/W reverse
imflnam=pickfile(/write, filter=('*.' + filetype))
if imflnam ne '' then begin
  set_plot, filetype, /Copy ;PS or PCL   Copy should copy color table
  device, filename=imflnam, bits_per_pixel=8
  ;tvlct, r, g, b  ;Load screen colour table to ps file
  tv, image
  device, /close
if !version.os eq 'windows' then set_plot, 'win' $  
  else set_plot, 'x' ;In case previously set to something else
endif
end


;-------------------------- PHD_SEL ---------------------------------
pro phd_sel
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON LABELS, title_label, val_label, base, butt_quit, butt_load, butt_acq, butt_unzoom, butt_phd,$
               butt_sel, butt_rect, butt_hard, butt_view, butt_col, draw

window, 1, xsize=640, ysize=640,$
        title='PHD Select. Use left mouse key to choose limits'
device, set_graphics=old  ;Disable xor for plotting
i2=indgen(64) & i5=i2+.5
plot, i5, sumhist4,$
      xstyle=1, xrange=[0, 64], ticklen=-0.02, psym=10
plots, [0, 1], [sumhist4(0), sumhist4(0)] ;Finish the plot
plots, [63, 64], [sumhist4(63), sumhist4(63)]
for i1=sumlim1(0), sumlim1(1) do begin
  imin5=i1 & imax5=imin5+1.0
  polyfill, [imin5, imax5, imax5, imin5], [0, 0, sumhist4(i1), sumhist4(i1)]
endfor
device, get_graphics=old, set_graphics=6   ;Set xor

WIDGET_CONTROL, title_label, SET_VALUE=' Sum       Cts'
button=0
while button ne 1 do begin ;Get 1st channel
  cursor, x, y, /change  ;Wait for a button change or move, get  (x, y)
  x2=fix(x)
  button=!err
  if (x2 ge 0) and (x2 le 63) then WIDGET_CONTROL, val_label, $
     SET_VALUE=STRING([x2, sumhist4(x2)],$
     format='("(", I3, ")", I)')
endwhile
oplot, [x2+.5], [y], psym=-1
sum11=byte(x2)

while button ne 0 do begin ;Wait for button release
  cursor, x, y, /change  ;Wait for a button change or move, get  (x, y)
  button=!err
endwhile

while button ne 1 do begin ;Get 2nd channel
  cursor, x, y, /change  ;Wait for a button change or move, get  (x, y)
  x2=fix(x)
  button=!err
  if (x2 ge 0) and (x2 le 63) then WIDGET_CONTROL, val_label, $
     SET_VALUE=STRING([x2, sumhist4(x2)],$
     format='("(", I3, ")", I)')
endwhile
oplot, [x2+.5], [y], psym=-1
sum21=byte(x2)
sumlim1(0)=min([sum11, sum21]) & sumlim1(1)=max([sum11, sum21])

wdelete
end


;----------------------- READ_RAW1 -------------------------
PRO read_raw1
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON XVAL, writeflag2, butt_array

;Read in data from .wsz file, convert to x,y and plot
       
fileflag2=0
       
       read_dfl
         xcombine4=64L*xfullscale4 ;64 scales it into integer
         ycombine4=64L*yfullscale4
         xcombine5=64.0*xfullscale4*ch0gain5 ;64 scales it into integer
         ycombine5=64.0*yfullscale4*ch1gain5
         xoffset5=float(xoffset4) & yoffset5=float(yoffset4)
     root_two5=sqrt(2.0)
     root_six5=sqrt(6.0)
       
       stream=1
       openr, stream, flnam
       stats=fstat(stream)
       nfile4=(stats.size-512L)/8L
       xarr2=intarr(nfile4) & yarr2=intarr(nfile4) & sum1=bytarr(nfile4)
       dummy=bytarr(512)
       nblocks2=fix(nfile4/1024L)
       nleft2=fix(nfile4-1024L*nblocks2)
       readu, stream, dummy
       dummy=0b ;Reclaim the memory

       ;Set up variables to read 1024 events
       wszarr1=bytarr(8, 1024) & nread4=1024L

     for iblock2=0, nblocks2 do begin
       event4=1024L*iblock2
       if iblock2 eq nblocks2 then begin
         wszarr1=bytarr(8, nleft2) & nread4=long(nleft2)
       endif
       readu, stream, wszarr1
       ;----------------- Calculate x, y, phd ------------
   case viewflag2 of  
     0: begin
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=long(wszarr1(0,*))+wszarr1(1,*)+wszarr1(2,*)
           xarr2(event4:(event4+nread4-1L))= $
                           fix(xcombine4*wszarr1(0,*)/sum4-xoffset4)
           yarr2(event4:(event4+nread4-1L))= $
                           fix(ycombine4*wszarr1(1,*)/sum4-yoffset4)
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         sum5=ch0gain5*wszarr1(0,*)+ch1gain5*wszarr1(1,*) $
         +ch2gain5*wszarr1(2,*)
         ;Form position coord list.
         xarr2(event4:(event4+nread4-1L))= $
                               fix(xcombine5*wszarr1(0,*)/sum5-xoffset5)
         yarr2(event4:(event4+nread4-1L))= $
                               fix(ycombine5*wszarr1(1,*)/sum5-yoffset5)
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
     end

     1: begin
         xcombine5=64.0*xfullscale4/root_two5 ;64 scales to 32767
         ycombine5=64.0*yfullscale4/root_six5
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=long(wszarr1(0,*))+wszarr1(1,*)+wszarr1(2,*)
           xarr2(event4:(event4+nread4-1L))= $
             fix(xcombine5*(long(wszarr1(2,*))-wszarr1(0,*)) $
                 /sum4-xoffset4+16384.5)
           yarr2(event4:(event4+nread4-1L))= $
            fix(ycombine5*(long(wszarr1(1,*))+wszarr1(1,*) $
                           -wszarr1(0,*)-wszarr1(2,*)) $
                /sum4-yoffset4+16384.5)
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         arr05=ch0gain5*wszarr1(0,*)
         arr15=ch1gain5*wszarr1(1,*)
         arr25=ch2gain5*wszarr1(2,*)
         sum5=arr05+arr15+arr25
         ;Form position coord list.
         xarr2(event4:(event4+nread4-1L))= $
             fix(xcombine5*(arr25-arr05)/sum5-xoffset5+16384.5)
         yarr2(event4:(event4+nread4-1L))= $
            fix(ycombine5*(2.0*arr15-arr05-arr25) $
                /sum5-yoffset5+16384.5)
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
     end

     2: begin
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=long(wszarr1(0,*))+wszarr1(1,*)+wszarr1(2,*)
           xarr5=(long(wszarr1(2,*))-wszarr1(0,*))/root_two5/sum4
           yarr5=(long(wszarr1(1,*))+wszarr1(1,*)-wszarr1(0,*)-wszarr1(2,*)) $
                 /root_six5/sum4
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         arr05=ch0gain5*wszarr1(0,*)
         arr15=ch1gain5*wszarr1(1,*)
         arr25=ch2gain5*wszarr1(2,*)
         sum5=arr05+arr15+arr25
           xarr5=(arr25-arr05)/sum5/root_two5
           yarr5=(2.0*arr15-arr05-arr25)/sum5/root_six5
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
         xarr2(event4:(event4+nread4-1L))= $
           fix(sqrt(xarr5*xarr5+yarr5*yarr5)*xcombine4-xoffset4) ;scale to 32767
         rad2deg5=180.0/!pi
         theta5=rad2deg5*atan(xarr5, yarr5)
         whereless4=where(theta5 lt 0.0)
         if whereless4(0) ne -1 then $
           theta5(whereless4)=theta5(whereless4)+360.0
         yarr2(event4:(event4+nread4-1L))= fix(theta5*64.0) ;scale to 360
                                                               ;screen pix
           
     end

     3: begin
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=long(wszarr1(0,*))+wszarr1(1,*)+wszarr1(2,*)
           xarr5=460.0*(long(wszarr1(2,*))-wszarr1(0,*))/root_two5/sum4
           yarr5=460.0*(long(wszarr1(1,*))+wszarr1(1,*)-wszarr1(0,*)-wszarr1(2,*)) $
                 /root_six5/sum4
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         arr05=ch0gain5*wszarr1(0,*)
         arr15=ch1gain5*wszarr1(1,*)
         arr25=ch2gain5*wszarr1(2,*)
         sum5=arr05+arr15+arr25
           xarr5=460.0*(arr25-arr05)/sum5/root_two5
           yarr5=460.0*(2.0*arr15-arr05-arr25)/sum5/root_six5
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
;	Calculate radius and ralpha
	radius5=sqrt(xarr5*xarr5+yarr5*yarr5)
	ralpha5=atan(xarr5,yarr5)
	whereless4=where(ralpha5 lt 0.0)
	if whereless4(0) ne -1 then $
	   ralpha5(whereless4)=ralpha5(whereless4)+(2*!dpi)
;
;	Now start on the arm work
	start2=fix(start5)
	stop2=fix(stop5+1.0)
;	Calculate some other parameters
         rad2deg5=180.0/!pi
	rphi5=phi5/rad2deg5
	rphilower5=rphi5-(percent5*!dpi)
	rphiupper5=rphi5+(percent5*!dpi)
	rl5=make_array(long(stop2)+1L,nread4)
	ru5=make_array(long(stop2)+1L,nread4)
	for n=start2,stop2 do begin
	   rl5(n,*)=k5*(ralpha5+rphilower5+(2*n*!dpi))
	   ru5(n,*)=k5*(ralpha5+rphiupper5+(2*n*!dpi))
	endfor	
;	Now for the assignment of a value of n to each event
	for m=start2,stop2 do begin
	   wherewithin4=where((rl5(m,*) le radius5) and (radius5 le ru5(m,*)))
	if wherewithin4(0) ne -1 then $
	     ralpha5(wherewithin4)=ralpha5(wherewithin4)+(2.0*float(m)*!dpi)
	endfor
         xarr2(event4:(event4+nread4-1L))= $
           fix(radius5/460.0*xcombine4-xoffset4) ;scale to 32767
         theta5=(rad2deg5*ralpha5)
	 xvalue=((theta5^2)-(start5*360.0)^2)/((360.0*stop5)^2-(360.0*start5)^2)
	 xvalue=xvalue*500.0	;scale to 500 for 50 cms
         yarr2(event4:(event4+nread4-1L))= fix(xvalue*64.0)  ;screen pix
	if (writeflag2 eq 1) then begin
		including4=where(xvalue ge 0 and xvalue le 500)
        	writeu,2,[xvalue(0,including4)*100.0,transpose(sum1(event4+including4))]
	endif
   
     end
   endcase
     endfor
     close, stream
     if (writeflag2 eq 1) then begin
        close,2	        ;close the xvalue file
        writeflag2=0     ;and reset the file                                                                         
        WIDGET_CONTROL, butt_array, sensitive=0
     endif
     sum4=0b & sum5=0b & wszarr1=0b & zarr2=0b ;Reclaim the memory
     xarr5=0b & yarr5=0b & theta5=0b & whereless4=0b
     arr05=0b & arr15=0b & arr25=0b
       
       zoomdiv2=16384
       xmasklo2=0 & xmaskhi2=32767
       ymasklo2=0 & ymaskhi2=32767
       xcurroffset2=0 & ycurroffset2=0
       calcall ;Plot the data
       resensitise

end


;----------------------- READ_RAW2 -------------------------
PRO read_raw2
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON XVAL, writeflag2, butt_array

;Read in data from .raw file, convert to x,y and plot
       
fileflag2=1

       read_dfl

         xcombine4=64L*xfullscale4 ;64 scales it into integer
         ycombine4=64L*yfullscale4
         xcombine5=64.0*xfullscale4*ch0gain5 ;64 scales it into integer
         ycombine5=64.0*yfullscale4*ch1gain5
         xoffset5=float(xoffset4) & yoffset5=float(yoffset4)
     root_two5=sqrt(2.0)
     root_six5=sqrt(6.0)
	     
       stream=1
       openr, stream, flnam
       stats=fstat(stream)
       nfile4=(stats.size-512L)/8L ;8bytes per event
       xarr2=intarr(nfile4) & yarr2=intarr(nfile4) & sum1=bytarr(nfile4)
       dummy=bytarr(512)
       nblocks2=fix(nfile4/1024L)
       nleft2=fix(nfile4-1024L*nblocks2)
       readu, stream, dummy
       dummy=0b ;Reclaim the memory

       ;Set up variables to read 1024 events
       wszarr2=intarr(4, 1024) & nread4=1024L

     for iblock2=0, nblocks2 do begin
       event4=1024L*iblock2
       if iblock2 eq nblocks2 then begin
         wszarr2=intarr(4, nleft2) & nread4=long(nleft2)
       endif
       readu, stream, wszarr2
       ;----------------- Calculate x, y, phd ------------
   case viewflag2 of  
     0: begin
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=long(wszarr2(0,*))+wszarr2(1,*)+wszarr2(2,*)
           xarr2(event4:(event4+nread4-1L))= $
                           fix(xcombine4*wszarr2(0,*)/sum4-xoffset4)
           yarr2(event4:(event4+nread4-1L))= $
                           fix(ycombine4*wszarr2(1,*)/sum4-yoffset4)
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         sum5=ch0gain5*wszarr2(0,*)+ch1gain5*wszarr2(1,*) $
         +ch2gain5*wszarr2(2,*)
         ;Form position coord list.
         xarr2(event4:(event4+nread4-1L))= $
                               fix(xcombine5*wszarr2(0,*)/sum5-xoffset5)
         yarr2(event4:(event4+nread4-1L))= $
                               fix(ycombine5*wszarr2(1,*)/sum5-yoffset5)
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
     end

     1: begin
         xcombine5=64.0*xfullscale4/root_two5 ;64 scales to 32767
         ycombine5=64.0*yfullscale4/root_six5
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=long(wszarr2(0,*))+wszarr2(1,*)+wszarr2(2,*)
           xarr2(event4:(event4+nread4-1L))= $
             fix(xcombine5*(long(wszarr2(2,*))-wszarr2(0,*)) $
                 /sum4-xoffset4+16384.5)
           yarr2(event4:(event4+nread4-1L))= $
            fix(ycombine5*(long(wszarr2(1,*))+wszarr2(1,*) $
                           -wszarr2(0,*)-wszarr2(2,*)) $
                /sum4-yoffset4+16384.5)
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         arr05=ch0gain5*wszarr2(0,*)
         arr15=ch1gain5*wszarr2(1,*)
         arr25=ch2gain5*wszarr2(2,*)
         sum5=arr05+arr15+arr25
         ;Form position coord list.
         xarr2(event4:(event4+nread4-1L))= $
             fix(xcombine5*(arr25-arr05)/sum5-xoffset5+16384.5)
         yarr2(event4:(event4+nread4-1L))= $
            fix(ycombine5*(2.0*arr15-arr05-arr25) $
                /sum5-yoffset5+16384.5)
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
     end

     2: begin
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=long(wszarr2(0,*))+wszarr2(1,*)+wszarr2(2,*)
           xarr5=(long(wszarr2(2,*))-wszarr2(0,*))/root_two5/sum4
           yarr5=(long(wszarr2(1,*))+wszarr2(1,*)-wszarr2(0,*)-wszarr2(2,*)) $
                 /root_six5/sum4
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         arr05=ch0gain5*wszarr2(0,*)
         arr15=ch1gain5*wszarr2(1,*)
         arr25=ch2gain5*wszarr2(2,*)
         sum5=arr05+arr15+arr25
           xarr5=(arr25-arr05)/sum5/root_two5
           yarr5=(2.0*arr15-arr05-arr25)/sum5/root_six5
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
         xarr2(event4:(event4+nread4-1L))= $
           fix(sqrt(xarr5*xarr5+yarr5*yarr5)*xcombine4-xoffset4) ;scale to 32767
         rad2deg5=180.0/!pi
         theta5=rad2deg5*atan(xarr5, yarr5)
         whereless4=where(theta5 lt 0.0)
         if whereless4(0) ne -1 then $
           theta5(whereless4)=theta5(whereless4)+360.0
         yarr2(event4:(event4+nread4-1L))= fix(theta5*64.0) ;scale to 360
                                                               ;screen pix
           
     end

     3: begin	
       if (ch0gain5 eq 1.0) and (ch1gain5 eq 1.0) and $
           (ch2gain5 eq 1.0) then begin
           sum4=(long(wszarr2(0,*))+wszarr2(1,*)+wszarr2(2,*))
           xarr5=460.0*(long(wszarr2(2,*))-wszarr2(0,*))/root_two5/sum4
           yarr5=460.0*(long(wszarr2(1,*))+wszarr2(1,*)-wszarr2(0,*)-wszarr2(2,*)) $
                 /root_six5/sum4
           sum1(event4:(event4+nread4-1L))=byte(sum4/sumdiv4)
       endif else begin
         arr05=ch0gain5*wszarr2(0,*)
         arr15=ch1gain5*wszarr2(1,*)
         arr25=ch2gain5*wszarr2(2,*)
         sum5=(arr05+arr15+arr25)
           xarr5=460.0*(arr25-arr05)/sum5/root_two5
           yarr5=460*(2.0*arr15-arr05-arr25)/sum5/root_six5
         sumdiv5=float(sumdiv4)
         sum1(event4:(event4+nread4-1L))=byte(sum5/sumdiv5)
       endelse
;	Calculate radius and ralpha
	radius5=sqrt(xarr5*xarr5+yarr5*yarr5)
	ralpha5=atan(xarr5,yarr5)
	whereless4=where(ralpha5 lt 0.0)
	if whereless4(0) ne -1 then $
	   ralpha5(whereless4)=ralpha5(whereless4)+(2*!dpi)
;
;	Now start on the arm work
	start2=fix(start5)
	stop2=fix(stop5+1.0)
;	Calculate some other parameters
         rad2deg5=180.0/!pi
	rphi5=phi5/rad2deg5
	rphilower5=rphi5-(percent5*!dpi)
	rphiupper5=rphi5+(percent5*!dpi)
	rl5=make_array(long(stop2)+1L,nread4)
	ru5=make_array(long(stop2)+1L,nread4)
	for n=start2,stop2 do begin
	   rl5(n,*)=k5*(ralpha5+rphilower5+(2*n*!dpi))
	   ru5(n,*)=k5*(ralpha5+rphiupper5+(2*n*!dpi))
	endfor	
;	Now for the assignment of a value of n to each event
	for m=start2,stop2 do begin
	   wherewithin4=where((rl5(m,*) le radius5) and (radius5 le ru5(m,*)))
	if wherewithin4(0) ne -1 then $
	     ralpha5(wherewithin4)=ralpha5(wherewithin4)+(2.0*float(m)*!dpi)
	endfor
         xarr2(event4:(event4+nread4-1L))= $
           fix(radius5/460.0*xcombine4-xoffset4) ;scale to 32767
         theta5=(rad2deg5*ralpha5)
	 xvalue=((theta5^2)-(start5*360.0)^2)/((360.0*stop5)^2-(360.0*start5)^2)
	 xvalue=xvalue*500.0	;scale to 500 for 50 cms
         yarr2(event4:(event4+nread4-1L))= fix(xvalue*64.0)  ;screen pix
	if (writeflag2 eq 1) then begin
		including4=where(xvalue ge 0 and xvalue le 500)
        	writeu,2,[xvalue(0,including4)*100.0,transpose(sum1(event4+including4))]
	endif
   
     end
   endcase
     endfor
     close, stream
     if (writeflag2 eq 1) then begin
        close,2	        ;close the xvalue file
        writeflag2=0     ;and reset the file                                                                         
        WIDGET_CONTROL, butt_array, sensitive=0
     endif
     sum4=0b & sum5=0b & wszarr2=0b & zarr2=0b ;Reclaim the memory
     xarr5=0b & yarr5=0b & theta5=0b & whereless4=0b
     arr05=0b & arr15=0b & arr25=0b
       
       zoomdiv2=16384
       xmasklo2=0 & xmaskhi2=32767
       ymasklo2=0 & ymaskhi2=32767
       xcurroffset2=0 & ycurroffset2=0
       calcall ;Plot the data
       resensitise
end


;----------------------- READ_XY -------------------------
PRO read_xy
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON XVAL, writeflag2, butt_array

;Read in data from .wsz file, convert to x,y and plot
     
fileflag2=2     

       read_dfl
     xcombine5=128.0*wszxscale5
     ycombine5=128.0*wszyscale5
     root_two5=sqrt(2.0)
     root_six5=sqrt(6.0)
;	because of designed for yx instead of xy, swap gain factors
	dummy=xy1gain5
	xy1gain5=xy0gain5
	xy0gain5=dummy
;
       stream=1
       openr, stream, flnam
       stats=fstat(stream)
       nfile4=(stats.size-512L)/2L ;2 bytes per event
       xarr2=intarr(nfile4) & yarr2=intarr(nfile4) & sum1=bytarr(nfile4)
       dummy=bytarr(512)
       nblocks2=fix(nfile4/1024L)
       nleft2=fix(nfile4-1024L*nblocks2)
       readu, stream, dummy
       dummy=0b ;Reclaim the memory
       
       ;Set up variables to read 1024 events
       xyarr1=bytarr(2, 1024)
       nread4=1024L

     for iblock2=0, nblocks2 do begin
       event4=1024L*iblock2
       if iblock2 eq nblocks2 then begin
         xyarr1=bytarr(2, nleft2) & nread4=long(nleft2)
       endif
       readu, stream, xyarr1
       ;----------------- Calculate x, y, phd ------------
   case viewflag2 of  
     0: begin
       if (wszxoffset5 eq 0.0) and (wszxscale5 eq 1.0) then $
         xarr2(event4:(event4+nread4-1L))= $
                   ishft(fix(xyarr1(0,*)), 7) $ ;shift 7 scales 256 to 32767
        else xarr2(event4:(event4+nread4-1L))= $
                   fix((xyarr1(0,*)-wszxoffset5)*xcombine5)

       if (wszyoffset5 eq 0.0) and (wszyscale5 eq 1.0) then $
         yarr2(event4:(event4+nread4-1L))= $
                   ishft(fix(xyarr1(1,*)), 7) $ ;shift 7 scales 256 to 32767
        else yarr2(event4:(event4+nread4-1L))= $
                   fix((xyarr1(1,*)-wszyoffset5)*ycombine5)
     end
     
     1: begin
         zarr2=pseudosum2-xyarr1(0,*)-xyarr1(1,*)

     	 if (xy0gain5 ne 1.0) and (xy1gain5 ne 1.0) and (xy2gain5 ne 1.0) then begin
	    arrn05=float(xyarr1(0,*))
	    arrn15=float(xyarr1(1,*))
	    arrn25=float(zarr2)
     	endif else begin
            arrn05=xy0gain5*float(xyarr1(0,*))	;correct using gain factors
            arrn15=xy1gain5*float(xyarr1(1,*))
            arrn25=xy2gain5*float(zarr2)
            sumc5=(arrn05+arrn15+arrn25)/460.0
	    arrn05=arrn05/sumc5
	    arrn15=arrn15/sumc5
            arrn25=arrn25/sumc5
     	endelse	

       if (wszxoffset5 eq 0.0) and (wszxscale5 eq 1.0) then begin
     xcombine5=128.0*wszxscale5/root_two5
         xarr2(event4:(event4+nread4-1L))= $
           fix((arrn25-arrn05)*xcombine5+16384.5)
        endif else begin
     xcombine5=128.0*wszxscale5
          xarr2(event4:(event4+nread4-1L))= $
           fix(((arrn25-arrn05)/root_two5-wszxoffset5)*xcombine5+16384.5)
       endelse

       if (wszyoffset5 eq 0.0) and (wszyscale5 eq 1.0) then begin
     ycombine5=128.0*wszyscale5/root_six5
         yarr2(event4:(event4+nread4-1L))= $
     fix((fix(arrn15)+arrn15-arrn05 $
               -arrn25)*ycombine5+16384.5)
        endif else begin
          ycombine5=128.0*wszyscale5
          yarr2(event4:(event4+nread4-1L))= $
            fix(((fix(arrn15)+arrn15-arrn05-arrn25)/root_six5 $
                 -wszyoffset5)*ycombine5+16384.5)
     endelse
     end

     2: begin
         zarr2=pseudosum2-xyarr1(0,*)-xyarr1(1,*)
 
    	 if (xy0gain5 eq 1.0) and (xy1gain5 eq 1.0) and (xy2gain5 eq 1.0) then begin
	    arrn05=float(xyarr1(0,*))
	    arrn15=float(xyarr1(1,*))
	    arrn25=float(zarr2)
     	endif else begin
            arrn05=xy0gain5*float(xyarr1(0,*))	;correct using gain factors
            arrn15=xy1gain5*float(xyarr1(1,*))
            arrn25=xy2gain5*float(zarr2)
            sumc5=(arrn05+arrn15+arrn25)
	    arrn05=460.0*arrn05/sumc5
	    arrn15=460.0*arrn15/sumc5
            arrn25=460.0*arrn25/sumc5
     	endelse	

         xarr5=(arrn25-arrn05)/root_two5
         yarr5=(fix(arrn15)+arrn15-arrn05-arrn25)/root_six5
         
       if (wszxoffset5 eq 0.0) and (wszxscale5 eq 1.0) then $
         xarr2(event4:(event4+nread4-1L))= $
           fix(sqrt(xarr5*xarr5+yarr5*yarr5)*xcombine5) $ ;scale to 32767
        else $
          xarr2(event4:(event4+nread4-1L))= $
            fix((sqrt(xarr5*xarr5+yarr5*yarr5)-wszxoffset5)*xcombine5)
         
         rad2deg5=180.0/!pi
         theta5=rad2deg5*atan(xarr5, yarr5)
         whereless4=where(theta5 lt 0.0)
         if whereless4(0) ne -1 then $
           theta5(whereless4)=theta5(whereless4)+360.0
         yarr2(event4:(event4+nread4-1L))= fix(theta5*64.0) ;scale to 360
                                                               ;screen pix
     end

     3: begin
         zarr2=pseudosum2-xyarr1(0,*)-xyarr1(1,*)
 
    	 if (xy0gain5 eq 1.0) and (xy1gain5 eq 1.0) and (xy2gain5 eq 1.0) then begin
	    arrn05=float(xyarr1(0,*))
	    arrn15=float(xyarr1(1,*))
	    arrn25=float(zarr2)
     	endif else begin
            arrn05=xy0gain5*float(xyarr1(0,*))	;correct using gain factors
            arrn15=xy1gain5*float(xyarr1(1,*))
            arrn25=xy2gain5*float(zarr2)
            sumc5=(arrn05+arrn15+arrn25)
	    arrn05=460.0*arrn05/sumc5
	    arrn15=460.0*arrn15/sumc5
            arrn25=460.0*arrn25/sumc5
     	endelse	

         xarr5=(arrn25-arrn05)/root_two5
         yarr5=(fix(arrn15)+arrn15-arrn05-arrn25)/root_six5
;
 ;	Calculate radius and ralpha
	radius5=sqrt(xarr5*xarr5+yarr5*yarr5)
	ralpha5=atan(xarr5,yarr5)
	whereless4=where(ralpha5 lt 0.0)
	if whereless4(0) ne -1 then $
	   ralpha5(whereless4)=ralpha5(whereless4)+(2*!dpi)
;
;	Now start on the arm work
	start2=fix(start5)
	stop2=fix(stop5+1.0)
;	Calculate some other parameters
         rad2deg5=180.0/!pi
	rphi5=phi5/rad2deg5
	rphilower5=rphi5-(percent5*!dpi)
	rphiupper5=rphi5+(percent5*!dpi)
	rl5=make_array(long(stop2)+1L,nread4)
	ru5=make_array(long(stop2)+1L,nread4)
	for n=start2,stop2 do begin
	   rl5(n,*)=k5*(ralpha5+rphilower5+(2*n*!dpi))
	   ru5(n,*)=k5*(ralpha5+rphiupper5+(2*n*!dpi))
	endfor	
;	Now for the assignment of a value of n to each event
	for m=start2,stop2 do begin
	   wherewithin4=where((rl5(m,*) le radius5) and (radius5 le ru5(m,*)))
	if wherewithin4(0) ne -1 then $
	     ralpha5(wherewithin4)=ralpha5(wherewithin4)+(2.0*float(m)*!dpi)
	endfor
         xarr2(event4:(event4+nread4-1L))= $
           fix(radius5*xcombine5-wszxoffset5) ;scale to 32767
         theta5=(rad2deg5*ralpha5)
	 xvalue=((theta5^2)-(start5*360.0)^2)/((360.0*stop5)^2-(360.0*start5)^2)
	 xvalue=xvalue*500.0	;scale to 500 for 50 cms
         yarr2(event4:(event4+nread4-1L))= fix(xvalue*64.0)  ;screen pix           
	if (writeflag2 eq 1) then begin
		including4=where(xvalue ge 0 and xvalue le 500)
        	writeu,2,[xvalue(0,including4)*100.0,transpose(sum1(event4+including4))]
	endif
   
     end
   endcase
     endfor
     close, stream
     if (writeflag2 eq 1) then begin
        close,2	        ;close the xvalue file
        writeflag2=0     ;and reset the file                                                                         
        WIDGET_CONTROL, butt_array, sensitive=0
     endif
     sum1=lindgen(nfile4)
     sum1=byte(sum1*64L/nfile4) ;sum1 tells position in file
     wszstruct=0b & wszstructarr=0b & zarr2=0b ;Reclaim the memory
     xarr5=0b & yarr5=0b & theta5=0b & whereless4=0b
       
       zoomdiv2=16384
       xmasklo2=0 & xmaskhi2=32767
       ymasklo2=0 & ymaskhi2=32767
       xcurroffset2=0 & ycurroffset2=0
       calcall ;Plot the data
       resensitise
       
end


;----------------------- READ_YX -------------------------
PRO read_yx
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON XVAL, writeflag2, butt_array

;Read in data from flight style .raw file, convert to x,y and plot
     
fileflag2=3

       read_dfl
     xcombine5=128.0*wszxscale5
     ycombine5=128.0*wszyscale5
     root_two5=sqrt(2.0)
     root_six5=sqrt(6.0)

       stream=1
       openr, stream, flnam
       stats=fstat(stream)
       nfile4=(stats.size-512L)/2L ;2 bytes per event
       xarr2=intarr(nfile4) & yarr2=intarr(nfile4) & sum1=bytarr(nfile4)
       dummy=bytarr(512)
       nblocks2=fix(nfile4/1024L)
       nleft2=fix(nfile4-1024L*nblocks2)
       readu, stream, dummy
       dummy=0b ;Reclaim the memory by discarding header
       
       ;Set up variables to read 1024 events
       xyarr1=bytarr(2, 1024)
       nread4=1024L

     for iblock2=0, nblocks2 do begin
       event4=1024L*iblock2
       if iblock2 eq nblocks2 then begin
         xyarr1=bytarr(2, nleft2) & nread4=long(nleft2)
       endif
       readu, stream, xyarr1
       ;----------------- Calculate x, y, phd ------------
   case viewflag2 of  
     0: begin
       if (wszxoffset5 eq 0.0) and (wszxscale5 eq 1.0) then $
         xarr2(event4:(event4+nread4-1L))= $
                   ishft(fix(xyarr1(1,*)), 7) $ ;shift 7 scales 256 to 32767
        else xarr2(event4:(event4+nread4-1L))= $
                   fix((xyarr1(1,*)-wszxoffset5)*xcombine5)

       if (wszyoffset5 eq 0.0) and (wszyscale5 eq 1.0) then $
         yarr2(event4:(event4+nread4-1L))= $
                   ishft(fix(xyarr1(0,*)), 7) $ ;shift 7 scales 256 to 32767
        else yarr2(event4:(event4+nread4-1L))= $
                   fix((xyarr1(0,*)-wszyoffset5)*ycombine5)
     end
     
     1: begin
         zarr2=pseudosum2-xyarr1(0,*)-xyarr1(1,*)
 
    	 if (xy0gain5 eq 1.0) and (xy1gain5 eq 1.0) and (xy2gain5 eq 1.0) then begin
	    arrn05=float(xyarr1(0,*))
	    arrn15=float(xyarr1(1,*))
	    arrn25=float(zarr2)
     	endif else begin
            arrn05=xy0gain5*float(xyarr1(0,*))	;correct using gain factors
            arrn15=xy1gain5*float(xyarr1(1,*))
            arrn25=xy2gain5*float(zarr2)
            sumc5=(arrn05+arrn15+arrn25)/460.0
	    arrn05=arrn05/sumc5
	    arrn15=arrn15/sumc5
            arrn25=arrn25/sumc5
     	endelse	

       if (wszxoffset5 eq 0.0) and (wszxscale5 eq 1.0) then begin
     xcombine5=128.0*wszxscale5/root_two5
         xarr2(event4:(event4+nread4-1L))= $
           fix((arrn25-arrn15)*xcombine5+16384.5)
        endif else begin
     xcombine5=128.0*wszxscale5
          xarr2(event4:(event4+nread4-1L))= $
           fix(((arrn25-arrn15)/root_two5-wszxoffset5)*xcombine5+16384.5)
       endelse

       if (wszyoffset5 eq 0.0) and (wszyscale5 eq 1.0) then begin
     ycombine5=128.0*wszyscale5/root_six5
         yarr2(event4:(event4+nread4-1L))= $
     fix((fix(arrn05)+arrn05-arrn15 $
               -arrn25)*ycombine5+16384.5)
        endif else begin
          ycombine5=128.0*wszyscale5
          yarr2(event4:(event4+nread4-1L))= $
            fix(((fix(arrn05)+arrn05-arrn15-arrn25)/root_six5 $
                 -wszyoffset5)*ycombine5+16384.5)
     endelse
     end

     2: begin
         zarr2=pseudosum2-xyarr1(0,*)-xyarr1(1,*)
 
    	 if (xy0gain5 eq 1.0) and (xy1gain5 eq 1.0) and (xy2gain5 eq 1.0) then begin
	    arrn05=float(xyarr1(0,*))
	    arrn15=float(xyarr1(1,*))
	    arrn25=float(zarr2)
     	endif else begin
            arrn05=xy0gain5*float(xyarr1(0,*))	;correct using gain factors
            arrn15=xy1gain5*float(xyarr1(1,*))
            arrn25=xy2gain5*float(zarr2)
            sumc5=(arrn05+arrn15+arrn25)/460.0
	    arrn05=arrn05/sumc5
	    arrn15=arrn15/sumc5
            arrn25=arrn25/sumc5
     	endelse	

         xarr5=(arrn25-arrn15)/root_two5
         yarr5=(fix(arrn05)+arrn05-arrn15-arrn25)/root_six5
         
       if (wszxoffset5 eq 0.0) and (wszxscale5 eq 1.0) then $
         xarr2(event4:(event4+nread4-1L))= $
           fix(sqrt(xarr5*xarr5+yarr5*yarr5)*xcombine5) $ ;scale to 32767
        else $
          xarr2(event4:(event4+nread4-1L))= $
            fix((sqrt(xarr5*xarr5+yarr5*yarr5)-wszxoffset5)*xcombine5)
         
         rad2deg5=180.0/!pi
         theta5=rad2deg5*atan(xarr5, yarr5)
         whereless4=where(theta5 lt 0.0)
         if whereless4(0) ne -1 then $
           theta5(whereless4)=theta5(whereless4)+360.0
         yarr2(event4:(event4+nread4-1L))= fix(theta5*64.0) ;scale to 360
                                                               ;screen pix
     end

     3: begin
         zarr2=pseudosum2-xyarr1(0,*)-xyarr1(1,*)
 
    	 if (xy0gain5 eq 1.0) and (xy1gain5 eq 1.0) and (xy2gain5 eq 1.0) then begin
	    arrn05=float(xyarr1(0,*))
	    arrn15=float(xyarr1(1,*))
	    arrn25=float(zarr2)
     	endif else begin
            arrn05=xy0gain5*float(xyarr1(0,*))	;correct using gain factors
            arrn15=xy1gain5*float(xyarr1(1,*))
            arrn25=xy2gain5*float(zarr2)
            sumc5=(arrn05+arrn15+arrn25)/460.0
	    arrn05=arrn05/sumc5
	    arrn15=arrn15/sumc5
            arrn25=arrn25/sumc5
     	endelse	

         xarr5=(arrn25-arrn15)/root_two5
         yarr5=(fix(arrn05)+arrn05-arrn15-arrn25)/root_six5
;
;	Calculate radius and ralpha
	radius5=sqrt(xarr5*xarr5+yarr5*yarr5)
	ralpha5=atan(xarr5,yarr5)
	whereless4=where(ralpha5 lt 0.0)
	if whereless4(0) ne -1 then $
	   ralpha5(whereless4)=ralpha5(whereless4)+(2*!dpi)
;
;	Now start on the arm work
	start2=fix(start5)
	stop2=fix(stop5+1.0)
;
;	Now start on the arm work
;	Calculate some other parameters
         rad2deg5=180.0/!pi
	rphi5=phi5/rad2deg5
	rphilower5=rphi5-(percent5*!dpi)
	rphiupper5=rphi5+(percent5*!dpi)
	rl5=make_array(long(stop2)+1L,nread4)
	ru5=make_array(long(stop2)+1L,nread4)
	for n=start2,stop2 do begin
	   rl5(n,*)=k5*(ralpha5+rphilower5+(2*n*!dpi))
	   ru5(n,*)=k5*(ralpha5+rphiupper5+(2*n*!dpi))
	endfor	
;	Now for the assignment of a value of n to each event
	for m=start2,stop2 do begin
	   wherewithin4=where((rl5(m,*) le radius5) and (radius5 le ru5(m,*)))
	if wherewithin4(0) ne -1 then $
	     ralpha5(wherewithin4)=ralpha5(wherewithin4)+(2.0*float(m)*!dpi)
	endfor
         xarr2(event4:(event4+nread4-1L))= $
           fix(radius5*xcombine5-wszxoffset5) ;scale to 32767
         theta5=(rad2deg5*ralpha5)
	 xvalue=((theta5^2)-(start5*360.0)^2)/((360.0*stop5)^2-(360.0*start5)^2)
	 xvalue=xvalue*500.0	;scale to 500 for 50 cms
         yarr2(event4:(event4+nread4-1L))= fix(xvalue*64.0)  ;screen pix           
	if (writeflag2 eq 1) then begin
		including4=where(xvalue ge 0 and xvalue le 500)
         	writeu,2,[xvalue(0,including4)*100.0,transpose(sum1(event4+including4))]
	endif
   
    end
   endcase
     endfor
     close, stream
     if (writeflag2 eq 1) then begin
        close,2	        ;close the xvalue file
        writeflag2=0     ;and reset the file                                                                         
        WIDGET_CONTROL, butt_array, sensitive=0
     endif
     sum1=lindgen(nfile4)
     sum1=byte(sum1*64L/nfile4) ;sum1 tells position in file
     wszstruct=0b & wszstructarr=0b & zarr2=0b ;Reclaim the memory
     xarr5=0b & yarr5=0b & theta5=0b & whereless4=0b
       
       zoomdiv2=16384
       xmasklo2=1 & xmaskhi2=32767
       ymasklo2=1 & ymaskhi2=32767
       xcurroffset2=0 & ycurroffset2=0
       calcall ;Plot the data
       resensitise
       
end


;----------------------- RESENSITISE ----------------------
PRO resensitise
COMMON LABELS, title_label, val_label, base, butt_quit, butt_load, butt_acq, butt_unzoom, butt_phd,$
               butt_sel, butt_rect, butt_hard, butt_view, butt_col, draw
COMMON XVAL, writeflag2, butt_array

;Resensitise widget buttons
WIDGET_CONTROL, butt_unzoom, /sensitive
WIDGET_CONTROL, butt_phd, /sensitive
WIDGET_CONTROL, butt_sel, /sensitive
WIDGET_CONTROL, butt_rect, /sensitive
WIDGET_CONTROL, butt_hard, /sensitive
WIDGET_CONTROL, butt_view, /sensitive
WIDGET_CONTROL, draw, /sensitive

end


;----------------------- READ_DFL -----------------------------------
PRO read_dfl
COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam

;Read animal.dfl for scale factors etc.     
     ;xfullscale4 and yfullscale4 are chosen for
     ;the aspect ratio of the particular detector. In Mick's program, the
     ;corresponding values are 900 and 900.
     ximsizestring='' & yimsizestring=''
     ch0string='' & ch1string='' & ch2string=''
     xoffstring='' & yoffstring=''
     xscalestring='' & yscalestring='' & sumdivstring=''
     xy0string='' & xy1string='' & xy2string=''
     wszxoffstring='' & wszyoffstring=''
     wszxstring='' & wszystring='' & wszsumstring=''
     pseudosumstring='' & acqprognam=''
     percentstring='' & stopstring='' & startstring=''
     kstring='' & phistring=''

     stream=1
     openr, stream, 'spanimal.dfl'
     while strlen(ximsizestring) eq 0 do readf, stream, ximsizestring ;Dummy
     ximsizestring=''
     while strlen(ximsizestring) eq 0 do readf, stream, ximsizestring
     while strlen(yimsizestring) eq 0 do readf, stream, yimsizestring
     while strlen(ch0string) eq 0 do readf, stream, ch0string
     while strlen(ch1string) eq 0 do readf, stream, ch1string
     while strlen(ch2string) eq 0 do readf, stream, ch2string
     while strlen(xoffstring) eq 0 do readf, stream, xoffstring
     while strlen(yoffstring) eq 0 do readf, stream, yoffstring
     while strlen(xscalestring) eq 0 do readf, stream, xscalestring
     while strlen(yscalestring) eq 0 do readf, stream, yscalestring
     while strlen(sumdivstring) eq 0 do readf, stream, sumdivstring
     while strlen(xy0string) eq 0 do readf, stream, xy0string
     while strlen(xy1string) eq 0 do readf, stream, xy1string
     while strlen(xy2string) eq 0 do readf, stream, xy2string
     while strlen(wszxoffstring) eq 0 do readf, stream, wszxoffstring
     while strlen(wszyoffstring) eq 0 do readf, stream, wszyoffstring
     while strlen(wszxstring) eq 0 do readf, stream, wszxstring
     while strlen(wszystring) eq 0 do readf, stream, wszystring
     while strlen(wszsumstring) eq 0 do readf, stream, wszsumstring
     while strlen(pseudosumstring) eq 0 do readf, stream, pseudosumstring
     while strlen(percentstring) eq 0 do readf, stream, percentstring
     while strlen(stopstring) eq 0 do readf, stream, stopstring
     while strlen(startstring) eq 0 do readf, stream, startstring
     while strlen(kstring) eq 0 do readf, stream, kstring
     while strlen(phistring) eq 0 do readf, stream, phistring
     while strlen(acqprognam) eq 0 do readf, stream, acqprognam
     close, stream

     posn2=strpos(ximsizestring, '=')+1
     ximsize2=fix(strmid(ximsizestring, posn2, strlen(ximsizestring)-posn2))
     posn2=strpos(yimsizestring, '=')+1
     yimsize2=fix(strmid(yimsizestring, posn2, strlen(yimsizestring)-posn2))
     posn2=strpos(ch0string, '=')+1
     ch0gain5=float(strmid(ch0string, posn2, strlen(ch0string)-posn2))
     posn2=strpos(ch1string, '=')+1
     ch1gain5=float(strmid(ch1string, posn2, strlen(ch1string)-posn2))
     posn2=strpos(ch2string, '=')+1
     ch2gain5=float(strmid(ch2string, posn2, strlen(ch2string)-posn2))

     posn2=strpos(xoffstring, '=')+1
     xoffset4=long(strmid(xoffstring, posn2, strlen(xoffstring)-posn2))
     posn2=strpos(yoffstring, '=')+1
     yoffset4=long(strmid(yoffstring, posn2, strlen(yoffstring)-posn2))

     posn2=strpos(xscalestring, '=')+1
     xfullscale4=long(strmid(xscalestring, posn2,$
                              strlen(xscalestring)-posn2))
     posn2=strpos(yscalestring, '=')+1
     yfullscale4=long(strmid(yscalestring, posn2,$
                              strlen(yscalestring)-posn2))

     posn2=strpos(sumdivstring, '=')+1
     sumdiv4=long(strmid(sumdivstring, posn2, strlen(sumdivstring)-posn2))

     posn2=strpos(xy0string, '=')+1
     xy0gain5= float(strmid(xy0string, posn2, strlen(xy0string)-posn2))
     posn2=strpos(xy1string, '=')+1
     xy1gain5= float(strmid(xy1string, posn2, strlen(xy1string)-posn2))
     posn2=strpos(xy2string, '=')+1
     xy2gain5= float(strmid(xy2string, posn2, strlen(xy2string)-posn2))

     posn2=strpos(wszxoffstring, '=')+1
     wszxoffset5= $
            float(strmid(wszxoffstring, posn2, strlen(wszxoffstring)-posn2))
     posn2=strpos(wszyoffstring, '=')+1
     wszyoffset5= $
            float(strmid(wszyoffstring, posn2, strlen(wszyoffstring)-posn2))
     posn2=strpos(wszxstring, '=')+1
     wszxscale5=float(strmid(wszxstring, posn2, strlen(wszxstring)-posn2))
     posn2=strpos(wszystring, '=')+1
     wszyscale5=float(strmid(wszystring, posn2, strlen(wszystring)-posn2))
     posn2=strpos(wszsumstring, '=')+1
     wszsumscale5= $
               float(strmid(wszsumstring, posn2, strlen(wszsumstring)-posn2))

     posn2=strpos(pseudosumstring, '=')+1
     pseudosum2= $
       fix(strmid(pseudosumstring, posn2, strlen(pseudosumstring)-posn2))

     posn2=strpos(percentstring, '=')+1
     percent5=float(strmid(percentstring, posn2, strlen(percentstring)-posn2))
     posn2=strpos(stopstring, '=')+1
     stop5=float(strmid(stopstring, posn2, strlen(stopstring)-posn2))
     posn2=strpos(startstring, '=')+1
     start5=float(strmid(startstring, posn2, strlen(startstring)-posn2))
     posn2=strpos(kstring, '=')+1
     k5=float(strmid(kstring, posn2, strlen(kstring)-posn2))
     posn2=strpos(phistring, '=')+1
     phi5=float(strmid(phistring, posn2, strlen(phistring)-posn2))

     posn2=strpos(acqprognam, '=')+1
     acqprognam= $
       strcompress(strmid(acqprognam, posn2, strlen(acqprognam)-posn2),$
                   /remove_all)
;	Invert gains so that they work like vrawnall
	ch0gain5=1.0/ch0gain5
	ch1gain5=1.0/ch1gain5
	ch2gain5=1.0/ch2gain5
	xy0gain5=1.0/xy0gain5
	xy1gain5=1.0/xy1gain5
	xy2gain5=1.0/xy2gain5
;	because of yx instead of xy, swap gain factors over for 3 inputs
	dummy=ch1gain5
	ch1gain5=ch0gain5
	ch0gain5=dummy

end


;----------------------- GET_NEVENTS_EVENT ----------------------
pro get_nevents_event, event
COMMON ACQCOM, nevent_text, nevents4

    WIDGET_CONTROL, event.id, GET_VALUE=strng
    strng=strtrim(strng(0), 2) ;Remove leading and trailing whitespace

    if strlen(strng) eq 0 then begin
      nevents4=0L
      WIDGET_CONTROL, event.top, /destroy
      return
    endif

    b1=byte(strng)
    where_not_numeral4=where((b1 lt '30'XB) or (b1 gt '39'XB))
    if where_not_numeral4(0) eq -1 then begin ;If OK
      nevents4=long(strng)
      WIDGET_CONTROL, event.top, /destroy
      return
     endif else begin ;If bad number, then re-enter
      WIDGET_CONTROL, nevent_text, set_value=''
    endelse
end


;---------------- GET_NEVENTS --------------------
function get_nevents, GROUP=GROUP
COMMON ACQCOM, nevent_text, nevents4

base=WIDGET_BASE(TITLE='Enter n_events to acquire', XOFFSET=300, YOFFSET=300)
nevent_text=WIDGET_TEXT(base, /EDITABLE, XSIZE=35, YSIZE=1)

WIDGET_CONTROL, base, /REALIZE
WIDGET_CONTROL, nevent_text, /INPUT_FOCUS
XMANAGER, 'get_nevents', base, GROUP_LEADER=GROUP, /MODAL ;Take over PC

return, nevents4
end


;----------------------- SPANIMAL_EVENT ---------------------

PRO spanimal_event, event

; This is the event handler for a draw widget which tracks
; cursor motion events.

; The COMMON block is used because the event handler needs
; widget ID's of the labels:

COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON LABELS, title_label, val_label, base, butt_quit, butt_load, butt_acq, butt_unzoom, butt_phd,$
               butt_sel, butt_rect, butt_hard, butt_view, butt_col, draw
COMMON XVAL, writeflag2, butt_array

COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON ZOOM, x0, y0, nx, ny, col, xbot2, ybot2, xmid2, ymid2, xtop2, ytop2, $
         boxmode2, px, py, prevboxflag2, xlo2, ylo2, xhi2, yhi2, area2,$
         histrectflag2
COMMON XVAL, writeflag2, butt_array

xbot5=xbot2+.5 & ybot5=ybot2+.5
xmid5=xbot5+65 & ymid5=ybot5+65
xtop5=xmid5+ximsize2+1 & ytop5=ymid5+yimsize2+1

; When a widget is selected, put its User Value into 'eventval':
WIDGET_CONTROL, event.id, GET_UVALUE = eventval


; Perform actions based on the User Value of the event:
CASE eventval OF
   'DUMMY':
   
   'DRAW_WIN_EVENT': BEGIN
     ;First, sort out button response

     ;This block waits for mouse button flags set by hist_rect to clear.
     ;There must be a better way to do this.
     ;if histrectflag2 then begin
     ;  if (event.press eq 0) and (event.release eq 0) then histrectflag2=0
     ;  return
     ;endif

     if event.press eq 1 then begin
       x0=event.x & y0=event.y & nx=0 & ny=0
       area2=-1
       ;Set up movement limits
       if (x0 gt xmid2) and (x0 lt xtop2) and $  ;Image area
          (y0 gt ymid2) and (y0 lt ytop2) then begin
          xlo2=xmid2+1 & ylo2=ymid2+1 & xhi2=xtop2-1 & yhi2=ytop2-1
          area2=0
       endif
       if (x0 gt xmid2) and (x0 lt xtop2) and $  ;Xhist area
          (y0 gt ybot2) and (y0 lt ymid2) then begin
          xlo2=xmid2+1 & ylo2=ybot2+1 & xhi2=xtop2-1 & yhi2=ymid2-1
          area2=1
       endif
       if (x0 gt xbot2) and (x0 lt xmid2) and $  ;Yhist area
          (y0 gt ymid2) and (y0 lt ytop2) then begin
          xlo2=xbot2+1 & ylo2=ymid2+1 & xhi2=xmid2-1 & yhi2=ytop2-1
          area2=2
       endif
       if (x0 gt xbot2) and (x0 lt xmid2) and $  ;Spect area
          (y0 gt ybot2) and (y0 lt ymid2) then begin
          xlo2=xbot2+1 & ylo2=ybot2+1 & xhi2=xmid2-1 & yhi2=ymid2-1
          area2=3
       endif
       if area2 ne -1 then begin          ;If a valid start point
         if prevboxflag2 eq 1 then $ ;Erase the old box
           plots, px, py, col=col, /dev, thick=1, lines=0
         boxmode2=1
         px=[x0, event.x, event.x, x0, x0]
         py=[y0, y0, event.y, event.y, y0]
         plots, px, py, col=col, /dev, thick=1, lines=0  ;Draw the box
         empty
       endif
     endif

     if event.release eq 1 then begin
       boxmode2=0 & prevboxflag2=1
     endif

     if (event.release eq 4) and (prevboxflag2 eq 1) then begin
       if nx lt 0 then begin
          nx=abs(nx) & x0=x0-nx
       endif
       if ny lt 0 then begin
          ny=abs(ny) & y0=y0-ny
       endif
       plots, px, py, col=col, /dev, thick=1, lines=0  ;Erase the box
       prevboxflag2=0
       if area2 eq 0 then zoomcalc, x0-xmid2-1, x0+nx-xmid2-1,$
                            y0-ymid2-1, y0+ny-ymid2-1
       histident2=area2
       if area2 eq 1 then histzoom, x0-xmid2-1, x0+nx-xmid2-1
       if area2 eq 2 then histzoom, y0-ymid2-1, y0+ny-ymid2-1
       if area2 eq 3 then histzoom, x0-xbot2-1, x0+nx-xbot2-1
       return
     endif

     ;Get the zoom box
     if boxmode2 eq 1 then begin
       plots, px, py, col=col, /dev, thick=1, lines=0  ;Erase the old box
       event.x=event.x > xlo2 & event.x=event.x < xhi2
       event.y=event.y > ylo2 & event.y=event.y < yhi2
       nx=event.x-x0 & ny=event.y-y0
       px=[x0, event.x, event.x, x0, x0]
       py=[y0, y0, event.y, event.y, y0]
       plots, px, py, col=col, /dev, thick=1, lines=0  ;Draw the new box
       empty    ;Flushes graphics o/p buffer
     endif
       
     ; Print the device coordinates of the cursor
     if (event.x gt xmid2) and (event.x lt xtop2) and $  ;Image area
        (event.y gt ymid2) and (event.y lt ytop2) then begin
       imx2=event.x-xmid2-1 & imy2=event.y-ymid2-1
       WIDGET_CONTROL, title_label, $
                       SET_VALUE='     X        Y                Cts'
       WIDGET_CONTROL, val_label, $
       SET_VALUE=STRING([xhistx5(imx2), yhisty5(imy2), im4(imx2, imy2)],$
         format='("(", F6.2, ",", F6.2, ")", I)')
     endif
     if (event.x gt xmid2) and (event.x lt xtop2) and $  ;Xhist area
        (event.y gt ybot2) and (event.y le ymid2) then begin
       imx2=event.x-xmid2-1
       WIDGET_CONTROL, title_label, SET_VALUE='   X               Cts'
       WIDGET_CONTROL, val_label, $
       SET_VALUE=STRING([xhistx5(imx2), xhist4(imx2)],$
         format='("(", F6.2, ")", I)')
     endif
     if (event.x gt xbot2) and (event.x le xmid2) and $  ;Yhist area
        (event.y gt ymid2) and (event.y lt ytop2) then begin
       imy2=event.y-ymid2-1
       WIDGET_CONTROL, title_label, SET_VALUE='   Y               Cts'
       WIDGET_CONTROL, val_label, $
       SET_VALUE=STRING([yhisty5(imy2), yhist4(imy2)],$
         format='("(", F6.2, ")", I)')
     endif
     if (event.x gt xbot2) and (event.x lt xmid2) and $  ;Spect area
        (event.y gt ybot2) and (event.y le ymid2) then begin
       imx2=event.x-xbot2-1
       WIDGET_CONTROL, title_label, SET_VALUE=' Sum       Cts'
       WIDGET_CONTROL, val_label, $
       SET_VALUE=STRING([imx2, sumhist4(imx2)],$
         format='("(", I3, ")", I)')
     endif
   END

   'QUIT': WIDGET_CONTROL, event.top, /DESTROY

   'LOAD_RAW1': begin
       flnam=pickfile(/read, /must_exist, filter='*.wsz')
     if flnam ne '' then read_raw1
   end

   'LOAD_RAW2': begin
       flnam=pickfile(/read, /must_exist, filter='*.raw')
     if flnam ne '' then read_raw2
   end

   'LOAD_XY': begin
       flnam=pickfile(/read, /must_exist, filter='*.raw')
     if flnam ne '' then read_xy
   end

   'LOAD_YX': begin
       flnam=pickfile(/read, /must_exist, filter='*.raw *.yx*')
     if flnam ne '' then read_yx
   end

   'ACQUIRE': begin
     return
     if findfile(acqprognam) then begin
       newflnam=pickfile(/write, filter='*.raw')
       if newflnam ne '' then begin
         ;nevents4=get_nevents()
         if nevents4 gt 0 then begin
           ;spawn, acqprognam, result2
           ;If successful then load new file, otherwise return
           ;if result2 eq 0 then begin
             ;flnam=newflnam
             ;read_raw2
           ;endif
         endif
       endif
     endif
   end

   ;'SAVE':
   
   'UNZOOM':  begin
                zoomdiv2=16384
                xmasklo2=0 & xmaskhi2=32767
                ymasklo2=0 & ymaskhi2=32767
                xcurroffset2=0 & ycurroffset2=0
                calcall
                end
   
   'INTEN': if phd1flag2 eq 1 then begin
              if (prevboxflag2 eq 1) and (area2 eq 0) then prevboxflag2=0
              phd1flag2=0
              intencalc
              device, set_graphics=old  ;Disable xor for plotting
              tvscl, im4, xmid5+1, ymid5+1, /device
       
              ;Plot new colour bar
              colourbar
              device, get_graphics=old, set_graphics=6   ;Set xor
            endif

   'PHD': if phd1flag2 eq 0 then begin
              if (prevboxflag2 eq 1) and (area2 eq 0) then prevboxflag2=0
              phd1flag2=1
              phdcalc
              device, set_graphics=old  ;Disable xor for plotting
              tvscl, im4, xmid5+1, ymid5+1, /device
       
              ;Plot new colour bar
              colourbar
              device, get_graphics=old, set_graphics=6   ;Set xor
            endif

   'PHD_SEL': begin
                phd_sel
                ;Replot everything
                calcall
              end
   
   'HIST_RECT': begin
       ;histrectflag2=1 ;For draw_win_event
       ;WIDGET_CONTROL, base, sensitive=0 ;Desensitise the widget events
       WIDGET_CONTROL, title_label, $
                       SET_VALUE='     X        Y                Cts'
       x0=fix(xmid2+xtop2)/2 & y0=fix(ymid2+ytop2)/2 ;Start posn
       x1=x0 & y1=y0;Start size=0
       ;Set motion limits
       xlo2=xmid2+1 & xhi2=xtop2-1
       ylo2=ymid2+1 & yhi2=ytop2-1

       tvcrs, x0, y0, /device
       button=0
       goto, middle

       while 1 do begin
         old_button=button
         cursor, x, y, /change, /dev ;Wait for button change or move, get x,y
         imx2=x-xmid2-1 & imy2=y-ymid2-1
         imx2=imx2>0 & imx2=imx2<(ximsize2-1)
         imy2=imy2>0 & imy2=imy2<(yimsize2-1)
         WIDGET_CONTROL, val_label, $
          SET_VALUE=STRING([xhistx5(imx2), yhisty5(imy2), im4(imx2, imy2)],$
                           format='("(", F6.2, ",", F6.2, ")", I)')
         button=!err
         if (old_button eq 0) and (button eq 1) then begin
           x0=x & y0=y  ;For dragging, mouse locn.
         endif
         if !err eq 1 then begin ;If left button
           x1=x & y1=y
         endif
         plots, px, py, /dev  ;Erase previous box
         empty
        
         if !err eq 4 then begin ;Ready to call zoomplot
           if x1 lt x0 then begin
             temp=x0 & x0=x1 & x1=temp
           endif
           if y1 lt y0 then begin
             temp=y0 & y0=y1 & y1=temp
           endif
           x0=x0-xmid2-1 & y0=y0-ymid2-1 ;im4 co-ords
           x1=x1-xmid2-1 & y1=y1-ymid2-1
           xmasklo2=fix(long(x0)*zoomdiv2/256L+xcurroffset2)
           xmaskhi2=fix(long(x1+1)*zoomdiv2/256L+xcurroffset2-1L)
           ymasklo2=fix(long(y0)*zoomdiv2/256L+ycurroffset2)
           ymaskhi2=fix(long(y1+1)*zoomdiv2/256L+ycurroffset2-1L)
           cursor, x, y, /UP, /dev ;Await button release
           tvcrs ;Switch off mouse
           calcall
           WIDGET_CONTROL, base, /clear_events ;Kill the waiting mouse events
           return
         endif
         
         middle:
         x1=x1>xlo2 & x1=x1<xhi2
         y1=y1>ylo2 & y1=y1<yhi2
         px=[x0, x1, x1, x0, x0]
         py=[y0, y0, y1, y1, y0]
         plots, px, py, /dev        ;Draw the new box
         ;wait, .1
       endwhile
       
       end
   
   'COLOUR': xloadct
   
   ;'PCL': hcopy, eventval
   'ps': hcopy, eventval

   'VIEW_NORMAL': begin
     viewflag2=0
     case fileflag2 of
       0: read_raw1
       1: read_raw2
       2: read_xy
       3: read_yx
     endcase
   end

   'VIEW_SPIRAL': begin
     viewflag2=1
     case fileflag2 of
       0: read_raw1
       1: read_raw2
       2: read_xy
       3: read_yx
     endcase
   end

   'VIEW_RTHETA': begin
     viewflag2=2
     case fileflag2 of
       0: read_raw1
       1: read_raw2
       2: read_xy
       3: read_yx
     endcase
   end

   'VIEW_SPECTRUM': begin
     viewflag2=3
	WIDGET_CONTROL, butt_array, sensitive=1
     case fileflag2 of
       0: read_raw1
       1: read_raw2
       2: read_xy
       3: read_yx
     endcase
   end

   'WRITE_XVALUE': begin
;	Output data array for use in other contexts
      xvalfile=pickfile(/write,filter='*.spc')
      openw,2,xvalfile
      writeflag2=1
     case fileflag2 of
       0: read_raw1
       1: read_raw2
       2: read_xy
       3: read_yx
      endcase
   end

ENDCASE

END

;------------------- SPANIMAL ------------------------------------

PRO spanimal, GROUP=GROUP

; This is the procedure that creates a draw widget that returns
; motion events.

; The COMMON block is used because the event handler needs
; widget ID's of the labels:

COMMON DEFAULTS, ximsize2, yimsize2, ch0gain5, ch1gain5, ch2gain5,$
                 xoffset4, yoffset4, xfullscale4, yfullscale4, sumdiv4,$
		 xy0gain5, xy1gain5, xy2gain5,$
                 wszxoffset5, wszyoffset5, wszxscale5, wszyscale5,$
                 wszsumscale5, fileflag2, viewflag2, pseudosum2,$
		 percent5, stop5, start5, k5, phi5,$
                 acqprognam
COMMON LABELS, title_label, val_label, base, butt_quit, butt_load, butt_acq, butt_unzoom, butt_phd,$
               butt_sel, butt_rect, butt_hard, butt_view, butt_col, draw
COMMON XVAL, writeflag2, butt_array
COMMON ARRY, im4, xhist4, yhist4, sumhist4, old, sumlim1,$
             wheredisp4, histident2, xhistx5, yhisty5, wholefileflag2
COMMON ZOOM, x0, y0, nx, ny, col, xbot2, ybot2, xmid2, ymid2, xtop2, ytop2, $
         boxmode2, px, py, prevboxflag2, xlo2, ylo2, xhi2, yhi2, area2,$
         histrectflag2
COMMON IMSTUFF, sum1, xarr2, yarr2, phd1flag2, nfile4, flnam,$
                zoomdiv2, xcurroffset2, ycurroffset2,$
                xmasklo2, xmaskhi2, ymasklo2, ymaskhi2,$
                nwind4, ndisp4
COMMON XVAL, writeflag2, butt_array
     
;Clear previous titles
!p.title=' '
!x.title=' '
!y.title=' '

;----------- Set up variables ------------------
read_dfl
x_size = ximsize2+208 & y_size = yimsize2+138
im4=lonarr(ximsize2, yimsize2)
xhist4=lonarr(ximsize2) & yhist4=lonarr(yimsize2) & sumhist4=lonarr(64)
xhistx5=findgen(ximsize2) & yhisty5=findgen(yimsize2)

sumlim1=[0, 63]
phd1flag2=0  ;Default at startup
histrectflag2=0
fileflag2=0 & viewflag2=0 ;Normal image
writeflag2=0	;for writing xvalue array

nfile4=0L
wheredisp4=[-1]
zoomdiv2=16384
xmasklo2=0 & xmaskhi2=32767
ymasklo2=0 & ymaskhi2=32767
xcurroffset2=0 & ycurroffset2=0

; Initialise window stuff
if !version.os eq 'windows' then set_plot, 'win' $  
  else set_plot, 'x' ;In case previously set to something else

;Zoom box stuff
col=!d.table_size-1 & boxmode2=0   ;Parameters for selecting zoom box
nx=0 & ny=0
boxmode2=0 & prevboxflag2=0 & area2=-1

; A top-level base widget
; will be created.  The size is left unspecified until the draw widget
; is created:

base = WIDGET_BASE( $
              TITLE = 'SPANIMAL - the SPiral ANode IMage AnaLyser', /COLUMN)
  butt_disp=widget_base(base, /ROW)
    butt=widget_base(butt_disp, /COLUMN)
    ; The 'DONE' button:
    butt_quit = WIDGET_BUTTON(butt, $
                UVALUE = 'QUIT', $
                VALUE = 'QUIT')

    ; The 'LOAD' button:
    butt_load = WIDGET_BUTTON(butt, $
                VALUE = 'Load', /MENU)
      raw1_opt=WIDGET_BUTTON(butt_load, VALUE='W1-S1-Z1', UVALUE='LOAD_RAW1')
      raw2_opt=WIDGET_BUTTON(butt_load, VALUE='X2-Y2-Z2', UVALUE='LOAD_RAW2')
      xy_opt=  WIDGET_BUTTON(butt_load, VALUE='X1-Y1', UVALUE='LOAD_XY')
      yx_opt=WIDGET_BUTTON(butt_load, VALUE='Y1-X1', UVALUE='LOAD_YX')

    ; The 'Acquire' button:
    if !version.os eq 'windows' then butt_acq = WIDGET_BUTTON(butt, $
                                                  UVALUE = 'ACQUIRE', $
                                                  VALUE = 'Acquire')

    ; The 'SAVE' button:
    ;butt_save = WIDGET_BUTTON(butt, $
    ;            UVALUE = 'SAVE', $
    ;            VALUE = 'Save')

    ; A dummy button for button grouping:
    butt_dummy = WIDGET_BUTTON(butt,$
                 UVALUE = 'DUMMY', $
                 VALUE = ' ')

    ; The 'Unzoom' button:
    butt_unzoom = WIDGET_BUTTON(butt, $
                UVALUE = 'UNZOOM', $
                VALUE = 'Unzoom')

    ; The 'PHD/int' button:
    butt_phd = WIDGET_BUTTON(butt, $
                VALUE = 'PHD/Intensity', /MENU)
      inten_opt= WIDGET_BUTTON(butt_phd, VALUE='Intensity', UVALUE='INTEN')
      phd_opt= WIDGET_BUTTON(butt_phd, VALUE='PHD', UVALUE='PHD')

    ; The 'PHD Select' button:
    butt_sel = WIDGET_BUTTON(butt, $
                UVALUE = 'PHD_SEL', $
                VALUE = 'PHD Select')

    ; The 'Hist Rectangle' button:
    butt_rect = WIDGET_BUTTON(butt, $
                UVALUE = 'HIST_RECT', $
                VALUE = 'Hist Rectangle')

    ; A dummy button for button grouping:
    butt_dummy2 = WIDGET_BUTTON(butt,$
                  UVALUE = 'DUMMY', $
                  VALUE = ' ')

    ; The 'Colour' button:
    butt_col = WIDGET_BUTTON(butt, $
                  UVALUE = 'COLOUR', $
                VALUE = 'Colour')

    ; The 'Hardcopy' button:
    butt_hard = WIDGET_BUTTON(butt, $
                  UVALUE= 'ps',$
                  VALUE = 'Hardcopy')
      ;pcl_opt= WIDGET_BUTTON(butt_hard, VALUE='PCL file', UVALUE='PCL')
      ;ps_opt= WIDGET_BUTTON(butt_hard, VALUE='PS file', UVALUE='ps')

    ; The 'Change View' button:
    butt_view = WIDGET_BUTTON(butt, $
                VALUE = 'Change View', /MENU)
      defl_opt= WIDGET_BUTTON(butt_view, VALUE='Normal',UVALUE='VIEW_NORMAL')
      spir_opt= WIDGET_BUTTON(butt_view, VALUE='Spiral',UVALUE='VIEW_SPIRAL')
      rthe_opt= WIDGET_BUTTON(butt_view, VALUE='R/Theta',UVALUE='VIEW_RTHETA')
    spec_opt=WIDGET_BUTTON(butt_view,VALUE='Spectrum',UVALUE='VIEW_SPECTRUM')

    ; A dummy button for button grouping:
    butt_dummy3 = WIDGET_BUTTON(butt,$
                  UVALUE = 'DUMMY', $
                  VALUE = ' ')

    ; The 'Print Out Array' button:
    butt_array = WIDGET_BUTTON(butt, $
		UVALUE = 'WRITE_XVALUE',$
		VALUE = 'Write Xvalues')

    ; Create the labels that will display the current x and y
    ; coordinates, leaving the value blank for now:

  ; A widget called 'draw' is created:
  draw = WIDGET_DRAW(butt_disp, $
        /FRAME, $
        /MOTION_EVENTS, $               ;generate LOTS of events
        /button_events, $
        UVALUE = 'DRAW_WIN_EVENT', $
        RETAIN = 2, $                   ;make sure window redraws when covered
        XSIZE = x_size, $
        YSIZE = y_size)

title_label = WIDGET_LABEL(base, /FRAME, $
                VALUE='')

val_label = WIDGET_LABEL(base, /FRAME, $
                VALUE='')

; Realize the widgets:
WIDGET_CONTROL, base, /REALIZE
WIDGET_CONTROL, butt_dummy, sensitive=0
WIDGET_CONTROL, butt_dummy2, sensitive=0

;Prevent crashes
WIDGET_CONTROL, butt_unzoom, sensitive=0
WIDGET_CONTROL, butt_phd, sensitive=0
WIDGET_CONTROL, butt_sel, sensitive=0
WIDGET_CONTROL, butt_rect, sensitive=0
WIDGET_CONTROL, butt_hard, sensitive=0
WIDGET_CONTROL, butt_view, sensitive=0
WIDGET_CONTROL, butt_array, sensitive=0
WIDGET_CONTROL, draw, sensitive=0

; Get the window number from the draw widget.  This can only be done
; after the widget has been realized:
WIDGET_CONTROL, draw, GET_VALUE=win_num2
; Use TVSCL to display an image in the draw widget.  Set the window for
; the TVSCL command since there may be other draw windows.

;Screen positions. N.B. Must be floating pt. with 0.5 added to avoid
;rounding errors
xbot2=72 & ybot2=32
xmid2=xbot2+65 & ymid2=ybot2+65
xtop2=xmid2+ximsize2+1 & ytop2=ymid2+yimsize2+1

WSET, win_num2
;Plot frame to make it look nice
plots, [xbot2, xtop2, xtop2, xbot2, xbot2],$
       [ybot2, ybot2, ytop2, ytop2, ybot2],$
       col=col, /dev, thick=1, lines=0
plots, [xbot2, xtop2], [ymid2, ymid2], col=col, /dev, thick=1, lines=0
plots, [xmid2, xmid2], [ybot2, ytop2], col=col, /dev, thick=1, lines=0
device, get_graphics=old, set_graphics=6   ;Set xor

; Hand off control of the widget to the XMANAGER:
XMANAGER, "spanimal", base, GROUP_LEADER=GROUP

device, set_graphics=old

END
