;+
; Project     : SOHO - CDS     
;                   
; Name        : Alice Breeveld
;               
; Purpose     : Program to find out how long a raw file should be
;		to give statistics on a weak line, to a certain
;		level of accuracy.
;               
; Explanation : Assumes Poisson statistics
;               
; Use         : For GIS raw data collection
;    
; Inputs      : Count rate in weak line, Count rate in detector
;		Accuracy required
;               
; Opt. Inputs : 140 c/s maximum raw data rate
;               
; Outputs     : Length of file in numbers of events or time
;               
; Opt. Outputs: 
;               
; Keywords    : 
;
; Calls       :
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : 
;               
; Prev. Hist. : None
;
; Written     : 26th September 1995
;               
; Modified    : changed data rate collection time on 17/11/95
;
; Version     : 2
;-            

t=140	;transmission rate for raw data
print,'Please give some facts'
read,'What is the count rate (/sec) in the weak line? ',w
read,'What is the mean processed count rate (/sec) for the whole detector? ',c
read,'To what accuracy do you need to measure the weak line? (in %) ',a
a=float(a)
c=float(c)
w=float(w)
;
n=(100.0/a)^2	;no. of events needed in the weak line
;
l=(n*c)/w	;no. of events in file
;
if (c ge t) then begin
time=l/t	;time to capture raw file
endif else begin
time=l/c	
endelse
;
print,'The file needs to contain ',l,' events'
print,'and will take ',time,' seconds or ',time/60.0,' minutes to capture'
;
end



