;
 PRO bj_err, X, DX, Y, DY, ICOL
;
; plot out symmetric error-bars - based on ERRPLOT from user-library
;
   on_error,2                      ;Return to caller if an error occurs
;
 IF ( N_PARAMS () EQ 4 ) THEN ICOL = 1
 IF ( ( N_PARAMS () EQ 4 ) and ( !d.name eq 'X' ) ) THEN ICOL = 255
;
   xmin = min(!x.crange)   ;X range
   xmax = max(!x.crange)
   ymax = max(!y.crange)   ;Y range
   ymin = min(!y.crange)
   width = 0.00125           ;kept for convenience!

   if !x.type eq 0 then begin   ;Test for x linear
         ;Linear in x
      width =  (xmax - xmin) * width ;bars = .01 of plot wide.
   endif else begin      ;Logarithmic X
      xmax = 10.^xmax
      xmin = 10.^xmin
      width  = (xmax/xmin)* width  ;bars = .01 of plot wide
   endelse
;
   for i=0,n_elements(x)-1 do begin   ;do each point.
      xx = x(i)   ;x value
      yy = y(i)   ;y value
      wid = dx(i)
      down = yy - dy(i)
      up = yy + dy(i)
      if (xx ge xmin) and (xx le xmax) then begin
         plots,[xx-width,xx+width,xx,xx,xx-width,xx+width,xx,xx,xx-wid,xx+wid],$
               [down,down,down,up,up,up,up,yy,yy,yy], COLOR = ICOL, NOCLIP = 0
      endif
   endfor
;
 return
;
 end
;
