;
 PRO cds_lines, wave, spec, glfit, gwfit, ghfit, gxfit, gbfit, gcfit, elfit, $
                            ewfit, ehfit, ecfit
;
 if ( n_params () lt 8 ) then begin
     print, ' '
     print, '     ERROR: Too few parameters!'
     return
 endif
;
 imode = 0

 if ( n_params () gt 8 ) then imode = 1
;
 l0 = glfit
;
 nlines = n_elements ( l0 )
;
 lp = fltarr ( nlines )
 lw = lp
 lh = lp
 lx = lp
 lb = lp
 lc = fltarr ( 3, nlines )
 el = lp
 eh = lp
 ew = lp
 ec = lc
;
 nsel = 0
;
 print, ' '
 print, '      Checking ...  ', nlines, ' possible line identifications!'
;
 dw = ( wave ( 1 ) - wave ( 0 ) )
 wdiff = 3.175 * dw
;;; rej_wid = 1.75 * dw
;;; rej_wid_min = 0.125 * dw
 rej_wid = 4.875 * dw
 rej_wid_min = 0.25 * dw
 rej_x = 13.75 * ( wave ( 1 ) - wave ( 0 ) )
 rej_bgd = -50.0
;
 wz = where ( spec gt 0 )
 rej_h = 0.75 * sqrt ( min ( spec ( wz ) ) )
;
 print, ' '
 print, '   Rejecting on ...'
 print, '                      Wavelength Difference = ', wdiff
;
 stxt = string ( format =                                                     $
              '( 15X,"ABS ( Fitted line Width ) < ", f6.4, " & > ", f6.4 )',  $
                 rej_wid_min, rej_wid )
;
 print, stxt
 print, '                      Abs ( Fitted X Pixel ) > ', rej_x
 print, '                      Fitted Line Height < ', rej_h
 print, '                      Estimated Continuum < ', rej_bgd
;
 for i = 0, nlines - 1 do begin
;
     ggw = abs ( gwfit ( i ) )
     if ( ( ggw lt rej_wid_min ) or ( ggw gt rej_wid ) ) then goto, rcont
;
     if ( abs ( gxfit ( i ) ) gt rej_x ) then goto, rcont
;
     if ( ghfit ( i ) lt rej_h ) then goto, rcont
;
     if ( gbfit ( i ) lt rej_bgd ) then goto, rcont
;
     lp ( nsel ) = glfit ( i )
     lw ( nsel ) = gwfit ( i )
     lh ( nsel ) = ghfit ( i )
     lx ( nsel ) = gxfit ( i )
     lb ( nsel ) = gbfit ( i )
     lc ( 0:2, nsel ) = gcfit ( 0:2, i )
;
     if ( imode eq 1 ) then begin
         el ( nsel ) = elfit ( i )
         ew ( nsel ) = ewfit ( i )
         eh ( nsel ) = ehfit ( i )
         ec ( 0:2, nsel ) = ecfit ( 0:2, i )
     endif
;
     nsel = nsel + 1
;
 rcont:
;
 endfor
;
 lp = lp ( 0:nsel-1 )
 lw = lw ( 0:nsel-1 )
 lh = lh ( 0:nsel-1 )
 lx = lx ( 0:nsel-1 )
 lb = lb ( 0:nsel-1 )
 lc = lc ( 0:2, 0:nsel-1 )
;
 if ( imode eq 1 ) then begin
     el = el ( 0:nsel-1 )
     eh = eh ( 0:nsel-1 )
     ew = ew ( 0:nsel-1 )
     ec = ec ( 0:2, 0:nsel-1 )
 endif
;
 iws = sort ( lp )
;
 glfit = lp ( iws )
 gwfit = lw ( iws )
 ghfit = lh ( iws )
 gxfit = lx ( iws )
 gbfit = lb ( iws )
 gcfit = lc ( 0:2, iws )
;
 if ( imode eq 1 ) then begin
     elfit = el ( iws )
     ewfit = ew ( iws )
     ehfit = eh ( iws )
     ecfit = ec ( 0:2, iws )
 endif
;
 nlines = nsel
;
 lp = fltarr ( nlines )
 lw = lp
 lh = lp
 lx = lp
 lb = lp
 lc = fltarr ( 3, nlines )
 el = lp
 eh = lp
 ew = lp
 ec = lc
;
 nsel = 0
;
 l0 = glfit
;
 for i = 0, nlines - 1 do begin
;
     ll = l0 ( i )
     l0 ( i ) = 9999.99
;
     dl = l0 - ll
     dl2 = dl * dl
;
     lmin = sqrt ( min ( dl2 ) )
;
     if ( lmin gt wdiff ) then begin
         lp ( nsel ) = ll
         lw ( nsel ) = gwfit ( i )
         lh ( nsel ) = ghfit ( i )
         lx ( nsel ) = gxfit ( i )
         lb ( nsel ) = gbfit ( i )
         lc ( 0:2, nsel ) = gcfit ( 0:2, i )
;
         if ( imode eq 1 ) then begin
             el ( nsel ) = elfit ( i )
             ew ( nsel ) = ewfit ( i )
             eh ( nsel ) = ehfit ( i )
             ec ( 0:2, nsel ) = ecfit ( 0:2, i )
         endif
     endif else begin
         wz = where ( sqrt ( dl2 ) le wdiff )
;
         xmin = min ( abs ( gxfit ( wz ) ) )
;;;         hmax = max ( ghfit ( wz ) )
;
         iw = wz ( !c )
         lp ( nsel ) = glfit ( iw )
         lw ( nsel ) = gwfit ( iw )
         lh ( nsel ) = ghfit ( iw )
         lx ( nsel ) = gxfit ( iw )
         lb ( nsel ) = gbfit ( iw )
         lc ( 0:2, nsel ) = gcfit ( 0:2, iw )
;
         if ( imode eq 1 ) then begin
             el ( nsel ) = elfit ( iw )
             ew ( nsel ) = ewfit ( iw )
             eh ( nsel ) = ehfit ( iw )
             ec ( 0:2, nsel ) = ecfit ( 0:2, iw )
         endif
     endelse
;
     if ( nsel gt 1 ) then begin
         dp = lp ( 0:nsel-1 ) - lp ( nsel )
         dp2 = dp * dp
         if ( sqrt ( min ( dp2 ) ) gt wdiff ) then nsel = nsel + 1
     endif
;
     if ( nsel eq 1 ) then begin
         dp = lp ( 0 ) - lp ( nsel )
         dp2 = dp * dp
         if ( sqrt ( min ( dp2 ) ) gt wdiff ) then nsel = nsel + 1
     endif
;
     if ( nsel eq 0 ) then nsel = nsel + 1
;
 endfor
;
 lp = lp ( 0:nsel-1 )
 lw = lw ( 0:nsel-1 )
 lh = lh ( 0:nsel-1 )
 lx = lx ( 0:nsel-1 )
 lb = lb ( 0:nsel-1 )
 lc = lc ( 0:2, 0:nsel-1 )
;
 if ( imode eq 1 ) then begin
     el = el ( 0:nsel-1 )
     eh = eh ( 0:nsel-1 )
     ew = ew ( 0:nsel-1 )
     ec = ec ( 0:2, 0:nsel-1 )
 endif
;
 iws = sort ( lp )
;
 glfit = lp ( iws )
 gwfit = lw ( iws )
 ghfit = lh ( iws )
 gxfit = lx ( iws )
 gbfit = lb ( iws )
 gcfit = lc ( 0:2, iws )
;
 if ( imode eq 1 ) then begin
     elfit = el ( iws )
     ewfit = ew ( iws )
     ehfit = eh ( iws )
     ecfit = ec ( 0:2, iws )
 endif
;
 print, ' '
 print, '          ... reduced list to ... ', nsel, ' lines!!'
;
 end
;
