;
 PRO cds_multig, x, y, dy, gpar, gperr, wcen, thres, quiet = quiet,           $
                 noprint = noprint, fint = fint, ferr = ferr, cint = cint,    $
                 cerr = cerr
;
 gpar = 0
 gperr = 0
;
 iprint = 1
 iplot = 1
;
 if keyword_set ( quiet ) then iprint = 0
 if keyword_set ( noprint ) then iplot = 0
;
 if ( iplot eq 0 ) then iprint = 0
;
 !p.title = string (format='("CDS-FIT: @",f7.3, " Ang.")', wcen )
;
 fit_back, x, y, yc, cf
;
 bb = poly ( x, cf )
;
 npix = n_elements ( x )
;
 if ( y ( 0 ) gt ( bb ( 0 ) + 0.5 * dy ( 0 ) ) ) then begin
     y ( 0 ) = bb ( 0 )
     if ( y ( 1 ) gt ( bb ( 1 ) + 0.5 * dy ( 1 ) ) ) then                 $
         y ( 1 ) = bb ( 1 )
 endif
;
 if ( y ( npix-1 ) gt ( bb ( npix-1 ) + 0.5 * dy ( npix-1 ) ) ) then begin
     y ( npix-1 ) = bb ( npix-1 )
     if ( y ( npix-2 ) gt ( bb ( npix-2 ) + 0.5 * dy ( npix-2 ) ) ) then  $
         y ( npix-2 ) = bb ( npix-2 )
 endif
;
 ymin0 = min ( y )
 ymax0 = max ( y )
;
 ymarg = 0.125 * ( ymax0 - ymin0 )
;
 ymin = ymin0 - 0.5 * ymarg
 ymax = ymax0 + 1.375 * ymarg
;
 if ( iplot ) then plot, x + wcen, y, psym = 10, xstyle = 1,                 $
                         yrange = [ ymin, ymax ], ystyle = 1
;
 find_g_arc, x, y, wg, wgh, cf, nwg
;
 if ( ( iprint eq 1 ) and ( max ( wgh ) lt thres ) ) then begin
     print, ' '
     print, '    Data less than Threshold (', thres, ') - NO FITTING DONE!'
     return
 endif
;
 if ( max ( wgh ) lt thres ) then return
;
 iwg = where ( wgh gt thres )
;
 wg = wg ( iwg )
 wgh = wgh ( iwg )
 nwg = n_elements ( iwg )
;
 bb = poly ( x, cf )
;
 if ( iplot ) then oplot, x ( wg ) + wcen, y ( wg ), psym = 6, symsize = 1.5
;
;;; if ( iplot ) then oplot, x + wcen, bb, color = 32
;
 if ( nwg lt 2 ) then begin
     gf = oneg_afit ( x, y, gpar, gperr )
;
     cf = gpar ( 3:5 )
;
     yd = ( y - gf ) / dy 
;
     chi2 = total ( yd * yd ) 
;
     if ( iplot ) then oplot, x + wcen, gf, color = 188
;
     if ( iprint ) then print, ' '
     if ( iprint ) then print, '   Fit 1:   Chi2 = ', chi2
 endif else begin
     a = fltarr ( 6 )
     chi2 = 999999.9999
 endelse
;
 tchi = 24.
;
 ymx = max ( y )
;
 if ( ymx gt 500. ) then tchi = 30.
 if ( ymx gt 1000. ) then tchi = 60.
 if ( ymx gt 1500. ) then tchi = 120.
 if ( ymx gt 2000. ) then tchi = 200.
 if ( ymx gt 2500. ) then tchi = 300.
 if ( ymx gt 3000. ) then tchi = 400.
 if ( ymx gt 4000. ) then tchi = 500.
 if ( ymx gt 5000. ) then tchi = 650.
 if ( ymx gt 6000. ) then tchi = 800.
 if ( ymx gt 7000. ) then tchi = 950.
 if ( ymx gt 8000. ) then tchi = 1200.
 if ( ymx gt 9000. ) then tchi = 1600.
 if ( ymx gt 10000. ) then tchi = 2500.
 if ( ymx gt 12500. ) then tchi = 5000.
 if ( ymx gt 15000. ) then tchi = 75000.
 if ( ymx gt 17500. ) then tchi = 15000.
 if ( ymx gt 20000. ) then tchi = 20000.
;
 if ( ( chi2 gt tchi ) or ( nwg gt 1 ) ) then begin
;
     ochi2 = chi2
;
     ye = 0. * y + 3.
     ynz = where ( y gt 10. )
     if ( ynz ( 0 ) gt -1 ) then ye ( ynz ) = sqrt ( y ( ynz ) )
     cf = poly_fit ( x, y, 1, yc )
;
     ifit = 0
;
 cfit:
;
     nord = 1
     if ( ifit gt 2 ) then nord = 2
;
     wz = where ( ( y - 3. * ye ) lt yc  )
     if ( n_elements ( wz ) lt 4 ) then goto, rfit
;
     cf = poly_fit ( x ( wz ), y ( wz ), nord, ycf )
     yd = y ( wz ) - ycf
     chi2 = total ( yd * yd ) / float ( n_elements ( wz ) - 2 )
;
     yc = poly ( x, cf )
     ifit = ifit + 1
;
;;;     if ( iplot ) then oplot, x + wcen, yc, color = 36 + ifit * 24
;
     if ( ( chi2 gt 64.0 ) and ( ifit lt 7 ) ) then goto, cfit
;
 rfit:
;
     yf = twog_afit ( x, y, a2, sigmaa )
;
     if ( iplot ) then oplot, x + wcen, yf, color = 208
;
     cf = a2 ( 6:8 )
;
     yd = ( y - yf ) / dy
;
     chi2 = total ( yd * yd ) 
;
     if ( iprint ) then print, ' '
     if ( iprint ) then print, '   Fit 2:   Chi2 = ', chi2
;
     if ( chi2 lt ochi2 ) then begin
         gpar = a2
         gperr = sigmaa
         ochi2 = chi2
     endif
;
     if ( chi2 gt 1.0e+10 ) then begin
         yf = twog_fit ( x, y, a2, sigmaa )
;
         if ( iplot ) then oplot, x + wcen, yf, color = 220
;
         gpar = a2
         gperr = sigmaa
;
         cf = a2 ( 6:8 )
;
         yd = ( y - yf ) / dy
;
         chi2 = total ( yd * yd ) 
;
         if ( iprint ) then print, '   Fit 2B:   Chi2 = ', chi2
;
         if ( chi2 lt ochi2 ) then begin
             gpar = a2
             gperr = sigmaa
             ochi2 = chi2
         endif
     endif
;
     if ( ( nwg gt 2 ) or ( chi2 gt 3. * tchi ) ) then begin
;
         yf2 = threeg_afit ( x, y, a3, sigmaa )
;
         if ( iplot ) then oplot, x + wcen, yf2, color = 196
;
         cf = a3 ( 9:11 )
;
         yd = ( y - yf2 ) / dy
;
         chi2 = total ( yd * yd ) 
;
         gflag = 0
         if ( min ( a3 ) lt -1.0e06 ) then gflag = 1
         if ( max ( a3 ) gt 1.0e06 ) then gflag = 1
;
         if ( ( chi2 gt 1.0e09 ) or ( gflag eq 1 ) ) then begin
             if ( iprint ) then print, ' '
             if ( iprint ) then print, '      **** BAD FIT!'
             if ( iprint ) then print, '                     Chi2 = ', chi2
             if ( iprint ) then print, '                     Ymax = ', ymx
             if ( iprint ) then print, ' '
             if ( iprint ) then print, '   Resetting to 2 Gaussian Fit!'
             if ( iprint ) then print, ' '
;
             a3 ( 0:5 ) = a2 ( 0:5 )
             cf = a2 ( 6:8 )
         endif else begin
             if ( chi2 lt ochi2 ) then begin
                 gpar = a3
                 gperr = sigmaa
                 ochi2 = chi2
             endif
         endelse
;
         if ( iprint ) then print, '   Fit 3:   Chi2 = ', chi2
;
     endif
;
 endif
;
 nofit3:
;
 ngpar = n_elements ( gpar )
;
 nfl = ( ngpar - 3 ) / 3
;
 iwl = 3 * indgen ( nfl )
;
 xf = gpar ( iwl+1 )
;
 if ( nfl eq 1 ) then xf = [ xf, xf ]
;
 gcf = gpar ( ngpar-3:ngpar-1 )
;
 bb = poly ( xf, gcf )
;
 if ( nfl eq 1 ) then bb = bb ( 0 )
;
 gpar ( iwl+1 ) = gpar ( iwl+1 ) + wcen
; 
 gfit_error, x, y, gpar, gperr, wcen, gfint, gferr, gcint, gcerr, /quiet
;
 gw = gpar ( iwl+1 )
 gx = gw - wcen
 gh = gpar ( iwl )
 gw = gpar ( iwl+2 )
;
 nxp = 251
 if ( !d.name eq 'PS' ) then nxp = 501
;
 dyt = 0.0275 * ( !y.crange ( 1 ) - !y.crange ( 0 ) )
;
 dx = ( x ( npix-1 ) - x ( 0 ) ) / float ( nxp - 1 )
;
 xx = x ( 0 ) + dx * findgen ( nxp )
;
 backg = poly ( x, gcf )
 bgnd = poly ( xx, gcf )
;
 xw = xx + wcen
;
 for j = 0, nfl - 1 do begin
;
     gcnt = get_gauss ( x, gx ( j ), gh ( j ), gw ( j ) )
     gg = get_gauss ( xx, gx ( j ), gh ( j ), gw ( j ) )
;
     if ( iplot ) then oplot, xw, bgnd + gg, thick = 4.0, color = 64
;
     iw = where ( gcnt gt 0.0275 * gh ( j ) )
     if ( gh ( j ) gt 2000.0 ) then iw = where ( gcnt gt 0.0175 * gh ( j ) )
;
     if ( ( iprint eq 1 ) and ( iw ( 0 ) ne -1 ) ) then                       $
         oplot, x ( iw ) + wcen, backg ( iw ) - 0.5 * dyt, psym = 4 + j
; 
     jcol = 80 + j * 48
;
     if ( iplot ) then begin
         for k = 0, nxp-1 do oplot, [ xw ( k ), xw ( k ) ],                 $
             [ bgnd ( k ), bgnd ( k ) + gg ( k ) ], color = jcol
     endif
;
     if ( iplot ) then oplot, xw, bgnd, thick = 2.0, color = 128
;
     tint = string ( format = '( f8.2,"+/-",f6.2 )', gfint ( j ), gferr ( j ) )
     cint = string ( format = '( f8.2,"+/-",f6.2 )', gcint ( j ), gcerr ( j ) )
;
     wy = ( gh ( j ) + bb ( j ) ) + 1.5 * dyt
;
     if ( iprint ) then xyouts, gx ( j ) + wcen, wy, tint, alignment = 0.575
     if ( iprint ) then xyouts, gx ( j ) + wcen, bb ( j ) - 1.875 * dyt, cint, alignment = 0.45
;
 endfor
;
 if ( iplot ) then oplot, x + wcen, y, psym = 10, thick = 3, color = 0
 if ( iplot ) then oplot, x + wcen, y, psym = 10
;
 fint = gfint
 ferr = gferr
 cint = gcint
 cerr = gcerr
;
 if keyword_set ( quiet ) then return
;
 if ( iprint ) then print, ' '
;
 for ig = 0, nfl - 1 do begin
     stxt = string ( format =                                                 $
'( " Line@",f8.3," A. x=",f6.3," Sig=",f7.4," H=",f9.4," Bgnd. =", F7.3," Int.=",f8.3)',    $
         gpar(iwl(ig)+1),gx(ig),gpar(iwl(ig)+2),gpar(iwl(ig)),bb(ig),gfint(ig))
;
     if ( iprint ) then print, stxt
 endfor
;
 end
; 
