FUNCTION cdsgauss, x, a, p, w
;+
; Project     : SOHO - CDS     
;                   
; Name        : gauss()
;               
; Purpose     : Gaussian function
;               
; Explanation : Calculates the gaussian of a function
;               
; Use         : IDL> gauss(x,a,p,w)
;    
; Inputs      : x-array, max-intensity, shift, width
;               
; Opt. Inputs : None 
;               
; Outputs     : Gaussian profile
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None 
;               
; Side effects: None
;               
; Category    : 
;               
; Prev. Hist. : 
;
; Written     : Nils Brynildsen, ITA, UiO 27-May-1993 
;               
; Modified    : Version 1 Nils Brynildsen, ITA, UiO, 27-May-1993
;
; Version     : Version 1  27-May-1993
;-            
y = a*exp(-(x-p)*(x-p)/(w*w))
RETURN, y
END