PRO filter, ys, yr
;+
; Project     : SOHO - CDS     
;                   
; Name        : filter
;               
; Purpose     : fft filtering of data
;               
; Explanation : filtering to reduse the noise in the data
;               
; Use         : IDL> filter, y-array (raw), y-array (filtered) 
;    
; Inputs      : raw y-array
;               
; Opt. Inputs : None
;               
; Outputs     : raw and filtered y-array
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : fft, box_filter
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : ?
;               
; Prev. Hist. : ?
;
; Written     : Olav Kjeldseth-Moe, ITA, UiO 
;               
; Modified    : Version 1 Nils Brynildsen, ITA, UiO, 1-July-1993
;
; Version     : Version 1 1-July-1993
;-            
yu=alog10(ys)
n=n_elements(ys)
cut=0.1
roll=cut/10.0
yft=fft(yu,-1)
yftm=max(yft)
yft=yft/yftm
filt=box_filter(n,cut,roll)
yr=fft(yft*filt,1)
yr=yr*yftm
yr=abs(yr)
yr=10^yr
RETURN
END
