PRO funct_1, x, cf, y, y1, y2, y3
;+
; Project     : SOHO - CDS     
;                   
; Name        : funct_1
;               
; Purpose     : Make the line profile of 1,2 or 3 Gaussians
;               
; Explanation : Calls routines to produce the fitted line profile
;               
; Use         : IDL> funct_1,x-array,parameters for Gaussian(s),
;                           the sum of the Gaussian line profiles,
;                           first Gaussian, second Gaussian,
;                           third Gaussian  
;    
; Inputs      : x-array, parameters of Gaussian
;               
; Opt. Inputs : None
;               
; Outputs     : sum of Gaussians and each individual Gaussian
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : cdsgauss
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : ?
;               
; Prev. Hist. : ?
;
; Written     : Nils Brynildsen, ITA, UiO 29-June-1993
;               
; Modified    : Version 1 Nils Brynildsen, ITA, UiO, 29-June-1993
;
; Version     : Version 1 29-June-1993
;-            
n = N_ELEMENTS(x)
m = N_ELEMENTS(cf)
pd = FLTARR(n,m)

a1 = cf(0)
p1 = cf(1)
w  = cf(2)
IF m GT 3 THEN a2 = cf(3)
IF m GT 3 THEN p2 = cf(4)
IF m GT 5 THEN a3 = cf(5)
IF m GT 5 THEN p3 = cf(6)

y1 = cdsgauss(x,a1,p1,w)
IF m GT 3 THEN y2 = cdsgauss(x,a2,p2,w)
IF m GT 5 THEN y3 = cdsgauss(x,a3,p3,w)
y = y1 
IF m GT 3 THEN y = y + y2
IF m GT 5 THEN y = y + y3
END