FUNCTION gauss_d_a, x, a, p, w
;+
; Project     : SOHO - CDS     
;                   
; Name        : gauss_d_a()
;               
; Purpose     : Calculate the partial derivative of line intensity
;               
; Explanation : Partial derivative of the Gaussian intensity
;               
; Use         : IDL> val = gauss_d_a(x-array,line intensity,
;                          line position (i.e. shift), line width)  
;    
; Inputs      : x-array, intensity, position and width of line
;               
; Opt. Inputs : None
;               
; Outputs     : partial derivative of Gaussian intensity
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : ?
;               
; Prev. Hist. : ?
;
; Written     : Nils Brynildsen, ITA, UiO 1-July-1993
;               
; Modified    : Version 1 Nils Brynildsen, ITA, UiO, 1-July-1993
;
; Version     : Version 1 1-July-1993
;-            

RETURN, exp(-(x-p)*(x-p)/(w*w))
END