FUNCTION gauss_d_w, x, a, p, w
;+
; Project     : SOHO - CDS     
;                   
; Name        : gauss_d_w()
;               
; Purpose     : Calculate the partial derivative of line width 
;               
; Explanation : Partial derivative of the Gaussian width
;               
; Use         : IDL> val = gauss_d_w(x-array,line intensity,
;                          line position (i.e. shift), line width)  
;    
; Inputs      : x-array, intensity, position and width of line
;               
; Opt. Inputs : None
;               
; Outputs     : partial derivative of Gaussian width
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : ?
;               
; Prev. Hist. : ?
;
; Written     : Nils Brynildsen, ITA, UiO 29-June-1993
;               
; Modified    : Version 1 Nils Brynildsen, ITA, UiO, 29-June-1993
;
; Version     : Version 1 29-June-1993
;-            

y = a*exp(-(x-p)*(x-p)/(w*w))
RETURN, 2*y*(x-p)*(x-p)/(w*w*w)
END
;-----------------------------------------