;
 PRO gfit_error, x, y, gpar, gperr, wcen, gfint, gferr, gcint, gcerr,         $
                 quiet = quiet
;
 if ( n_params () eq 4 ) then wcen = 0.0
;
 ngpar = n_elements ( gpar )
;
 nfl = ( ngpar - 3 ) / 3
;
 iwl = 3 * indgen ( nfl )
;
 gcf = gpar ( ngpar-3:ngpar-1 )
 gce = gperr ( ngpar-3:ngpar-1 )
;
 xf = gpar ( iwl+1 )
;
 if ( nfl eq 1 ) then xf = [ xf, xf ]
;
 bb = poly ( xf, gcf )
;
 if ( nfl eq 1 ) then bb = bb ( 0 )
;
 gx = gpar ( iwl+1 )
 gh = gpar ( iwl )
 gw = gpar ( iwl+2 )
 gxerr = gperr ( iwl+1 )
 gherr = gperr ( iwl )
 gwerr = gperr ( iwl+2 )
;
 gfint = fltarr ( nfl )
 gcint = fltarr ( nfl )
 gferr = fltarr ( nfl )
 gcerr = fltarr ( nfl )
;
 gcf1 = gcf
 gcf2 = gcf
;
 gcf1 ( 0 ) = ( gcf ( 0 ) / abs ( gcf ( 0 ) ) ) * abs ( gcf ( 0 ) + gce ( 0 ) )
 gcf1 ( 1 ) = ( gcf ( 1 ) / abs ( gcf ( 1 ) ) ) * abs ( gcf ( 1 ) + gce ( 1 ) )
 gcf1 ( 2 ) = ( gcf ( 2 ) / abs ( gcf ( 2 ) ) ) * abs ( gcf ( 2 ) + gce ( 2 ) )
;
 gcf2 ( 0 ) = ( gcf ( 0 ) / abs ( gcf ( 0 ) ) ) * abs ( gcf ( 0 ) - gce ( 0 ) )
 gcf2 ( 1 ) = ( gcf ( 1 ) / abs ( gcf ( 1 ) ) ) * abs ( gcf ( 1 ) - gce ( 1 ) )
 gcf2 ( 2 ) = ( gcf ( 2 ) / abs ( gcf ( 2 ) ) ) * abs ( gcf ( 2 ) - gce ( 2 ) )
;
 bgnd = poly ( x, gcf )
 bgnd1 = poly ( x, gcf1 )
 bgnd2 = poly ( x, gcf2 )
;
 nxp = 1001
;
 npix = n_elements ( x )
;
 dx = ( x ( npix-1 ) - x ( 0 ) ) / float ( nxp - 1 )
;
 xx = x ( 0 ) + dx * findgen ( nxp )
;
 sf = dx / ( x ( 1 ) - x ( 0 ) ) 
;
 for j = 0, nfl - 1 do begin
;
     gcnt = get_gauss ( xx + wcen, gx ( j ), gh ( j ), gw ( j ) )
     gcntl = get_gauss ( xx + wcen, gx ( j ), gh ( j ) - gherr ( j ),          $
                         gw ( j ) - gwerr ( j ) )
     gcnth = get_gauss ( xx + wcen, gx ( j ), gh ( j ) + gherr ( j ),          $
                         gw ( j ) + gwerr ( j ) )
;
     tgcnt = total ( gcnt * sf )
     tgcntl = total ( gcntl * sf )
     tgcnth = total ( gcnth * sf )
;
     gfint ( j ) = tgcnt
     gferr ( j ) = 0.5 * ( ( tgcnth - tgcnt ) + ( tgcnt - tgcntl ) ) 
;
     gcnt = get_gauss ( x + wcen, gx ( j ), gh ( j ), gw ( j ) )
;
     iw = where ( gcnt gt 0.0275 * gh ( j ) )
     if ( gh ( j ) gt 2000.0 ) then iw = where ( gcnt gt 0.0175 * gh ( j ) )
;
     if ( iw ( 0 ) eq -1 ) then goto, econt
;
     gcint ( j ) = total ( y ( iw ) ) - total ( bgnd ( iw ) )
;
     gcerr ( j ) = 0.5 * (                                                    $
                     abs ( total ( bgnd1 ( iw ) ) - total ( bgnd ( iw ) ) ) + $
                     abs ( total ( bgnd2 ( iw ) ) - total ( bgnd ( iw ) ) ) )
;
 econt:
;
 endfor
;
 if keyword_set ( quiet ) then return
;
 print, ' '
;
 for ig = 0, nfl - 1 do begin
     stxt1 = string ( format =                                                 $
'( " Line@",f8.3,"+/-",f7.5," A. Sig=",f7.4,"+/-",f7.5," H=",f9.4,"+/-",f7.5)',    $
         gx(ig),gxerr(ig),gw(ig),gwerr(ig),gh(ig),gherr(ig))
     stxt2 = string ( format =                                                 $
'( 2x," Fitted Intensity:",f9.3,"+/-",f6.3," Observed Intensity:",f9.3,"+/-",f6.3)',    $
         gfint(ig),gferr(ig),gcint(ig),gcerr(ig))
;
     print, stxt1
     print, stxt2
 endfor
;
 end
; 
