PRO hrts_w_3_0
;+
; Project     : SOHO - CDS     
;                   
; Name        : hrts_w
;               
; Purpose     : Main procedure, makes widgets, calls all procedures
;               
; Explanation : Main 'program'
;               
; Use         : IDL> hrts_w 
;    
; Inputs      : Follow instructions given in IDL window !
;               
; Opt. Inputs : None
;               
; Outputs     : Widget with parameters and fitted line profiles
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : Widget routines, etc.
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : ?
;               
; Prev. Hist. : ?
;
; Written     : Nils Brynildsen, ITA, UiO 29-June-1993
;               
; Modified    : Version 2 Nils Brynildsen, ITA, UiO, 13-Sep.-1993
;
;	3	Changed x-array from x to x - w0 after suggestion
; 		 by Bill Thompson
;	
;	4	This version is for IDL 3.0.0
;
; Version     : Version 4 16-Nov.-1993
;-            
rc = FINDGEN(256) & gc = FINDGEN(256) & bc = FINDGEN(256)
rc(0) = 0   & gc(0) = 0   & bc(0) = 0     ; black
rc(1) = 255 & gc(1) = 0   & bc(1) = 0     ; red
rc(2) = 0   & gc(2) = 255 & bc(2) = 0     ; green 
rc(3) = 0   & gc(3) = 0   & bc(3) = 255   ; blue
rc(4) = 255 & gc(4) = 255 & bc(4) = 255   ; white 
rc(5) = 255 & gc(5) = 255 & bc(5) = 0     ; yellow
TVLCT, rc, gc, bc

dummy = ' ' 
base = WIDGET_BASE(title = 'HRTS (sl415_30s.int)', /ROW)
col  = WIDGET_BASE(base, /FRAME, /COLUMN)

w5    = WIDGET_BASE(col, /ROW)
dum1  = WIDGET_LABEL(w5, VALUE = 'Rl.:')
cur0  = WIDGET_TEXT(w5, XSIZE = 10, YSIZE=1)

wd    = WIDGET_BASE(col, /ROW)
dum   = WIDGET_LABEL(wd, VALUE = '                       logI     v       w      logI     v      logI     v')

w1    = WIDGET_BASE(col, /ROW)
dum1  = WIDGET_LABEL(w1, VALUE = '------------->   ')
cur1  = WIDGET_TEXT(w1, XSIZE = 60, YSIZE=1)

w2    = WIDGET_BASE(col, /ROW)
dum2  = WIDGET_LABEL(w2, VALUE = 'CURVEFIT  (Red): ')
cur2  = WIDGET_TEXT(w2, XSIZE = 60, YSIZE=1)

w3    = WIDGET_BASE(col, /ROW)
dum3  = WIDGET_LABEL(w3, VALUE = 'LSTSQR   (Blue): ')
cur3  = WIDGET_TEXT(w3, XSIZE = 60, YSIZE=1)

w4    = WIDGET_BASE(col, /ROW)
dum4  = WIDGET_LABEL(w4, VALUE = 'AMOEBA  (Green): ')
cur4  = WIDGET_TEXT(w4, XSIZE = 60, YSIZE=1)

w6    = WIDGET_BASE(col, /ROW)
dum6  = WIDGET_LABEL(w6, VALUE = 'MOMENT (Yellow): ')
cur6  = WIDGET_TEXT(w6, XSIZE = 60, YSIZE=1) 

draw  = WIDGET_DRAW(col, xsize=300, ysize=300)

draw2 = WIDGET_DRAW(col, xsize=300, ysize=170)

w0   = WIDGET_BUTTON(col, VALUE = "Done")

WIDGET_CONTROL, base, /REALIZE

  read_hrts_im,inf,anf,image
 
  fname='func_f'
  nx=255 

  read,'Give first and last rl to fit: ',irl1,irl2

  w = FLTARR(nx+1) & w(*) = 1.0 
  xs = anf(1) - 1548.202           ; anf(1)                             
  x = xs + findgen(nx+1)*anf(4)*4.0
  w0 = 1548.202 

  FOR rl = irl1,irl2 DO BEGIN   ; 130,150 160,180
   y = image(0:nx,rl-2)

   filter,y,yf
   yu = y
   y = yf

   PRINT,rl   
   y = 10.0^y                      
   back = 158.5  ; 0, 100.0
   y = y - back

   WIDGET_CONTROL, GET_VALUE = window, draw
   WSET, window
   SET_XY,1547.5,1549.5,2.,6.
   PLOT,x+w0,alog10(y+back),COLOR=0,BACK=128 ;255
   OPLOT,x+w0,yu,COLOR=4
   PLOTS,[1548.715,1548.715],[2.1,2.3],COLOR=0
   PLOTS,[1548.202,1548.202],[2.1,2.3],COLOR=0
fit:
   read,'How many components in fit ? ',na
   na = 2*na + 1

;   y(where(y LT 2.21)) = 0.0
;   back = 0.0
 
   a = fltarr(na)
   a(0) = 0.9*max(y)                          
   a(1) = 0.05   ; w0 + 0.05
   a(2) = 0.1
   IF na GT 3 THEN a(3) = 0.5*a(0)
   IF na GT 3 THEN a(4) = 0.3        ;w0 + 0.3
   IF na GT 5 THEN a(5) = 0.5*a(0)
   IF na GT 5 THEN a(6) = 0.5        ;w0 + 0.5

   y_c = y
   a_c = a
   y_c = CURVEFIT(x,y_c,w,a_c,sigma,FUNCTION_NAME='functn')  ; red
   a_c(1) = a_c(1) + w0
   IF na GT 3 THEN a_c(4) = a_c(4) + w0 
   IF na GT 5 THEN a_c(6) = a_c(6) + w0
   FUNCT_1,x+w0,a_c,y_c,y_c1,y_c2,y_c3

 y_l = y
 a_l = a
 LSTSQR,x,y_l,fname,a_l,noprint=1                            ; blue
 a_l(1) = a_l(1) + w0
 IF na GT 3 THEN  a_l(4) = a_l(4) + w0 
 IF na GT 5 THEN  a_l(6) = a_l(6) + w0 
 FUNCT_1,x+w0,a_l,y_l,y_l1,y_l2,y_l3

 y_a = y
 a_a = a
; a_a = a_l
 AMOEBA,x,y_a,fname,a_a,noprint=1,MAX = 100                  ;green
 a_a(1) = a_a(1) + w0
 IF na GT 3 THEN  a_a(4) = a_a(4) + w0 
 IF na GT 5 THEN  a_a(6) = a_a(6) + w0 
 FUNCT_1,x+w0,a_a,y_a,y_a1,y_a2,y_a3

 y_m = y
 y_m(0:50) = 0.0
 y_m(100:*) = 0.0
 disp = anf(4)*4 
 three_moment,x,y_m,disp,ampl,shift,width        ; yellow
 a_m = FINDGEN(3)
 a_m(0) = ampl
 a_m(1) = shift + w0
 a_m(2) = width
 FUNCT_1,x+w0,a_m,y_m


 WIDGET_CONTROL, cur0, SET_VALUE = STRING(rl)
 a(1) = a(1) + w0
 IF na GT 3 THEN a(4) = a(4) + w0
 IF na GT 5 THEN a(6) = a(6) + w0

 DL2VEL,a,back,w0
 WIDGET_CONTROL, cur1, SET_VALUE = STRING(FORMAT='(7f8.2)',a)
 DL2VEL,a_c,back,w0
 WIDGET_CONTROL, cur2, SET_VALUE = STRING(FORMAT='(7f8.2)',a_c)
 DL2VEL,a_l,back,w0
 WIDGET_CONTROL, cur3, SET_VALUE = STRING(FORMAT='(7f8.2)',a_l)
 DL2VEL,a_a,back,w0
 WIDGET_CONTROL, cur4, SET_VALUE = STRING(FORMAT='(7f8.2)',a_a)
 DL2VEL,a_m,back,w0
 WIDGET_CONTROL, cur6, SET_VALUE = STRING(FORMAT='(7f8.2)',a_m)
 WIDGET_CONTROL, GET_VALUE = window, draw
 WSET, window
  SET_XY,1547.5,1549.5,2.,6.
  PLOT,x+w0,alog10(y+back),COLOR=0,BACK=128   ;255
  OPLOT,x+w0,yu,COLOR=4
  PLOTS,[1548.715,1548.715],[2.1,2.3],COLOR=0
  PLOTS,[1548.202,1548.202],[2.1,2.3],COLOR=0

  OPLOT,x+w0,alog10(y_c+back),COLOR=1,LINESTYLE=0,PSYM=0
;  OPLOT,x,alog10(y_c1+back),COLOR=1,LINESTYLE=2,PSYM=0
;  OPLOT,x,alog10(y_c2+back),COLOR=1,LINESTYLE=2,PSYM=0
;  OPLOT,x,alog10(y_c3+back),COLOR=1,LINESTYLE=2,psym=0

  OPLOT,x+w0,alog10(y_a+back),COLOR=2,LINESTYLE=0,psym=0
;  OPLOT,x,alog10(y_a1+back),COLOR=2,LINESTYLE=3,psym=0
;  OPLOT,x,alog10(y_a2+back),COLOR=2,LINESTYLE=3,psym=0
;  OPLOT,x,alog10(y_a3+back),COLOR=2,LINESTYLE=3,psym=0

  OPLOT,x+w0,alog10(y_l+back),COLOR=3,LINESTYLE=0,psym=0
;  OPLOT,x,alog10(y_l1+back),COLOR=3,LINESTYLE=4,psym=0
;  OPLOT,x,alog10(y_l2+back),COLOR=3,LINESTYLE=4,psym=0
;  OPLOT,x,alog10(y_l3+back),COLOR=3,LINESTYLE=4,psym=0

  OPLOT,x+w0,alog10(y_m+back),COLOR=5,LINESTYLE=0,psym=0

 WIDGET_CONTROL, GET_VALUE = window, draw2
 WSET, window
  SET_XY,1547.5,1549.5,-1.,1.
  PLOT,x+w0,alog10(y+back)-alog10(y+back),COLOR=0,BACK=128   ;255
  OPLOT,x+w0,alog10(y+back)-alog10(y_c+back),COLOR=1
  OPLOT,x+w0,alog10(y+back)-alog10(y_a+back),COLOR=2
  OPLOT,x+w0,alog10(y+back)-alog10(y_l+back),COLOR=3
  OPLOT,x+w0,alog10(y+back)-alog10(y_m+back),COLOR=5
  PLOTS,[1548.715,1548.715],[-.5,.5],COLOR=0
  PLOTS,[1548.202,1548.202],[-.5,.5],COLOR=0

 READ,'New fit (Y) ? ', dummy
 ERASE
 IF (dummy EQ 'Y') OR (dummy EQ 'y') THEN goto, fit
 ENDFOR
;stop

 PRINT, "Press [Done] in HRTS window when finished!"
 XMANAGER, 'hrts_w', base 
 END

