PRO INTERP, x1, y1, x2, y2, xh, yh
;+
; Project     : SOHO - CDS     
;                   
; Name        : interp
;               
; Purpose     : Simple linear interpolation
;               
; Explanation : 
;               
; Use         : IDL> interp,x1,y1,x2,y2,xh,yh
;    
; Inputs      : two points [x,y] and y-value where interpolated
;               value is wanted 
;               
; Opt. Inputs : 
;               
; Outputs     : interpolated values in x and y
;               
; Opt. Outputs: 
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : ?
;               
; Prev. Hist. : None
;
; Written     : Nils Brynildsen, ITA, UiO, 9-Sept.-1993
;               
; Modified    : Version 1.1 Nils Brynildsen, ITA, 27-June-1995
;
;               Added y1 = y2 test.
;
; Version     : Version 1.1 27-June-1995
;- 
IF N_PARAMS(0) LT 6 THEN BEGIN
  PRINT,' *** INTERP must be called with 6 parameters ***'
  RETURN
ENDIF 
          
IF y1(0) EQ y2(0) THEN BEGIN
   xh = (x1 + x2)/2.
   RETURN
ENDIF
      
xh = x1 + (yh - y1)*((x2 - x1)/(y2 - y1))

RETURN
END