FUNCTION parab,x,y,p1,p2,back,a
;+
; Project     : SOHO - CDS     
;                   
; Name        : parab
;               
; Purpose     : fit a parabola to a given line profile
;               
; Explanation : uses IDL-procedure poly_fit to fit a parabola to
;		the points in the line profile
;               
; Use         : IDL>a = parab(x,y,p1,p2,back,a)
;    
; Inputs      : x-array, y-array, first pixel in lineprofile,
;		last pixel in line profile, background value
;               
; Opt. Inputs : None
;               
; Outputs     : Coeffissients of fitted parabola
;               
; Opt. Outputs: a
;               
; Keywords    : ?
;
; Calls       : poly_fit
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Line fitting
;               
; Prev. Hist. : None
;
; Written     : Nils Brynildsen, ITA, UiO, 12-Apr.-1994
;               
; Modified    : Version 1.0 Nils Brynildsen, 12-Apr.-1994
;
; Version     : Version 1.0, 1-July-1994
;-            
a_p = DBLARR(3)
a = POLY_FIT(x(p1:p2), y(p1:p2), 2, yp)
a_p(0) = a(0) - a(1)*a(1)/(4.*a(2))
a_p(1) = -a(1)/(2.*a(2))
yhalf = (a_p(0) - back)/2.
a_p(2) = SQRT((a(1)/a(2))^2 - 4*(a(0) - yhalf)/a(2))
RETURN,a_p
END