PRO read_hrts_im, inf, anf, image
;+
; Project     : SOHO - CDS     
;                   
; Name        : read_hrts_im
;               
; Purpose     : Read a hrts image file from disk
;               
; Explanation : 
;               
; Use         : IDL> read_hrts_im,inf-array,anf-array,image-array
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : Header info. (inf,anf), HRTS-image
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: Can only read one special HRTS image at the moment
;               
; Side effects: None
;               
; Category    : ?
;               
; Prev. Hist. : ?
;
; Written     : Nils Brynildsen, ITA, UiO, 29-June-1993
;               
; Modified    : Version 1 Nils Brynildsen, ITA, UiO, 29-June-1993
;
; Version     : Version 1 29-June-1993
;-            

;    name = 'sl317_17_sp.dns' ; r.l. 160, 177
    name = 'sl415_30s.int' ; r.l. 130, 150
    OPENR,1,name
    dumarr = ASSOC(1,INTARR(80))
    hdr = dumarr(0)
    dumarr = ASSOC(1,INTARR(512))
    infval = dumarr(0)
    dumarr = ASSOC(1,FLTARR(512))
    anfval = dumarr(0)
    IF infval(40) EQ 0 THEN BEGIN
      inf = infval(199:259)
      anf = anfval(129:191)
    ENDIF ELSE BEGIN
      inf = infval(39:99)
      anf = anfval(49:101)
    ENDELSE
    nsm = inf(27)
    nrl = inf(29)
    dumarr = ASSOC(1,INTARR(nsm,nrl),1024)
    image = dumarr(0)

    image = FLOAT(image)/anf(15)+anf(16)

    CLOSE,1
END
