; $Id: gaussfit.pro,v 1.1 1993/04/02 19:43:31 idl Exp $

PRO	TWOGAUSS,X,A,F,PDER

; NAME:
;
	ON_ERROR,2                        ;Return to caller if an error occurs
;
	if a(2) ne 0.0 then Z1 = (X-A(1))/A(2) $	;GET Z
	else z1= 10.
;
	if a(5) ne 0.0 then Z2 = (X-A(4))/A(5) $	;GET Z
	else z2= 10.
;
	EZ1 = EXP(-Z1^2/2.)*(ABS(Z1) LE 7.) ;GAUSSIAN PART IGNORE SMALL TERMS

	EZ2 = EXP(-Z2^2/2.)*(ABS(Z2) LE 7.) ;GAUSSIAN PART IGNORE SMALL TERMS

	F = A(0)*EZ1 + A(3)*EZ2 + A(6) + A(7)*X + A(8)*X^2 ;FUNCTIONS.
;
	IF N_PARAMS(0) LE 3 THEN RETURN      ;NEED PARTIAL?
;
	PDER = FLTARR(N_ELEMENTS(X),9)       ;YES, MAKE ARRAY.
	PDER(0,0) = EZ1		             ;COMPUTE PARTIALS
	PDER(0,3) = EZ2	                     ;COMPUTE PARTIALS

	if a(2) ne 0. then PDER(0,1) = A(0) * EZ1 * Z1/A(2)

	if a(5) ne 0. then PDER(0,4) = A(3) * EZ2 * Z2/A(5)
;
	PDER(0,2) = PDER(*,1) * Z1
	PDER(0,5) = PDER(*,4) * Z2
;
	PDER(*,6) = 1.
	PDER(0,7) = X
	PDER(0,8) = X^2
;
	RETURN
;
END

Function twog_fit, x, y, a, sigmaa

;+
;-
;

on_error,2                      ;Return to caller if an error occurs

;
     yf = gaussfit ( x, y, ac ) 
;
     find_g_arc, x, y, wg, wgh, cf, nwg
;
     yc = poly ( x, ac ( 3:5 ) )
;
     a = fltarr ( 9 )
;
     if ( nwg eq 1 ) then begin
         a ( 0 ) = y ( wg ( 0 ) ) - yc ( wg ( 0 ) )
         a ( 1 ) = x ( wg ( 0 ) )
         a ( 2 ) = 0.125
     endif else begin
         a ( 0 ) = 100.
         a ( 1 ) = 0.0
         a ( 2 ) = 0.125
     endelse
;
     if ( nwg gt 1 ) then begin
         a ( 3 ) = y ( wg ( 1 ) ) - yc ( wg ( 1 ) )
         a ( 4 ) = x ( wg ( 1 ) )
         a ( 5 ) = 0.125
     endif else begin
         dx = 3
         if ( y ( wg ( 0 ) + dx ) lt y ( wg ( 0 ) - dx ) ) then dx = -3
;
         a ( 3 ) = 0.667 * ( y ( wg ( 0 ) + dx ) - yc ( wg ( 0 ) ) )
         a ( 4 ) = x ( wg ( 0 ) + dx )
         a ( 5 ) = 0.125
         wg = [ wg ( 0 ), wg ( 0 ) + dx ]
     endelse
;
     a ( 6:8 ) = ac ( 3:5 )
;
     n = n_elements(y)	        	;# of points.
;
     !c=0				;reset cursor for plotting
;
     return,curvefit(x,y,replicate(1.,n),a,sigmaa, $
		function_name = "TWOGAUSS") ;call curvefit
;
 end
;
