;+
; Project     : SOHO - CDS     
;                   
; Name        : QLDS_INVENTORY
;               
; Purpose     : Display all QLDS'es that are stored in the QLMGR scheme.
;               
; Explanation : Looks for all possible stored QLDS'es and makes a call
;		to dsp_struct for each one.
;               
; Use         : QLDS_INVENTORY
;    
; Inputs      : None.
;               
; Opt. Inputs : None.
;               
; Outputs     : None.
;               
; Opt. Outputs: None.
;               
; Keywords    : None.
;
; Calls       : QLDS_CHECKIN, DSP_STRUCT, DATATYPE()
;
; Common      : QLSAVE : See QLDS_CHECKIN
;		QLMGR  : See QLMGR
;               
; Restrictions: None.
;               
; Side effects: None.
;               
; Category    : QuickLook, Management
;               
; Prev. Hist. : None.
;
; Written     : Stein Vidar Hagfors Haugan, ItA/UiO, 11-June-1994
;               
; Modified    : Never.
;
; Version     : 1, 11-June-1994
;-            

PRO qlds_inventory
  common QLSAVE,QLDS,saved
  common QLMGR,QL_ID,QL_DATA
  
  FOR i=0,N_elements(QL_DATA)-1	DO BEGIN
      qlds_checkin,i,/test
      IF datatype(QLDS)	eq 'STC' THEN dsp_struct,QLDS
  EndFOR
  
END
