;+
; Project     : SOHO - CDS     
;                   
; Name        : CDSNOTIFY
;               
; Purpose     : Display a message to the user.
;               
; Explanation : Creates a window in the upper right corner of the
;		screen with a text area to show lines with
;		information to the CDS QuickLook user.
;               
; Use         : CDSNOTIFY,'Message'
;    
; Inputs      : The message text
;               
; Opt. Inputs : None.
;               
; Outputs     : None.
;               
; Opt. Outputs: None.
;               
; Keywords    : BELL:	Set to cause a beep.
;
; Calls       : BELL, DATATYPE()
;
; Common      : CDSNOTIFY
;               
; Restrictions: 
;               
; Side effects: 
;               
; Category    : CDS, QL, DISPLAY, UTIL
;               
; Prev. Hist. : None.
;
; Written     : SVHH, January 1994
;               
; Modified    : 
;
; Version     : 1.0
;-            



PRO cdsnotify_event, event,append_text=append_text,Bell=Bell
  common CDSNOTIFY,baseid,textid
  
  IF datatype(append_text) eq 'STR' THEN BEGIN
      Widget_CONTROL,baseid,iconify=0,/show
      Widget_CONTROL,textid,Set_VALUE=append_text,/append
      IF Keyword_SET(Bell) THEN	Bell
      return
  END
  
  
  Widget_CONTROL, event.id, Get_UVALUE = eventval	  ;find the user value
							  ;of the widget where
							  ;the event occured
  CASE eventval	OF
      
      'DONE':$
      BEGIN
	  Widget_CONTROL,event.top,/destroy
	  return
      END
      'ICONIFY':$
      BEGIN
	  Widget_CONTROL,event.top,/iconify
      END
      
      ELSE:$
      BEGIN
	  Print,'Event not understood:'
	  help,event,/str
      END
  EndCASE
  
END ;============= end of cdsnotify event handling routine task =============





;------------------------------------------------------------------------------
;	procedure cdsnotify
;------------------------------------------------------------------------------
; This routine creates the widget and registers it with the XManager.
;------------------------------------------------------------------------------
PRO cdsnotify,text,GROUP = GROUP,Bell=Bell
  common CDSNOTIFY,baseid,textid
  
  IF(XRegistered("cdsnotify") NE 0) THEN BEGIN
      IF datatype(text)	eq 'STR' THEN $
	      cdsnotify_event,append_text=text,Bell=Bell
      return
  END
  
  DEVICE,GET_SCREEN_SIZE=SZ
  
  baseid = Widget_BASE(TITLE = "cdsnotify",$
			  xoffset=SZ(0),yoffset=0,/column)
  
  rbase	= Widget_BASE(baseid,/row)
  button = Widget_BUTTON(rbase,value='ICONIFY',uvalue='ICONIFY')
  button = Widget_BUTTON(rbase,value='DONE',uvalue='DONE');
  
  textid = Widget_TEXT(baseid,xsize=80,ysize=20,/scroll)
  
  
  Widget_CONTROL, baseid, /REALIZE
  
  Widget_CONTROL, baseid,tlb_get_size=bsize
  
  Widget_CONTROL, baseid,tlb_set_xoffset=SZ(0)-bsize(0)-10,$
			  tlb_set_yoffset=30
  
  IF (datatype(text) eq	'STR') THEN cdsnotify_event,append_text=text
  
  Xmanager, "cdsnotify", baseid,GROUP_LEADER = GROUP,/just_reg
  
END
