;+
; Project     : SOHO - CDS     
;                   
; Name        : FITS_MENU
; 
; Purpose     : Display available FITS file and read selected file into IDL
;               
; Explanation : Enables reading of a CDS FITS file. Still a preleminary
;               solution. 
;               
; Use         : FITS_MENU, QLDS
;    
; Inputs      : None.
;
; Opt. Inputs : None.
;               
; Outputs     : None.
;               
; Opt. Outputs: None.
;               
; Keywords    : None.
;
; Calls       : READCDSFITS(), XSTART
;
; Common      : None.
;               
; Restrictions: ..
;               
; Side effects: ..
;               
; Category    : CDS, QL, DISPLAY
;               
; Prev. Hist. : 
;
; Written     : P. Brekke, 19-Feb-96,
;               
; Modified    : P.Brekke, 5-March-1996
pro fits_menu, qlds

	IF N_PARAMS() LT 1 THEN BEGIN
            Print, 'Syntax:  FITS_MENU, QLDS'  
            return
        END    
      filename=cdspickfile(filter='*.fits',title='Pick QL data file',$
             path='$CDS_FITS_DATA',xoffset=500,yoffset=500,/fsort)
      
      filename=trim(filename)
      IF filename ne ''	THEN BEGIN
      Widget_CONTROL,/hourglass
      xtext,'Please wait Reading FITS file.'$
             ,/just_reg, wbase=wbase
	  qlds=ReadCDSfits(filename)
       xkill, wbase
     ENDIF

end
