;+
; Project     : SOHO - CDS     
;                   
; Name        : LOAD_RED
;               
; Purpose     : Load "Red Temperature" with a gamma effect.
;               
; Explanation : Purpose says it all.
;               
; Use         : LOAD_RED,GAMMA
;    
; Inputs      : 
;               
; Opt. Inputs : GAMMA
;               
; Outputs     : None
;               
; Opt. Outputs: None.
;               
; Keywords    : None.
;
; Calls       : LOADCT, GAMMA_CT
;
; Common      : None
;               
; Restrictions: 
;               
; Side effects: Changes current color table.
;               
; Category    : CDS, QL, DISPLAY, UTILITY
;               
; Prev. Hist. : None.
;
; Written     : SVHH, March 14, 1994
;               
; Modified    : SVHH, March 15, 1994
;			Added gamma.
;		Version 2, William Thompson, GSFC, 8 April 1998
;			Changed !D.N_COLORS to !D.TABLE_SIZE for 24-bit displays
;		Version 3, 18-Aug-1998, William Thompson, GSFC
;			Use GAMMA_CT instead of STRETCH
;
; Version     : Version 2, 8 April 1998
;-            

PRO load_red,gamma
  IF N_elements(gamma) eq 0 or N_elements(gamma) gt 1 THEN gamma = 0.5
  loadct,3
  gamma_ct,0.5
END
