;+
; Project     : SOHO - CDS     
;                   
; Name        : QL_DIMENSIONS
;               
; Purpose     : (Obsolete -- use(s) gt_dimension)
;               
; Explanation : Based on the information in the QuickLook Data Stucture,
;		an IDL structure describing the dimensionality of the 
;		detector data is returned with the following tags:
;
;		WAVELNTH : TRUE if the spectral dimension is present
;			   and non-singular
;		SOLAR_X:   TRUE if the SOLAR_X dimension is present
;			   and non-singular
;		SOLAR_Y:   TRUE if the SOLAR_Y dimension is present
;			   and non-singular
;		DEL_TIME:  TRUE if the DEL_TIME dimension is present
;			   and non-singular.
;		NDIMS:     The number of non-singular dimensions
;
;		There is also a tag for each of the dimensions that
;		describes the size of the dimension, named SWAVELNTH,
;		SSOLAR_X, SSOLAR_Y, SDEL_TIME.
;               
; Use         : info = QL_DIMENSIONS(QLDS)
;    
; Inputs      : QLDS: QuickLook Data Structure, see CDS software note #9
;               
; Opt. Inputs : None.
;               
; Outputs     : Returns a structure with information on the dimensionality
;		of the data windows in the QLDS
;               
; Opt. Outputs: None.
;               
; Keywords    : NOCHECK : Set to avoid checking the validity of the QLDS
;
; Calls       : None.
;
; Common      : None.
;               
; Restrictions: QLDS should conform to CDS software not #9
;               
; Side effects: None known.
;               
; Category    : CDS QuickLook
;               
; Prev. Hist. : None.
;
; Written     : Stein Vidar Hagfors Haugan, 20-Feb-1995
;               
; Modified    : Version 2, SVHH, 21-Aug-1995
;			QL_SIZE modified to save memory.
;               Version 3, SVHH, 15 August 1996
;                       Obsolete -- using gt_dimension instead.
; Version     : 2
;-            


function QL_DIMENSIONS,QLDS,NOCHECK=NOCHECK
  
  RETURN,gt_dimension(qlds)
  
END
