;+
; Project     : SOHO - CDS     
;                   
; Name        : QL_MENU
; 
; Purpose     : Executive menu for QL software
;               
; Explanation : Enables reading of a new CDS FITS file.
;               
; Use         : QL_MENU
;    
; Inputs      : None.
;
; Opt. Inputs : None.
;               
; Outputs     : None.
;               
; Opt. Outputs: None.
;               
; Keywords    : None.
;
; Calls       : DSP_MENU, READCDSFITS()
;
; Common      : None.
;               
; Restrictions: ..
;               
; Side effects: ..
;               
; Category    : CDS, QL, DISPLAY
;               
; Prev. Hist. : None.
;
; Written     : Stein Vidar Hagfors Haugan, March 16 1994
;               
; Modified    : PB, 27-Feb-1996, Changed the default file path
;               PB, 3-MAr-1996, Added keyword /fsort in call to 
;                   cdspickfile
; Version     : 1 (very experimental)
;-            

PRO QL_MENU_EVENT, EV
  
  On_Error,0
  
  Widget_CONTROL,ev.id,Get_VALUE=value
  IF value eq 'Load new file' THEN BEGIN
      filename=cdspickfile(filter='*.fits',title='Pick QL data file',$
	  path='$CDS_FITS_DATA',xoffset=500,yoffset=500,/fsort)
      filename=trim(filename)
      IF filename ne ''	THEN BEGIN
          Widget_CONTROL,/hourglass
	  a=ReadCDSfits(filename)
	  dsp_MENU,a,/nokeep
      EndIF
      Widget_CONTROL,ev.top,/destroy
  END ELSE BEGIN
      Widget_CONTROL,ev.top,/destroy
  EndELSE
  
END






PRO QL_MENU
  
  On_Error,2
  
  IF Xregistered('ql_menu') gt 0 THEN return
  
  base = Widget_BASE(/column,title='QL menu',xoffset=500,yoffset=500)
  
  dummy	= Widget_BUTTON(base,value='Load new file')
  dummy	= Widget_BUTTON(base,value='Quit')
  
  Widget_CONTROL,base,/realize
  
  Xmanager,"ql_menu",base
  
END
