;+
; Project     : SOHO - CDS     
;                   
; Name        : RECOVER
;               
; Purpose     : A general crash recovery procedure -- recovers stored QLDS
;               
; Explanation : If anyghing goes wrong, type "@recover", and the data
;		you've given to the QL routines are recovered.
;               
; Use         : @recover
;    
; Inputs      : None.
;               
; Opt. Inputs : None.
;               
; Outputs     : Global variables a,b,c,.....
;               
; Opt. Outputs: None.
;               
; Keywords    : None.
;
; Calls       : CONCAT_DIR(), DATATYPE(), QLDS_CHECKIN, QLMGR, TRIM()
;
; Common      : QLMGR : See qlmgr.pro
;               QLSAVE : See qlmgr.pro
;
; Restrictions: 
;               
; Side effects: Kills all widgets
;               
; Category    : 
;               
; Prev. Hist. : None.
;
; Written     : Stein Vidar Hagfors Haugan, 10-December 1994
;               
; Modified    : Never.
;
; Version     : 1.0
;-            


retall
common qlmgr,_rec_ql_id,_rec_ql_data
common qlsave,_rec_qlds,_rec_saved

Print,"This is the QuickLook recovery procedure"
print
cd,"$HOME",current=oldpath
_rec=['']

if n_elements(a) eq 0 then _rec=[_rec,'a']
if n_elements(b) eq 0 then _rec=[_rec,'b']
if n_elements(c) eq 0 then _rec=[_rec,'c']
if n_elements(d) eq 0 then _rec=[_rec,'d']
if n_elements(e) eq 0 then _rec=[_rec,'e']
if n_elements(f) eq 0 then _rec=[_rec,'f']
if n_elements(g) eq 0 then _rec=[_rec,'g']
if n_elements(h) eq 0 then _rec=[_rec,'h']
if n_elements(i) eq 0 then _rec=[_rec,'i']
if n_elements(j) eq 0 then _rec=[_rec,'j']
if n_elements(k) eq 0 then _rec=[_rec,'k']
if n_elements(l) eq 0 then _rec=[_rec,'l']
if n_elements(m) eq 0 then _rec=[_rec,'m']
if n_elements(n) eq 0 then _rec=[_rec,'n']
if n_elements(o) eq 0 then _rec=[_rec,'o']

_rec = _rec(1:*)

openw,lur,concat_dir("$HOME","_recover.pro"),/get_lun
nrec = 0

for i=0,N_elements(_rec_ql_data)-1 do begin & $
   qlds_checkin,i,/test & $
   if datatype(_rec_qlds) eq 'STC' then begin & $
	print,"A QLDS has been found, placing it in the global variable '"+$
							_rec(0)+"'" &$
	printf,lur,"qlds_fetch,"+trim(i)+","+_rec(0) &$
	_rec = _rec(1:*) &$
	nrec = nrec+1 &$
   end &$
end

close,lur
free_lun,lur

@_recover.pro

widget_control,/reset
xmanager
retall

delvar,_rec

print,"QuickLook recovery finished"
if nrec gt 0 then begin &$
        if nrec eq 1 then print,"One data structure was found and recovered" $
	else  print,trim(nrec)+" data structures were found and recovered" & $
end else begin & $
    Print,"No data structures found -- if you're missing one, it's gone.." &$
    print,"..or it's still in the original variable" &$
    print,"Sorry" &$
end

cd,oldpath