;+
; Project     : SOHO - CDS     
;                   
; Name        : GET_SERTSW
;               
; Purpose     : Return a descriptor for the current SERTS IMAGE window
;               
; Explanation : 
;               
; Use         : SERTSW = GET_SERTSW()
;    
; Inputs      : None.
;               
; Opt. Inputs : None.
;               
; Outputs     : Return value.
;               
; Opt. Outputs: None.
;               
; Keywords    : None.
;
; Calls       : None.
;
; Common      : IMAGE_AREA, from Bill Thompsons image routines
;               
; Restrictions: Should only be used when Bill routines are always used.
;               
; Side effects: None.
;               
; Category    : QuickLook
;               
; Prev. Hist. : None.
;
; Written     : Stein V Hagfors Haugan, December -93
;               
; Modified    : 
;
; Version     : 1.0
;-            

FUNCTION get_sertsw
  common IMAGE_AREA,IMAGE_SET,IX,NX,IY,NY
  IF N_elements(ix) eq 0 THEN return,0
  return,{SERTSW, name:!D.name,window:!d.window,$
		  ix:float(ix),nx:float(nx),$
		  iy:float(iy),ny:float(ny)}
END
