;+
; Project     : SOHO - CDS     
;                   
; Name        : SET_SERTSW
;               
; Purpose     : Set current SERTS window to the one in the descriptor
;               
; Explanation : 
;               
; Use         : SET_SERTSW,SERTSW
;    
; Inputs      : SERTSW: a SERTS window descriptor as returned by GET_SERTSW()
;               
; Opt. Inputs : None.
;               
; Outputs     : None.
;               
; Opt. Outputs: None.
;               
; Keywords    : None.
;
; Calls       : None.
;
; Common      : IMAGE_AREA, from Bill Thompsons image routines
;               
; Restrictions: There must be a data coordinate system associated with
;		the SERTS window.
;               
; Side effects: Changes the current SETIMAGE settings.
;               
; Category    : QuickLook
;               
; Prev. Hist. : None.
;
; Written     : Stein V Hagfors Haugan, December -93
;               
; Modified    : 
;
; Version     : 1.0
;-            

PRO set_sertsw,a
  common IMAGE_AREA,IMAGE_SET,IX,NX,IY,NY
  SetWindow,a.window
  image_set=1
  ix = a.ix
  iy = a.iy
  nx = a.nx
  ny = a.ny
; Copied from SETIMAGE
  GET_TV_SCALE,	SX0, SY0, MX0, MY0, JX0, JY0, DT, /DISABLE
  !P.CLIP = DT.CLIP
  !X.S = DT.XS
  !Y.S = DT.YS
  GET_VIEWPORT,SC1,SC2,SC3,SC4
  !X.CRANGE = ([SC1,SC2]/!D.X_SIZE - !X.S(0)) /	!X.S(1)
  !Y.CRANGE = ([SC3,SC4]/!D.Y_SIZE - !Y.S(0)) /	!Y.S(1)
  !X.TYPE = 0
  !Y.TYPE = 0
END

