;+
; Project     : SOHO - CDS     
;                   
; Name        : CAL_HDR_UPDATE
;               
; Purpose     : To update primary and binary table headers of a FITS file.
;               
; Explanation : The routine FXHMODIFY is called to update the primary and
;               binary extension headers of a calibration FITS file.
;               
; Use         : IDL> cal_hdr_update, filename, item_name, value
;    
; Inputs      : filename  - the FITS file name
;               item_name - the name of the FITS header item
;               value     - the new value to be associated with item_name
;               
; Opt. Inputs : None
;               
; Outputs     : The input file headers are updated.
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : FXHMODIFY
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Data_handling,  FITS, i_o
;               
; Prev. Hist. : None
;
; Written     : CDP, RAL, 4-Mar-94
;               
; Modified    : 
;
; Version     : Version 1, 4-Mar-94
;-            

pro cal_hdr_update, file, name, value

;
;  call to basic routine to update headers
;
fxhmodify, file, name, value
fxhmodify, file, name, value, ext=1

end

