;+
; Project     : SOHO - CDS     
;                   
; Name        : GT_DATA_UNITS()
;               
; Purpose     : Returns the current data units in the QLDS
;               
; Explanation : Information taken from the header.
;               
; Use         : UNITS = GT_DATA_UNITS(QLDS)
;    
; Inputs      : QLDS: Quick Look Data Structure
;               
; Opt. Inputs : None.
;               
; Outputs     : None.
;               
; Opt. Outputs: None.
;               
; Keywords    : NOCHECK: Set to avoid call to QLMGR
;
; Calls       : QLMGR
;
; Common      : None.
;               
; Restrictions: 
;               
; Side effects: None.
;               
; Category    : GET routine
;               
; Prev. Hist. : None.
;
; Written     : 25-Jan-1999, CDP
;               
; Modified    : 
;
; Version     : 1, 25-Jan-1999
;-            

FUNCTION GT_DATA_UNITS,QLDS,nocheck=nocheck
  
  ON_ERROR,2
  IF !debug GT 0 THEN ON_ERROR,0
  
  IF NOT KEYWORD_SET(nocheck) THEN begin
     QLMGR,QLDS,valid
     IF NOT valid THEN  $
        MESSAGE,"Parameter must be a valid Quick Look Data Structure"
  END
  RETURN,QLDS.DETDESC(0).UNITS
  
END
