;+
; Project     : SOHO - CDS     
;                   
; Name        : SHOW_AXES
;               
; Purpose     : Informs of axes type of CDS data structure.
;               
; Explanation : The data array returned in the .detdata tag by readcdsfits
;               can have either 2,3 or 4 dimensions.  This routine lists the
;               axes descriptors by way of explanation of what the data array
;               represents.
;               
; Use         : IDL> show_axes, structure
;    
; Inputs      : structure - CDS data structure returned by READCDSFITS
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : CDS, FITS, array
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 11-Jul-95
;               
; Modified    : 
;
; Version     : Version 1, 11-Jul-95
;-            

pro show_axes, str

ax = str.detdesc(0).axes
ndim = n_dimensions(str.detdata)
dim = size(str.detdata) & dim = dim(1:ndim)

print,ax,form='(3x,4(2x,a10))'
print,dim,form='(4(6x,i6))'

print,'           |'
print,'           \--> ',fmt_vect(gt_winsize(str))


end
