;+
; Project     : SOHO - CDS     
;                   
; Name        : FF_DEMO
;               
; Purpose     : Demonstrates new on board flat-field for OV region.
;               
; Explanation : 
;               
; Use         : IDL> ff_demo
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : Image display routines.
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Engineering
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 31-May-96
;               
; Modified    : 
;
; Version     : Version 1, 31-May-96
;-            

pro ff_demo

m = 0
mc = 0
mf = 0
ov = 0
print,'Restoring data...'

restore,concat_dir('$CDS_ENG_DEMO','ff_demo')

if !d.name eq 'X' then begin
   window,xs=950,ys=725,/free
   wset,!d.window
endif   
erase

m = sigrange(m)
mc = sigrange(mc)
mf = sigrange(mf)


setimage,1,4
exptv,(m(*,*,0)),/nor
label_image,'Raw data',gap=1,chars=1.1,/bel

setimage,2,4
exptv,(mc(*,*,0)),/nor
label_image,'After vds_calib',gap=1,chars=1.1,/bel

setimage,3,4
exptv,ov,/nor
label_image,'New OV flat field',gap=1,chars=1.1,/bel

setimage,4,4
exptv,(mf(*,*,0)),/nor
label_image,'Result of new FF',gap=1,chars=1.1,/bel


yes_no, 'Display movie?', ans, 'N'

if ans then begin
   mm = fltarr(150,143,60)
   for i=0,59 do begin
      mm(0:49,*,i)    = m(*,*,i)
      mm(50:99,*,i)   = mc(*,*,i)*121.
      mm(100:149,*,i) = mf(*,*,i)
   endfor
   xmovie,mm, res=2,rel=0.5
endif


end
