;+
; Project     : SOHO - CDS     
;                   
; Name        : PLOT_SCI_TLM
;               
; Purpose     : Demonstrates science content of CDS telemetry
;               
; Explanation : 
;               
; Use         : IDL> plot_sci_tlm, timerange=timerange
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : TIMERANGE - specify 2-element strarr
;
; Calls       : CDS_UTPLOT
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Engineering
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 26-Jul-96
;               
; Modified    : 
;
; Version     : Version 1, 26-Jul-96
;-            

pro plot_sci_tlm,timerange=timerange

file = 0
percent = 0
date = 0

restore,concat_dir('$CDS_ENG_DEMO','may_jul_tlm_stats')


if n_elements(timerange) eq 2 then begin
   tr = str2utc(timerange)
endif else begin
   tr = [date(0),last_item(date)]
endelse

!p.multi=[0,1,2]

;
;  fiddle! (cds_utplot doesn't like leap years)
;
date.mjd = date.mjd+365L

circle_sym,/fill
cds_utplot,date,percent,psym=8,ytit='Percentage',xtit='1996',syms=0.6,$
       tit='Percentage of telemetry occupied by science data',chars=1.3

nh = float(n_elements(date))
h = histogram(percent)
plot,h/nh,psym=10,xtit='Percentage of science data',ytit='Fraction of time ',$
          chars=1.3,xr=[-10,100],/xst
oplot,[-0.5,-0.5],[h(0)/nh,0]
oplot,[-0.5,0.5],[h(0)/nh,h(0)/nh]

!p.multi=0

end
