;+
; Project     : SOHO - CDS     
;                   
; Name        : PLOT_TEMP_POS
;               
; Purpose     : Demonstrates temperature dependence of NIS wavecal
;               
; Explanation : 
;               
; Use         : IDL> plot_temp_pos
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : CDS_UTPLOT
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Engineering
;               
; Prev. Hist. : None
;
; Written     : C D Pike, 11-Jul-96
;               
; Modified    : Change utplot name.  CDP, 2-Oct-96
;               Added velocity error bar.  CDP, 29-Oct-96
;
; Version     : Version 3, 29-Oct-96
;-            

pro plot_temp_pos

temp_time = 0
cst = 0
ovtime = 0
ovpos = 0

restore,concat_dir('$CDS_ENG_DEMO','cds_temp_pos_data')
circle_sym,/fill

xm = !x.margin
!x.margin = [10,10]
cds_utplot,temp_time,cst,yr=[10,30],psym=3,$
  tit = 'CDS NIS wavelength temperature sensitivity',$
   ytit='Optical bench temperature (degrees)',syms=2,chars=1.6
cds_outplot,str2utc(['1996-06-06','1996-06-06']),[12,14.97]
cds_outplot,str2utc(['1996-06-05','1996-06-07']),[12,12]
cds_outplot,str2utc(['1996-06-05','1996-06-07']),[14.97,14.97]
cds_utstring,str2utc('1996-06-7'),13.5,'50 km/s',chars=1.3

circle_sym
cds_outplot,ovtime,(ovpos-8.15)*4. + 23.,psym=8,syms=1.5
axis,yax=1,ytickna=[' ','5.5','7.0','8.5',' '],$
           ytit='Average OV 629A line position (pixels)',chars=1.6

!x.margin = xm

end
