;+
; Project     : SOHO - CDS     
;                   
; Name        : SLIT45_IMAGE_DEMO
;               
; Purpose     : Demonstrates slit 4 and 5 NIS image data.
;               
; Explanation : Rastered images taken with slit 4 and 5 are displayed.
;               
; Use         : IDL> slit45_image_demo
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Calibration
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 11-Dec-96
;               
; Modified    : 
;
; Version     : Version 1, 11-Dec-96
;-            

pro slit45_image_demo

d4 = 0
d5 = 0

;
;  restore data from s5099 and s5100
;
restore,concat_dir('$CDS_ENG_DEMO','slit4_5_images')


savep = !p.multi

if !d.name eq 'X' then wshow
!p.multi=[0,1,2]
setflag,miss=-100

plot_image,sigrange(d4,frac=0.99),tit='Slit 4',scale=[2,1.69],$
           xtit='Solar X (arcsec)',ytit='Solar Y (arcsec)',chars=1.4

plot_image,sigrange(d5,frac=0.99),tit='Slit 5',scale=[4,1.69],$
           xtit='Solar X (arcsec)',ytit='Solar Y (arcsec)',chars=1.4

!p.multi=savep

end
