;+
; Project     : SOHO - CDS     
;                   
; Name        : VDS_BIAS_GLITCH
;               
; Purpose     : Demonstrates instability in VDS bias level.
;               
; Explanation : 
;               
; Use         : IDL> vds_bias_glitch
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Engineering, VDS
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL.  5-Aug-96
;               
; Modified    : Change utplot name.  CDP, 2-Oct-96
;
; Version     : Version 2, 2-Oct-96
;-                                          



pro vds_bias_glitch

t = 0 & b = 0 & baa = 0

;
;  restore demo data
;
restore,concat_dir('$CDS_ENG_DEMO','vds_bias_glitch')

circle_sym,/fill
cds_utplot,t,b,psym=8,yr=[300,450],syms=0.6,ytit='VDS Bias levels',$
       tit='VDS Bias levels from S3571r04 - r09',chars=1.5,$
       xtit='Exposure start time (14-July-1996)'

cds_outplot,['1996-7-14 11:00','1996-7-14 13:00'],[444,444],line=2
cds_outplot,['1996-7-14 11:00','1996-7-14 13:00'],[310,310],line=2
                                          
circle_sym
cds_outplot,t,baa,syms=0.5,psym=8

cds_utstring,'1996-7-14 12:00',360,'Quadrants 1 & 2',chars=1.5
cds_utstring,'1996-7-14 12:00',315,'Quadrants 3 & 4',chars=1.5


end
