;+
; Project     : SOHO - CDS     
;                   
; Name        : TP_CLEAR_RASTER
;               
; Purpose     : Clears raster branch of structure used in the tech planning.
;               
; Explanation : Clears all details apart from the instrument kept in the
;               raster_p and raster_v structures.
;               
; Use         : IDL>  tp_clear_raster
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Planning, Technical
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 6-Dec-94
;               
; Modified    : Include ief_id in raster variation.  CDP, 09-Nov-95
;
; Version     : Version 2, 09-Nov-95
;-                       

pro tp_clear_raster

;
;  main structure is in common block
;
@tplan_com


tp_obs.raster_p.ras_id = 0
tp_obs.raster_p.ras_desc = ' '
if tp_obs.raster_p.detector eq 'N' then begin
   tp_obs.raster_p.slit_num = 4
endif else begin
   tp_obs.raster_p.slit_num = 1
endelse
tp_obs.raster_p.xstep = 0 
tp_obs.raster_p.ystep = 0 
tp_obs.raster_p.nx = 1    
tp_obs.raster_p.ny = 1    

tp_obs.raster_v.ras_id = 0
tp_obs.raster_v.ras_var = 0   
tp_obs.raster_v.rv_desc = ' '
tp_obs.raster_v.exptime = 50.0
tp_obs.raster_v.ll_id = 0 
tp_obs.raster_v.comp_id = 0
tp_obs.raster_v.comp_opt = 0
tp_obs.raster_v.dw_id = 0   
tp_obs.raster_v.ief_id = 0   
tp_obs.raster_v.vds_orient = 0
tp_obs.raster_v.vds_map = 2  
tp_obs.raster_v.tel_rate = 'M'
tp_obs.raster_v.duration = 0
tp_obs.raster_v.usable = 'Y'


end     
      
