;+
; Project     : SOHO - CDS     
;                   
; Name        : TP_CLEAR_STATE
;               
; Purpose     : Clears STATE branch of structure used in the tech planning.
;               
; Explanation : Sets the contents of the .state tag in the main observation
;               definition structure to the default values.
;               
; Use         : IDL>  tp_clear_state
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Planning, Technical
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 12-Jul-94
;               
; Modified    : 
;
; Version     : Version 1, 12-Jul-94
;-                       

pro tp_clear_state

;
;  main structure is in common block
;
@tplan_com

tp_obs.state.date = 0.0
tp_obs.state.vds_read =  1  
tp_obs.state.vds_pmcp =  0          
tp_obs.state.vds_offset = [0,0]        


;
;  clear display as well if present
;
if xregistered('tp_display_gp') then begin
   for i=0,7 do widget_control,gp_widg(i),set_val=' '
endif

if xregistered('tp_display_vp') then begin
   for i=0,3 do widget_control,vp_widg(i),set_val=' '
endif

end     
      
