;+
; Project     : SOHO - CDS     
;                   
; Name        : TP_LOAD_VDSBACK()
;               
; Purpose     : Loads default VDS background windows into structure.
;               
; Explanation : Reads the VDS background windows from the state database
;               into the internal MK_RASTER structure.
;               
; Use         : status = tp_load_vdsback(str)
;    
; Inputs      : str - standard MK_RASTER structure
;               
; Opt. Inputs : None
;               
; Outputs     : str - is updated on output
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Planning, technical
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 20-Oct-94
;               
; Modified    : Pick up values from state database.  CDP, 18-Jan-96
;
; Version     : Version 2, 18-Jan-96
;-            

function tp_load_vdsback, tp_obs

;
;  read state database
;
back = cp_get_entry('VDS_BACK',indgen(4,4))

;
; reformat
;
if n_elements(back) eq 16 then begin
   tp_obs.vds_backwin.win_def = fix(rotate(back.active,4))
   return,1
endif else return,0

end
