;+
; Project     : SOHO - CDS     
;                   
; Name        : TP_VDS_AXES
;               
; Purpose     : Label VDS image with wavelength scales.
;               
; Explanation : Uses xyouts to put a simple wavelength indications alongside
;               the VDS image display
;               
; Use         : tp_vds_axes
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;
; Common      : TPLAN_COM
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Technical, planning
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL, 21-Oct-94
;               
; Modified    : 
;
; Version     : Version 1, 21-Oct-94
;-            
pro tp_vds_axes

;
;  common
;
@tplan_com

;
;  try and find a white colour
;
tvlct,/get,r,g,b
n = where(r eq g and r eq b)
if n(0) ge 0 then n = max(n) else n = 255

;
;  top spectrum (300A range)
;
x = [310,320,330,340,350,360,370]
xp = wave2pix('N1',x) - 9

for i=0,6 do begin
   xyouts, xp(i), 248, string(x(i),form='(i3)'),/dev,col=n
endfor

x = [315,325,335,345,355,365,375]
xp = wave2pix('N1',x)

for i=0,6 do begin
   xyouts, xp(i), 248, '|',/dev,col=n
endfor

;
;  bottom spectrum (500A range)
;
x = [520,540,560,580,600,620]
xp = wave2pix('N2',x) - 9

for i=0,5 do begin
   xyouts, xp(i), 1, string(x(i),form='(i3)'),/dev,col=n
endfor

x = [530,550,570,590,610,630]
xp = wave2pix('N2',x)

for i=0,5 do begin
   xyouts, xp(i), 1, '|',/dev,col=n
endfor



end
