;+
; Project     : SOHO - CDS     
;                   
; Name        : TPLAN_COM
;               
; Purpose     : The common blocks include file for TP_PAGE1
;               
; Explanation : The source code in this file is loaded from the technical 
;               planning codes.  It contains the common blocks needed for
;               passing variables amongst the tp_page1 routines.
;               It also sets up the maximum number of line and flag windows
;               allowed.
;
; Use         : Only by hardcoding @tplan_com in the source of routines.
;    
; Inputs      : None
;               
; Opt. Inputs : None
;               
; Outputs     : None
;               
; Opt. Outputs: None
;               
; Keywords    : None
;
; Calls       : None
;               
; Restrictions: None
;               
; Side effects: None
;               
; Category    : Technical planning
;               
; Prev. Hist. : None
;
; Written     : C D Pike, RAL,  10-May-1993
;               
; Modified    : Added flag_state.  CDP, 18-Oct-95
;               Added raster duration variables.  CDP, 10-Mar-97
;
; Version     : Version 3,  10-Mar-97
;-            

common tplan_layout,$ 
       base,$
           top,$
              top_left,   et,   et_rv,      et_rv_curr, et_info,  $
                          et_slide, slit_info, ww_info,$  
                          vds_backbase, gis_dispbase, parmbase, $
              top_middle, $
                          ss,   wlss,       sss,        sssx,      sssy,      $
                          rr,   rni,                                          $
                          ns,   wlns,       nss,        nsx,       nsy,       $
                          wll,  wll_info_2, wll_list,  wll_list_1,$
                          wrp_info_2, raster_ll_std,              $
                          wrv_info_2, raster_p_std, raster_v_std, $
                          wdw_info_2, tlm_info_2, tlm_info_3, ras_info1,$
                          frid, rvid, llid, dwid, ras_info2, engrate_id,      $
                          tlmrate_id, cs,   ccs_info,  ccs_info_2,tmr_info_2,$
              top_right,  ctr,  wlctr,      ctreq,                            $
                          cfn,  wlcfn,      cfneed,                           $
           middle,$
              gis_b, image_area2,$ 
           bottom,$
              image_area,$
           low_button
common general, info_line, info_base, vp_base, vp_widg, gp_base, gp_widg, $
                      dew_base, dew_image, fr_base, vr_base, ll_base,$
                      plot_vds_base, vdsp_image, pwin_start, last_vwin_plot,$
                      plot_rasdur_base, rasdurp_image,$
                      pvds_pl, see_mess, m10, $
                      chosen_frast, chosen_llist, dwdb_base, flag_base

common  plot_buttons, lb1, lb2
   
common tplan_data, VDS_image_data, vert_line, GIS_data, GIS_band, $
                      previous_inst, current_zone, zone_base, ief_str,$
                      n_wavecal, g_wavecal

common tplan_exp_time, curr_et_max, curr_etime, curr_ww_max   

common l_wind, window_state, curr_lwidth, line_window, lhit, $
               num_windows, curr_llist, curr_llist_name, curr_lheight

common slider_ids, ww_slider_id, wh, wh_slider_id, et_slider_id, $
                   vv_slider_id, gv_slider_id, gis_setup, gv_done, $
                   npb, vds_parm_info, o3_slider_id, o5_slider_id,$
                   tr_ids, gb_ids, instr_ids, ex_ids, vds_extension, $
                   nis_def_ext, vdsb_ids, nis_pdef, $
                   gbdef_ids, gis_def_ext, vdsb_slider_id

common modes, window_mode, comp_mode, display_state, wmode_ids, dmode_ids,$
              wmode_rv, dmode_rv, db_switch, db_in_use, db_original, $
              help_mode, tp_help, last_uvalue, flag_state


common obs_spec, tp_obs, max_num_lwindow, max_num_fwindow 

common plot_parms, savex, savey, savep

common key_com, key_code, tp_key_base, key_code_ok, key_ids, key_sofar

;
;  set maximum number of line and flag windows allowed
;
max_num_lwindow = 50
max_num_fwindow = 3
tp_font = '-adobe-helvetica-bold-r-normal--14-100-100-100-p-82-iso8859-1'
  


