;+
; Project     :	SOHO - CDS
;
; Name        :	GET_PLAN_DEF
;
; Purpose     : Get definition of plan type
;
; Use         : DEF=GET_PLAN_DEF(TYPE)
;
; Inputs      : TYPE = 0/1/2/3/4 for DETAILS/FLAG/SCIENCE/ALT/SCIENCE_DETAILS
;
; Opt. Inputs : None.
;
; Outputs     : DEF = DETAILS/FLAG/SCIENCE/ALT/SCIENCE_DETAILS
;                    = '' if invalid
;
; Opt. Outputs: None.
;
; Keywords    : None
;
; Explanation : None.
;
; Calls       : None.
;
; Common      : None.
;
; Restrictions: None.
;
; Side effects: None.
;
; Category    : Planning
;
; Prev. Hist. : None.
;
; Written     :	Version 1, Zarro (ARC/GSFC) 29 January 1995.
;-


function get_plan_def,type,err=err

on_error,1

err=''
err_mess='unsupported input plan type'

if n_elements(type) eq 0 then begin
 err='syntax --> DEF = GET_PLAN_DEF(TYPE) '
 message,err,/cont
 return,''
endif

defs=['DETAIL','FLAG','SCIENCE','ALT','SCIENCE-DET','RES']

ndefs=n_elements(defs)
if type gt (ndefs-1) or (type lt 0) then begin
 err=err_mess
 message,err_mess,/cont 
 return,''
endif else return,defs(type)

end
 
