;+
; Project     :	SOHO - CDS
;
; Name        :	GET_PLAN_TIME()
;
; Purpose     : Get plan times
;
; Category    : Planning
;;
; Syntax      :	TSTART = GET_PLAN_TIME( PLAN, TEND=TEND )
;
; Inputs      : PLAN = Plan structure definition 
;
;
; Outputs     : TSTART = plan start time
;
; Keywords    : TEND = plan end time
;
; History     :	Written, Zarro (SM&A/GSFC) 2 Dec 1999
;
; Contact     :	zarro@smmdac.nascom.nasa.gov
;-
;

function get_plan_time,plan,tend=tend,err=err,_extra=extra

err=''
itime=get_plan_itime(plan,err=err)
if err ne '' then return,''

tstart=plan.(itime)
tend=plan.(itime+1)

if datatype(extra) eq 'STC' then begin
 tstart=anytim2utc(tstart,_extra=extra)
 tend=anytim2utc(tend,_extra=extra)
endif

return,tstart
end
