;+
; Project     : SOHO - CDS
;
; Name        : GET_SOHO_MAP
;
; Purpose     : return SOHO SCI_PLAN instrument that is being used for ACTIVITY
;
; Category    : operations, planning
;
; Explanation : 
;
; Syntax      : IDL> inst=get_soho_map(activity)
;
; Inputs      : ACTIVITY = activity (e.g., 'jop')
;
; Opt. Inputs : None
;
; Outputs     : OUT = instrument letter associated with activity
;
; Opt. Outputs: None
;
; Keywords    : None
;
; Common      : None
;
; Restrictions: None
;
; Side effects: None
;
; History     : Version 1,  26-Apr-1995,  D.M. Zarro.  Written
;
; Contact     : DZARRO@SOLAR.STANFORD.EDU
;-

function get_soho_map,activity

np=n_elements(activity)
if np eq 0 then return,''
out=strarr(np)
for i=0,np-1 do begin
 if grep('jop',activity(i),/ex) then out(i)=get_soho_inst('celias')
 if grep('soc',activity(i),/ex) then out(i)=get_soho_inst('swan')
 if grep('cmp',activity(i),/ex) then out(i)=get_soho_inst('erne')
endfor

return,out
end

