;+
; Project     : SOHO - CDS
;
; Name        : GET_SOHO_SUBMODE
;
; Purpose     : return DSN subformat definitions for SOHO instruments
;
; Category    : planning
;
; Explanation : Single point maintenance
;
; Syntax      : IDL>def=get_soho_submode(submode)
;
; Inputs      : SUBMODE= 1,2,3,4, or 6
;
; Opt. Inputs : None
;
; Outputs     : DEF = corresponding definition
;
; Opt. Outputs: None
;
; Keywords    : None
;
; Common      : None
;
; Restrictions: None
;
; Side effects: None
;
; History     : Version 1,  18-Jan-1998,  D.M. Zarro.  Written
;
; Contact     : DZARRO@SOLAR.STANFORD.EDU
;-


function get_soho_submode,submode

if not exist(submode) then return,''

smodes=['','LASCO/EIT (Hi)','CDS (Hi)','SUMER (Hi)','Nominal','LASCO/EIT (Extra Hi)']
nmodes=n_elements(smodes)

nok=where( (submode lt 1) or (submode gt nmodes),count)
dmodes=submode
if count gt 0 then dmodes(nok)=1
def=smodes(dmodes-1)
if n_elements(def) eq 1 then def=def(0)
return,def

end
