;+
; Project     :	SOHO - CDS
;
; Name        :	WHICH_INST 
;
; Purpose     :	return which instrument DB (CDS or SUMER) is being used
;
; Explanation :	
;
; Use         :	INST=WHICH_INST()
;
; Inputs      :	None.
;
; Opt. Inputs :	None.
;
; Outputs     :	INST='C' or 'S' depending on which DB is active
;
; Opt. Outputs: None.
;
; Keywords    :	None.
;
; Calls       :	None.
;
; Common      :	None.
;
; Restrictions:	None.
;
; Side effects:	None.
;
; Category    :	Planning, Database.
;
; Prev. Hist. :	None.
;
; Written     :	Dominic Zarro (ARC),  1 May 1995
;-

function which_inst

zdbase=getenv('ZDBASE')
sdbase=getenv('ORA_SQLPLUS')

inst=''

if zdbase ne '' then inst='C'
if sdbase ne '' then inst='S'

if inst eq '' then begin
 if zdbase eq '' then begin
  if call_function('fix_zdbase',/cds) then inst='C'
 endif
endif

return,inst & end

