;+
; Project     : SOHO - CDS
;
; Name        : DEF_ANOMALY
;
; Purpose     : define anomaly structure
;
; Category    : operations
;
; Explanation :
;
; Syntax      : IDL> def_anomaly,anomaly
;
; Inputs      : None
;
; Opt. Inputs : None
;
; Outputs     : ANOMALY = anomaly data structure
;
; Opt. Outputs: None
;
; Keywords    : None
;
; Common      : None
;
; Restrictions: None
;
; Side effects: None
;
; History     : Version 1,  21-Dec-1995,  D.M. Zarro.  Written
;
; Contact     : DZARRO@SOLAR.STANFORD.EDU
;-

pro def_anomaly,anomaly        ;-- define anomaly base structure

b=strpad('',400)
anomaly={id:-1l,time:0d,system:'NONE',origin:'Anonymous',anomaly:b,action:b,$
         impact:b,resolution:b,open:1}

return & end


