;+
; Project     : VSO
;
; Name        : VSO_NAMES
;
; Purpose     : Return VSO source names
;
; Category    : utility system sockets
;
; Inputs      : None
;
; Outputs     : URLS = url's of search results
;
; Keywords    : DETECTOR = array of matching detector names
;               INSTRUMENT = array of matching instrument names
;               CATEGORY = array of matching data types
;
; History     : Written 21-Jan-2008, D.M. Zarro (ADNET)
;
; Contact     : DZARRO@SOLAR.STANFORD.EDU
;-

function vso_names,category=category,$
            instrument=instrument,detector=detector

detector=['','','euvi','cor1','cor2','']
instrument=['eit','trace','secchi','secchi','secchi','xrt']
category=['euv/images','euv/images','euv/images','coronal/images','coronal/images','sxr/images']
return,['SOHO/EIT','TRACE','STEREO/SECCHI-EUVI','STEREO/SECCHI-COR1','STEREO/SECCHI-COR2','HINODE/XRT']

end

